using CRMWebParts.Common.Security;
using CRMWebParts.Common.Security.Authorization;
using Newtonsoft.Json;
//using Newtonsoft.Json;
using System;
using System.Security.Cryptography;
using System.Text;

namespace CRMWebParts
{
	public class SecurityTokenGenerator
	{
		private string serializedObj = string.Empty;

		private string serializedObjTokenInTransit = string.Empty;

		public SecurityTokenGenerator()
		{
		}

		public string GenerateToken(string clientName, string clientIdentityKey, string userId, int minutesToLive, string encryptionSalt, string clientKey, string data)
		{
			Token token = new Token()
			{
				ApplicationName = clientName,
				ClientAppKey = clientIdentityKey,
				RequestDateTime = DateTime.Now.AddMinutes((double)minutesToLive),
				UserId = userId,
				Data = data
			};
			byte[] bytes = Encoding.ASCII.GetBytes(encryptionSalt);
			byte[] numArray = Encoding.ASCII.GetBytes(clientKey);
			byte[] bytes1 = (new Rfc2898DeriveBytes(numArray, bytes, 2)).GetBytes(32);
            string str = JsonConvert.SerializeObject(token);
            SimpleAES simpleAE = new SimpleAES();
			simpleAE.InitEncryptionKey(bytes1);
			string str1 = simpleAE.Encrypt(str);
            //string str2 = JsonConvert.SerializeObject(new WebpartsTokenInTransit()
            //{
            //    ApplicationName = clientName,
            //    Token = str1
            //});
            string str2 = JsonConvert.SerializeObject(new WebpartsTokenInTransit()
            {
                ApplicationName = clientName,
                Token = str1
            });
            return Convert.ToBase64String(Encoding.UTF8.GetBytes(str2));
		}
	}
}