﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using VEIS.Plugins;
using CRMWebParts.Common.Security;
using CRMWebParts.Common.Security.Authorization;
using System.Security.Cryptography;
using Newtonsoft.Json;

namespace FlagsSerialization
{
    class Program
    {
        static void Main(string[] args)
        {

            string req = "{\"NationalId\" : \"1008702098\"}";
            SecurityTokenGenerator securityTokenGenerator = new SecurityTokenGenerator();
            string clientName = "FTPCRM"; //  ServiceTicketClientName
            string clientIdentityKey = "88a8b9358aabb0fe38f";  //  ServiceTicketClientIdentityKey
            string userName = "PII                "; //  domain name of user
            int minutesToLive = 10;  //  ServiceTicketClientMinutesToLive
            string encryptionSalt = "D8CBB17EF5A90F44"; //  ServiceTicketClientEncryptionSalt
            string clientEncryptionKey = "3ED6B4F0546D233DF0A2F3EDFAF63DDE04C9B02FF4DC578A649559847F7D15F3";    //ServiceTicketClientEncryptionKey
            string tokenHelper = securityTokenGenerator.GenerateToken(clientName, clientIdentityKey, userName, minutesToLive,
                encryptionSalt, clientEncryptionKey, req);
            Console.WriteLine("tokenHelper: {0}", tokenHelper);

            string tokenNewtonsoft = GenerateToken(clientName, clientIdentityKey, userName, minutesToLive,
                encryptionSalt, clientEncryptionKey, req);
            Console.WriteLine("tokenNewtonsoft: {0}", tokenNewtonsoft);
            if(tokenNewtonsoft != tokenHelper)
            {
                Console.WriteLine("token mismatch");
            }
            Console.WriteLine("done...");
            Console.ReadKey();
        }

        private static string GenerateToken(string clientName, string clientIdentityKey, string userId, int minutesToLive, string encryptionSalt, string clientKey, string data)
        {
            Token token = new Token()
            {
                ApplicationName = clientName,
                ClientAppKey = clientIdentityKey,
                RequestDateTime = DateTime.Now.AddMinutes((double)minutesToLive),
                UserId = userId,
                Data = data
            };
            byte[] bytes = Encoding.ASCII.GetBytes(encryptionSalt);
            byte[] numArray = Encoding.ASCII.GetBytes(clientKey);
            byte[] bytes1 = (new Rfc2898DeriveBytes(numArray, bytes, 2)).GetBytes(32);
            string serializedToken = JsonConvert.SerializeObject(token);
            SimpleAES simpleAE = new SimpleAES();
            simpleAE.InitEncryptionKey(bytes1);
            string encryptedToken = simpleAE.Encrypt(serializedToken);
            string encodedTokenInTransit = JsonConvert.SerializeObject(new WebpartsTokenInTransit()
            {
                ApplicationName = clientName,
                Token = encryptedToken
            });
            return Convert.ToBase64String(Encoding.UTF8.GetBytes(encodedTokenInTransit));
        }
    }
}
