﻿using VEIS.Plugins.Messages;
using VEIS.Plugins.Models;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;


namespace VEIS.Plugins.RunTests
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                string str = DateTime.Now.ToString("MM-dd-yyyy");
                //MODEBUG wire up the veisConfiguration need to move this to settings
                Models.VeisConfiguration config = new Models.VeisConfiguration()
                {
                    CRMAuthInfo = new Models.CRMAuthTokenConfiguration()
                    {
                        ClientApplicationId = "58d50ca3-b921-4d9b-ac76-8965be2eb80b",
                        ClientSecret = "4RdVDdhq8cv/h2263Ojdy8fD3JI9OwHcr5hOkntAwTc=",
                        TenantId = "f7c49e36-971b-42c7-b244-a88eed6c0bf6",
                        ResourceId = "4a77476c-ceed-45db-ad7e-ac2bbbc4f72a"
                    },
                    SvcConfigInfo = new Models.VEISSvcLOBConfiguration()
                    {
                        ApimSubscriptionKey = "88784cf9396e41dab087c90a5da0c2c1",
                        //SvcLOBServiceUrl = "https://DNS.URL/veis",
                        SvcLOBServiceUrl = "https://DNS.URL"
                    },
                    VASTRefreshFacilityAPI = "/api/VASTListRefresh/1.0/json/ftpcrm"
                };

                PersonSearchRequest searchRequest = new PersonSearchRequest();
                //SetQueryString(config, localContext, (PersonSearchRequest)searchRequest, request.Query.criteria);
                searchRequest.MessageId = Guid.NewGuid().ToString();
                searchRequest.OrganizationName = "TEST";
                searchRequest.UserId = new Guid();
                searchRequest.Debug = false;
                searchRequest.LogSoap = false;
                searchRequest.LogTiming = false;


                //var searchResponse = Program.SendReceiveVeisRequest<PersonSearchResponse>(new Uri(veisConfiguration.SvcConfigInfo.SvcLOBServiceUrl), "SearchPerson", searchRequest, veisConfiguration);
               
                //VeisConfig config = RetrieveVeisConfig("patsr_vastlistrefreshapiurl", "patsr_mvisubscriptionkey");

                var vASTRefreshResponse = WebApiUtility.ReceiveVeisRequest<Messages.VASTRefreshResponse>(config, config.VASTRefreshFacilityAPI + "/" + "03-04-2019");
                Console.Write(vASTRefreshResponse.ErrorMessage);
                Console.Write(vASTRefreshResponse.Data[0].totalItems.ToString());

            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
            Console.ReadLine();
        }

        public static T SendReceiveVeisRequest<T>(Uri baseUri, string messageId, VeisRequest request, VeisConfiguration config)
        {
            try
            {
                if ((System.Net.ServicePointManager.SecurityProtocol & SecurityProtocolType.Tls12) == 0)
                {
                    System.Net.ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls | SecurityProtocolType.Tls11 | SecurityProtocolType.Tls12;
                }

                using (WebClient client = new WebClient())
                {
                    Uri uri;
                    if (config.SvcConfigInfo.SvcLOBServiceUrl.EndsWith("/"))
                    {
                        uri = new Uri(config.SvcConfigInfo.SvcLOBServiceUrl + messageId);
                    }
                    else
                    {
                        uri = new Uri(config.SvcConfigInfo.SvcLOBServiceUrl + "/" + messageId);
                    }
                    client.AddAuthHeader(config.CRMAuthInfo);
                    Console.WriteLine("Auth Header: " + client.Headers[HttpRequestHeader.Authorization]);
                    string reqBody = JsonHelper.Serialize(request);
                    client.Headers[HttpRequestHeader.ContentType] = "application/json";
                    client.Headers.Add("Ocp-Apim-Subscription-Key", config.SvcConfigInfo.ApimSubscriptionKey);
                    string response = client.UploadString(uri.AbsoluteUri, reqBody);
                    return JsonHelper.Deserialize<T>(response);
                }
            }

            catch (WebException exception)
            {
                string callResponse = string.Empty;
                if (exception.Response != null)
                {
                    using (StreamReader reader = new StreamReader(exception.Response.GetResponseStream()))
                    {
                        callResponse = reader.ReadToEnd();
                    }
                    exception.Response.Close();
                }
                if (exception.Status == WebExceptionStatus.Timeout)
                {
                    throw new Exception("The timeout elapsed while attempting to issue the request.", exception);
                }
                throw new Exception($"A Web exception occurred while attempting to issue the request. {exception.Message}: {callResponse}", exception);
            }
        }

    }
}
