﻿using Microsoft.Xrm.Sdk;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace VEIS.Plugins
{
    public abstract class BasePlugin : IPlugin
    {

        public class PluginContext : BasePluginContext
        {
            internal IPluginExecutionContext PluginExecutionContext { get; private set; }

            internal PluginContext(IServiceProvider serviceProvider) : base((IOrganizationServiceFactory)serviceProvider.GetService(typeof(IOrganizationServiceFactory)), (ITracingService)serviceProvider.GetService(typeof(ITracingService)), ((IPluginExecutionContext)serviceProvider.GetService(typeof(IPluginExecutionContext))).UserId)
            {
                this.PluginExecutionContext = (IPluginExecutionContext)serviceProvider.GetService(typeof(IPluginExecutionContext));

                OrganizationName = this.PluginExecutionContext.OrganizationName;
            }
        }

        public abstract void Execute(IServiceProvider serviceProvider);
    }
}
