using CRMWebParts.Common.Security;
using CRMWebParts.Common.Security.Authorization;
using System;
using System.Security.Cryptography;
using System.Text;
using Newtonsoft.Json;



namespace VEIS.Plugins
{
	public class SecurityTokenGenerator
	{
		private string serializedObj = string.Empty;

		private string serializedObjTokenInTransit = string.Empty;

		public SecurityTokenGenerator()
		{
		}

		public string GenerateToken(string clientName, string clientIdentityKey, string userId, int minutesToLive, string encryptionSalt, string clientKey, string data)
		{
			Token token = new Token()
			{
				ApplicationName = clientName,
				ClientAppKey = clientIdentityKey,
				RequestDateTime = DateTime.Now.AddMinutes((double)minutesToLive),
				UserId = userId,
				Data = data
			};
			byte[] bytes = Encoding.ASCII.GetBytes(encryptionSalt);
			byte[] numArray = Encoding.ASCII.GetBytes(clientKey);
			byte[] bytes1 = (new Rfc2898DeriveBytes(numArray, bytes, 2)).GetBytes(32);
			string serializedToken = JsonHelper.Serialize(token);
			SimpleAES simpleAE = new SimpleAES();
			simpleAE.InitEncryptionKey(bytes1);
			string encryptedToken = simpleAE.Encrypt(serializedToken);
			string encodedTokenInTransit = JsonHelper.Serialize(new WebpartsTokenInTransit()
			{
				ApplicationName = clientName,
				Token = encryptedToken
            });
			return Convert.ToBase64String(Encoding.UTF8.GetBytes(encodedTokenInTransit));
		}
	}
}