﻿
using System;
using System.Activities;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Query;
using Microsoft.Xrm.Sdk.Workflow;
using VEIS.Plugins.Models;
using VEIS.Plugins.Messages;

namespace VEIS.Plugins
{
    public class RefreshFacilitiesAction : BaseAction
    {
        //[Input("DAC URL")]
        //public InArgument<string> dacURLInput { get; set; }

        [Input("Facility Data Date")]
        [RequiredArgument]
        public InArgument<DateTime> FacilityDataDateInput { get; set; }

        [AttributeTarget("patsr_setting", "patsr_vastfaciltiyrefreshselectedendpoint")]
        [Input("API to use for facility data")]
        [RequiredArgument]
        public InArgument<OptionSetValue> FacilityEndpointToUse { get; set; }

        //[Input("VAST List GIS API Base URL")]
        //public InArgument<string> GISAPIBaseURLInput { get; set; }

        //[Input("VAST List GIS API URL Parameters")]
        //public InArgument<string> GISAPIURLParametersInput { get; set; }

        [Output("Refresh Completed Successfully")]
        public OutArgument<bool> RefreshCompletedSuccessfully { get; set; }

        [Output("Message")]
        public OutArgument<string> ResultMessage { get; set; }

        //[Input("VAST List API URL")]
        //public InArgument<string> VASTAPIURLInput { get; set; }

        [AttributeTarget("patsr_setting", "patsr_vastfacilitytosubfacilitymappingmethod")]
        [Input("VAST Facility to Sub Facility Mapping Method")]
        [RequiredArgument]
        public InArgument<OptionSetValue> VASTMappingMethodInput { get; set; }
        protected override void Execute(CodeActivityContext context)
        {
            //WebClient webClient;
            //string str;
            Exception exception;
            int i;
            object[] correlationId;
            ITracingService extension = null;
            
                Response.Set(context, "");
                // Use a 'using' statement to dispose of the service context properly
                // To use a specific early bound entity replace the 'Entity' below with the appropriate class type
                using (var localContext = new ActionContext(context))
                {

                try
                {

                    extension = context.GetExtension<ITracingService>();
                    IWorkflowContext workflowContext = context.GetExtension<IWorkflowContext>();
                    IOrganizationService organizationService = context.GetExtension<IOrganizationServiceFactory>().CreateOrganizationService(new Guid?(localContext.WorkflowExecutionContext.UserId));

                    OptionSetValue optionSetValue = this.FacilityEndpointToUse.Get(context);
                    FacilityEndpoint facilityEndpoint = (optionSetValue != null ? (FacilityEndpoint)Enum.ToObject(typeof(FacilityEndpoint), optionSetValue.Value) : FacilityEndpoint.VASTProxy);
                    OptionSetValue optionSetValue1 = this.VASTMappingMethodInput.Get(context);
                    ParentFacilityMappingMethod parentFacilityMappingMethod = (optionSetValue1 != null ? (ParentFacilityMappingMethod)Enum.ToObject(typeof(ParentFacilityMappingMethod), optionSetValue1.Value) : ParentFacilityMappingMethod.UseParentStationIDFieldFromVAST);
                    DateTime dateTime = this.FacilityDataDateInput.Get(context);
                    int month = dateTime.Month;
                    string str1 = month.ToString();
                    month = dateTime.Day;
                    string str2 = month.ToString();
                    month = dateTime.Year;
                    string str3 = string.Format("{0}-{1}-{2}", str1, str2, month.ToString());
                    VASTRefreshResponse vASTRefreshResponse = new VASTRefreshResponse();
                    if (facilityEndpoint != FacilityEndpoint.VASTProxy)
                    {
                        //to do throw not implemented exception

                        //string str4 = this.GISAPIBaseURLInput.Get(context);
                        //string str5 = this.GISAPIURLParametersInput.Get(context);
                        //if ((string.IsNullOrEmpty(str4) ? true : string.IsNullOrEmpty(str5)))
                        //{
                        //    throw new InvalidPluginExecutionException("You must provide a value for 'VAST List GIS API Base URL' and 'VAST List GIS API URL Parameters' in order to query facility data directly from the GIS endpoint.");
                        //}
                        //string str6 = string.Concat(str4, str3, str5);
                        //GISResponse gISResponse = new GISResponse();
                        //webClient = new WebClient();
                        //try
                        //{
                        //    try
                        //    {
                        //        extension.Trace("querying VAST GIS API", new object[0]);
                        //        str = webClient.DownloadString(str6);
                        //        gISResponse = (new JavaScriptSerializer()).Deserialize<GISResponse>(str);
                        //    }
                        //    catch (Exception exception1)
                        //    {
                        //        exception = exception1;
                        //        extension.Trace("error querying VAST GIS API", new object[0]);
                        //        throw new InvalidPluginExecutionException(string.Concat("error querying VAST GIS API: ", exception.Message));
                        //    }
                        //}
                        //finally
                        //{
                        //    if (webClient != null)
                        //    {
                        //        ((IDisposable)webClient).Dispose();
                        //    }
                        //}
                        //List<VASTStation> vASTStations = new List<VASTStation>();
                        //GISStation[] gISStationArray = gISResponse.features;
                        //for (i = 0; i < (int)gISStationArray.Length; i++)
                        //{
                        //    vASTStations.Add(new VASTStation(gISStationArray[i]));
                        //}
                        //DataMember[] dataMemberArray = new DataMember[1];
                        //DataMember dataMember = new DataMember()
                        //{
                        //    vistaList = vASTStations.ToArray()
                        //};
                        //dataMemberArray[0] = dataMember;
                        //vASTRefreshResponse.Data = dataMemberArray;
                    }
                    else
                    {
                        //string str7 = this.dacURLInput.Get(context);
                        //string str8 = this.VASTAPIURLInput.Get(context);
                        //if ((string.IsNullOrEmpty(str7) ? true : string.IsNullOrEmpty(str8)))
                        //{
                        //    throw new Exception("You must provide a value for 'DAC URL' and 'VAST List API URL' in order to query facility data from the VAST Proxy.");
                        //}
                        //string str9 = string.Concat(str7, str8, str3);

                        VeisConfig config = localContext.RetrieveVeisConfig("patsr_vastlistrefreshapiurl", "patsr_mvisubscriptionkey");

                        vASTRefreshResponse = WebApiUtility.ReceiveVeisRequest<VASTRefreshResponse>(config, config.VeisConfiguration.VASTRefreshFacilityAPI + "/" + str3);


                        //webClient = new WebClient();
                        //try
                        //{
                        //    try
                        //    {
                        //        extension.Trace("querying VAST Refresh API", new object[0]);
                        //        str = webClient.DownloadString(str9);
                        //        vASTRefreshResponse = (new JavaScriptSerializer()).Deserialize<VASTRefreshResponse>(str);
                        //    }
                        //    catch (Exception exception2)
                        //    {
                        //        exception = exception2;
                        //        extension.Trace("error querying VAST Refresh API", new object[0]);
                        //        throw new InvalidPluginExecutionException(string.Concat("Error querying VAST Refresh API: ", exception.Message));
                        //    }
                        //}
                        //finally
                        //{
                        //    if (webClient != null)
                        //    {
                        //        ((IDisposable)webClient).Dispose();
                        //    }
                        //}
                        if (vASTRefreshResponse.ErrorOccurred)
                        {
                            throw new InvalidPluginExecutionException((string.IsNullOrEmpty((string)vASTRefreshResponse.ErrorMessage) ? "Unspecified error." : (string)vASTRefreshResponse.ErrorMessage));
                        }
                    }
                    if ((int)vASTRefreshResponse.Data.Length != 1)
                    {
                        throw new InvalidPluginExecutionException("Unhandled response content: multiple Data[] members.");
                    }
                    DataMember data = vASTRefreshResponse.Data[0];
                    if ((int)data.vistaList.Length > 0)
                    {
                        VASTStation[] vASTStationArray = data.vistaList;
                        for (i = 0; i < (int)vASTStationArray.Length; i++)
                        {
                            vASTStationArray[i].MassageVASTStation(data.vistaList, parentFacilityMappingMethod);
                        }
                        extension.Trace("staring VISNs...", new object[0]);
                        QueryExpression queryExpression = new QueryExpression();
                        queryExpression.EntityName = "veo_visn";
                        queryExpression.ColumnSet = new ColumnSet(new string[] { "veo_name" });
                        queryExpression.Criteria.Conditions.Add(new ConditionExpression("statecode", 0, "Active"));
                        queryExpression.Orders.Add(new OrderExpression("modifiedon", OrderType.Ascending));
                        EntityCollection entityCollection = organizationService.RetrieveMultiple(queryExpression);
                        extension.Trace("got active veo_visn records", new object[0]);
                        Dictionary<string, Entity> strs = new Dictionary<string, Entity>();
                        vASTStationArray = data.vistaList;
                        for (i = 0; i < (int)vASTStationArray.Length; i++)
                        {
                            VASTStation vASTStation = vASTStationArray[i];
                            if (strs.FirstOrDefault<KeyValuePair<string, Entity>>((KeyValuePair<string, Entity> entry) => entry.Key == vASTStation.VisnID).Key == null)
                            {
                                extension.Trace(string.Concat("VISN from VAST: ", vASTStation.VisnID), new object[0]);
                                Entity entity = entityCollection.Entities.FirstOrDefault<Entity>((Entity v) => (!v.Contains("veo_name") ? false : (string)v.GetAttributeValue<string>("veo_name") == vASTStation.VisnID));
                                if (entity != null)
                                {
                                    strs.Add(vASTStation.VisnID, entity);
                                }
                                else
                                {
                                    extension.Trace(string.Concat("creating new veo_visn record: ", vASTStation.VisnID), new object[0]);
                                    Entity entity1 = new Entity("veo_visn");
                                    entity1.Attributes.Add("veo_name", vASTStation.VisnID);
                                    try
                                    {
                                        entity1.Id = organizationService.Create(entity1);
                                    }
                                    catch (Exception exception3)
                                    {
                                        exception = exception3;
                                        extension.Trace(string.Concat("error creating new veo_visn record: ", vASTStation.VisnID), new object[0]);
                                        throw new InvalidPluginExecutionException(string.Concat("error creating new veo_visn record: ", exception.Message));
                                    }
                                    strs.Add(vASTStation.VisnID, entity1);
                                }
                            }
                        }
                        extension.Trace("filled VISNDictionary.", new object[0]);
                        extension.Trace("starting top-level facilities (patsr_facility entity)", new object[0]);
                        QueryExpression queryExpression1 = new QueryExpression();
                        queryExpression1.EntityName = VEISVASTRefreshFacility.CrmEntityName;
                        queryExpression1.ColumnSet = VEISVASTRefreshFacility.CrmColumns;
                        queryExpression1.Criteria.Conditions.Add(new ConditionExpression("statecode", 0, "Active"));
                        queryExpression1.Orders.Add(new OrderExpression(VEISVASTRefreshFacility.StationNumberFieldName, 0));
                        queryExpression1.Orders.Add(new OrderExpression("modifiedon", OrderType.Ascending));
                        EntityCollection entityCollection1 = organizationService.RetrieveMultiple(queryExpression1);
                        extension.Trace("got active patsr_facility records.", new object[0]);
                        Dictionary<VASTStation, Entity> vASTStations1 = new Dictionary<VASTStation, Entity>();
                        vASTStationArray = data.vistaList;
                        for (i = 0; i < (int)vASTStationArray.Length; i++)
                        {
                            VASTStation vASTStation1 = vASTStationArray[i];
                            if (vASTStation1.IsATopLevelStation)
                            {
                                VEISVASTRefreshFacility facility = new VEISVASTRefreshFacility(vASTStation1);
                                extension.Trace(string.Concat("top-level patsr_facility from VAST: ", facility.CRMDisplayname), new object[0]);
                                Entity entity2 = entityCollection1.Entities.FirstOrDefault<Entity>((Entity f) => (!f.Contains(VEISVASTRefreshFacility.StationIDFieldName) ? false : (string)f.GetAttributeValue<string>(VEISVASTRefreshFacility.StationIDFieldName) == vASTStation1.StationID));
                                if (entity2 == null)
                                {
                                    entity2 = entityCollection1.Entities.FirstOrDefault<Entity>((Entity f) => (!f.Contains(VEISVASTRefreshFacility.StationNumberFieldName) ? false : (string)f.GetAttributeValue<string>(VEISVASTRefreshFacility.StationNumberFieldName) == vASTStation1.StationNumber));
                                }
                                if (entity2 == null)
                                {
                                    extension.Trace(string.Concat("creating new patsr_facility record: ", facility.CRMDisplayname), new object[0]);
                                    Entity cRMRecord = facility.MapToCRMRecord(Guid.Empty, strs);
                                    try
                                    {
                                        cRMRecord.Id = organizationService.Create(cRMRecord);
                                        vASTStations1.Add(vASTStation1, cRMRecord);
                                    }
                                    catch (Exception exception4)
                                    {
                                        exception = exception4;
                                        extension.Trace("error creating new patsr_facility record.", new object[0]);
                                        throw new InvalidPluginExecutionException(string.Concat("error creating new patsr_facility record: ", exception.Message));
                                    }
                                }
                                else if (facility.MatchesCRMRecord(entity2))
                                {
                                    vASTStations1.Add(vASTStation1, entity2);
                                }
                                else
                                {
                                    extension.Trace(string.Concat("updating patsr_facility record: ", facility.CRMDisplayname), new object[0]);
                                    Entity cRMRecord1 = facility.MapToCRMRecord(entity2.Id, strs);
                                    try
                                    {
                                        organizationService.Update(cRMRecord1);
                                        vASTStations1.Add(vASTStation1, cRMRecord1);
                                    }
                                    catch (Exception exception5)
                                    {
                                        exception = exception5;
                                        extension.Trace("error updating facility record.", new object[0]);
                                        throw new InvalidPluginExecutionException(string.Concat("error updating patsr_facility record: ", exception.Message));
                                    }
                                }
                            }
                        }
                        extension.Trace("finished creating/updating patsr_facility records from vastResponse.Data[0].vistaList.", new object[0]);
                        extension.Trace("filled ParentFacilityDictionary.", new object[0]);
                        extension.Trace("starting full facilities list (patsr_subfacility entity)...", new object[0]);
                        QueryExpression queryExpression2 = new QueryExpression();
                        queryExpression2.EntityName = VEISVASTRefreshSubFacility.CrmEntityName;
                        queryExpression2.ColumnSet = VEISVASTRefreshSubFacility.CrmColumns;
                        queryExpression2.Criteria.Conditions.Add(new ConditionExpression("statecode", 0, "Active"));
                        queryExpression2.Orders.Add(new OrderExpression(VEISVASTRefreshSubFacility.StationNumberFieldName, 0));
                        queryExpression2.Orders.Add(new OrderExpression("modifiedon", OrderType.Ascending));
                        EntityCollection entityCollection2 = organizationService.RetrieveMultiple(queryExpression2);
                        extension.Trace("got active patsr_subfacility records.", new object[0]);
                        vASTStationArray = data.vistaList;
                        for (i = 0; i < (int)vASTStationArray.Length; i++)
                        {
                            VASTStation vASTStation2 = vASTStationArray[i];
                            VEISVASTRefreshSubFacility subFacility = new VEISVASTRefreshSubFacility(vASTStation2, vASTStations1);
                            extension.Trace(string.Concat("patsr_subfacility from VAST: ", subFacility.CRMDisplayname), new object[0]);
                            Entity entity3 = entityCollection2.Entities.FirstOrDefault<Entity>((Entity sf) => (!sf.Contains(VEISVASTRefreshSubFacility.StationIDFieldName) ? false : (string)sf.GetAttributeValue<string>(VEISVASTRefreshSubFacility.StationIDFieldName) == vASTStation2.StationID));
                            if (entity3 == null)
                            {
                                entity3 = entityCollection2.Entities.FirstOrDefault<Entity>((Entity sf) => (!sf.Contains(VEISVASTRefreshSubFacility.StationNumberFieldName) ? false : (string)sf.GetAttributeValue<string>(VEISVASTRefreshSubFacility.StationNumberFieldName) == vASTStation2.StationNumber));
                            }
                            if (entity3 == null)
                            {
                                extension.Trace(string.Concat("creating new patsr_subfacility record: ", subFacility.CRMDisplayname), new object[0]);
                                Entity cRMRecord2 = subFacility.MapToCRMRecord(Guid.Empty, vASTStations1);
                                try
                                {
                                    cRMRecord2.Id = organizationService.Create(cRMRecord2);
                                }
                                catch (Exception exception6)
                                {
                                    exception = exception6;
                                    extension.Trace("error creating new patsr_subfacility record.", new object[0]);
                                    throw new InvalidPluginExecutionException(string.Concat("error creating new patsr_subfacility record: ", exception.Message));
                                }
                            }
                            else if (!subFacility.MatchesCRMRecord(entity3))
                            {
                                extension.Trace(string.Concat("updating patsr_subfacility record: ", subFacility.CRMDisplayname), new object[0]);
                                try
                                {
                                    organizationService.Update(subFacility.MapToCRMRecord(entity3.Id, vASTStations1));
                                }
                                catch (Exception exception7)
                                {
                                    exception = exception7;
                                    extension.Trace("error updating patsr_subfacility record.", new object[0]);
                                    throw new InvalidPluginExecutionException(string.Concat("error updating patsr_subfacility record: ", exception.Message));
                                }
                            }
                        }
                        this.RefreshCompletedSuccessfully.Set(context, true);
                        this.ResultMessage.Set(context, "finished creating/updating patsr_subfacility records.");
                        extension.Trace("finished creating/updating patsr_subfacility records.", new object[0]);
                    }

                }
                catch (Exception ex)
                {

                    this.RefreshCompletedSuccessfully.Set(context, false);
                    correlationId = new object[] { ex.ToString() };
                    extension.Trace("Exception: {0}", correlationId);
                    this.ResultMessage.Set(context, ex.ToString());
                    throw;
                }
                correlationId = new object[] { context.GetExtension<IWorkflowContext>().CorrelationId };
                extension.Trace("Exiting RefreshFacilityListFromVAST.Execute(), Correlation Id: {0}", correlationId);

                #region "Commented"
                /*
                ContactFindCreateRequest request = JsonHelper.Deserialize<ContactFindCreateRequest>(this.Request.Get<string>(context));
                if (request.Person == null)
                {
                    throw new ArgumentNullException("Person Not Specified in Request");
                }

                if (!string.IsNullOrEmpty(request.Person.VetNumber))
                {
                    QueryByAttribute query = new QueryByAttribute
                    {
                        //change these fields as required for your implementation
                        ColumnSet = new ColumnSet("contactid", "governmentid", "veo_sensitiveveteran"),
                        EntityName = "contact"
                    };
                    query.AddAttributeValue("governmentid", request.Person.VetNumber);

                    EntityCollection results = localContext.OrganizationService.RetrieveMultiple(query);
                    if (results.Entities.Count == 0)
                    {
                        Entity entity = new Entity("contact");
                        entity["firstname"] = request.Person.FirstName;
                        entity["lastname"] = request.Person.LastName;
                        entity["governmentid"] = request.Person.VetNumber;
                        int sensitivityLevel;
                        entity["veo_sensitiveveteran"] = (!string.IsNullOrEmpty(request.Person.VeteranSensitivityLevel) && Int32.TryParse(request.Person.VeteranSensitivityLevel, out sensitivityLevel) && sensitivityLevel > 0);

                        entity.Id = localContext.OrganizationService.Create(entity);
                        entity = localContext.OrganizationService.Retrieve("contact", entity.Id, new ColumnSet("contactid", "fullname", "veo_sensitiveveteran"));

                        ContactFindCreateResponse response = new ContactFindCreateResponse()
                        {
                            Id = entity.Id,
                            IsSensitive = (entity.Contains("veo_sensitiveveteran")) ? entity.GetAttributeValue<bool>("veo_sensitiveveteran") : false,
                            FullName = (entity.Contains("fullname")) ? entity.GetAttributeValue<string>("fullname") : string.Empty,
                        };
                        this.Response.Set(localContext.ActivityContext, JsonHelper.Serialize(response));
                    }
                    else if (results.Entities.Count == 1)
                    {
                        ContactFindCreateResponse response = new ContactFindCreateResponse()
                        {
                            Id = results.Entities[0].Id,
                            IsSensitive = (results.Entities[0].Contains("veo_sensitiveveteran")) ? results.Entities[0].GetAttributeValue<bool>("veo_sensitiveveteran") : false,
                            FullName = (results.Entities[0].Contains("fullname")) ? results.Entities[0].GetAttributeValue<string>("fullname") : string.Empty
                        };
                        this.Response.Set(localContext.ActivityContext, JsonHelper.Serialize(response));
                    }
                    else
                    {
                        throw new Exception("Nultiple contacts found for the same SSN");
                    }
                }
                else
                {
                    throw new ArgumentNullException("SSN");
                }
                */
                #endregion
            }
           
        }

    }
}
