﻿using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Query;
using VEIS.Plugins.Messages;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace VEIS.Plugins
{
    public class RemoveAttachmentPlugin : BaseAttachmentPlugin
    {
        public RemoveAttachmentPlugin(string unsecureConfig, string secureConfig) : base(unsecureConfig, secureConfig)
        {
        }

        public override void Execute(PluginContext localContext, VeisConfig config, string siteUrl, string listName, string userName, string password)
        {
            SharePointRemoveLOBReq request = new SharePointRemoveLOBReq()
            {
                SharepointSite = siteUrl,
                SharepointList = listName,
                SharepointUsername = userName,
                SharepointPassword = password,
                SharepointID = localContext.PluginExecutionContext.InputParameters["SharepointID"].ToString()
            };

            SharePointRemoveLOBRes response = WebApiUtility.SendReceiveVeisRequest<SharePointRemoveLOBRes>(config, "Remove", request);
        }
    }
}
