﻿using Microsoft.Xrm.Sdk;
using VEIS.Plugins.Messages;
using VEIS.Plugins.Models;
using System;
using System.Activities;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace VEIS.Plugins
{
    public class TestAction : BaseAction
    {
        protected override void Execute(CodeActivityContext context)
        {
            try
            {
                //MODEBUG wire up the veisConfiguration need to move this to settings
                Models.VeisConfiguration veisConfiguration = new Models.VeisConfiguration()
                {
                    CRMAuthInfo = new Models.CRMAuthTokenConfiguration()
                    {
                        ClientApplicationId = "58d50ca3-b921-4d9b-ac76-8965be2eb80b",
                        ClientSecret = "4RdVDdhq8cv/h2263Ojdy8fD3JI9OwHcr5hOkntAwTc=",
                        TenantId = "f7c49e36-971b-42c7-b244-a88eed6c0bf6",
                        ResourceId = "4a77476c-ceed-45db-ad7e-ac2bbbc4f72a"
                    },
                    SvcConfigInfo = new Models.VEISSvcLOBConfiguration()
                    {
                        ApimSubscriptionKey = "45f51ebbff3541ad8f3faf584499498f",
                        SvcLOBServiceUrl = "https://DNS.URL/veis/EC/MVIService/api/",
                    }
                };

                PersonSearchRequest searchRequest = new PersonSearchRequest();
                //SetQueryString(config, localContext, (PersonSearchRequest)searchRequest, request.Query.criteria);
                searchRequest.MessageId = Guid.NewGuid().ToString();
                searchRequest.OrganizationName = "TEST";
                searchRequest.UserId = new Guid();
                searchRequest.Debug = false;
                searchRequest.LogSoap = false;
                searchRequest.LogTiming = false;


                var searchResponse = SendReceiveVeisRequest<PersonSearchResponse>(new Uri(veisConfiguration.SvcConfigInfo.SvcLOBServiceUrl), "SearchPerson", searchRequest, veisConfiguration);
            }
            catch (Exception ex)
            {
                throw new InvalidPluginExecutionException(WebApiUtility.BuildExceptionMessage(ex));
            }
        }

        public static T SendReceiveVeisRequest<T>(Uri baseUri, string messageId, VeisRequest request, VeisConfiguration config)
        {
            try
            {
                if ((System.Net.ServicePointManager.SecurityProtocol & SecurityProtocolType.Tls12) == 0)
                {
                    System.Net.ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls | SecurityProtocolType.Tls11 | SecurityProtocolType.Tls12;
                }

                using (WebClient client = new WebClient())
                {
                    Uri uri;
                    if (config.SvcConfigInfo.SvcLOBServiceUrl.EndsWith("/"))
                    {
                        uri = new Uri(config.SvcConfigInfo.SvcLOBServiceUrl + messageId);
                    }
                    else
                    {
                        uri = new Uri(config.SvcConfigInfo.SvcLOBServiceUrl + "/" + messageId);
                    }
                    client.AddAuthHeader(config.CRMAuthInfo);
                    Console.WriteLine("Auth Header: " + client.Headers[HttpRequestHeader.Authorization]);
                    string reqBody = JsonHelper.Serialize(request);
                    client.Headers[HttpRequestHeader.ContentType] = "application/json";
                    client.Headers.Add("Ocp-Apim-Subscription-Key", config.SvcConfigInfo.ApimSubscriptionKey);
                    string response = client.UploadString(uri.AbsoluteUri, reqBody);
                    return JsonHelper.Deserialize<T>(response);
                }
            }

            catch (WebException exception)
            {
                string callResponse = string.Empty;
                if (exception.Response != null)
                {
                    using (StreamReader reader = new StreamReader(exception.Response.GetResponseStream()))
                    {
                        callResponse = reader.ReadToEnd();
                    }
                    exception.Response.Close();
                }
                if (exception.Status == WebExceptionStatus.Timeout)
                {
                    throw new Exception("The timeout elapsed while attempting to issue the request.", exception);
                }
                throw new Exception($"A Web exception occurred while attempting to issue the request. {exception.Message}: {callResponse}", exception);
            }
        }

    }
}
