﻿using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Query;
using MVI_Search.Plugins.Messages;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace MVI_Search.Plugins
{
    public class UploadAttachmentAction : BaseAttachmentAction
    {
        public override void Execute(ActionContext localContext, VeisConfig config, string siteUrl, string listName, string userName, string password)
        {
            SharePointUploadLOBReq request = new SharePointUploadLOBReq()
            {
                SharepointSite = siteUrl,
                SharepointList = listName,
                SharepointUsername = userName,
                SharepointPassword = password,
                FileBody = (string)localContext.WorkflowExecutionContext.InputParameters["FileBody"],
                FileName = (string)localContext.WorkflowExecutionContext.InputParameters["FileName"],
                Title = (string)localContext.WorkflowExecutionContext.InputParameters["Title"]
            };

            SharePointUploadLOBRes response = WebApiUtility.SendReceiveVeisRequest<SharePointUploadLOBRes>(config, "Upload", request);
        }
    }
}
