﻿using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Query;
using VEIS.Plugins.Messages;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace VEIS.Plugins
{
    public class UploadAttachmentPlugin : BaseAttachmentPlugin
    {
        public UploadAttachmentPlugin(string unsecureConfig, string secureConfig) : base(unsecureConfig, secureConfig)
        {
        }

        public override void Execute(PluginContext localContext, VeisConfig config, string siteUrl, string listName, string userName, string password)
        {
            SharePointUploadLOBReq request = new SharePointUploadLOBReq()
            {
                SharepointSite = siteUrl,
                SharepointList = listName,
                SharepointUsername = userName,
                SharepointPassword = password,
                FileBody = (string)localContext.PluginExecutionContext.InputParameters["FileBody"],
                FileName = (string)localContext.PluginExecutionContext.InputParameters["FileName"],
                Title = (string)localContext.PluginExecutionContext.InputParameters["Title"]
            };

            SharePointUploadLOBRes response = WebApiUtility.SendReceiveVeisRequest<SharePointUploadLOBRes>(config, "Upload", request);
        }
    }
}
