﻿using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Query;
using VEIS.Plugins.Messages;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace VEIS.Plugins
{
    public class ViewAttachmentPlugin : BaseAttachmentPlugin
    {
        public ViewAttachmentPlugin(string unsecureConfig, string secureConfig) : base(unsecureConfig, secureConfig)
        {
        }

        public override void Execute(PluginContext localContext, VeisConfig config, string siteUrl, string listName, string userName, string password)
        {
            SharePointViewLOBReq request = new SharePointViewLOBReq()
            {
                SharepointSite = siteUrl,
                SharepointList = listName,
                SharepointUsername = userName,
                SharepointPassword = password,
                SharepointID = localContext.PluginExecutionContext.InputParameters["SharepointID"].ToString()
            };

            SharePointViewLOBRes response = WebApiUtility.SendReceiveVeisRequest<SharePointViewLOBRes>(config, "View", request);
            localContext.PluginExecutionContext.OutputParameters["FileStream"] = response.FileStream;
        }
    }
}
