﻿using System;
using System.ComponentModel.Composition;
using VRM.Integration.Servicebus.Core;
using Iris.VEFT.Messages;
using Iris.VEFT.Processors;


namespace Iris.VEFT.MessageHandler
{
    [Export(typeof(IMessageHandler))]
    [ExportMetadata("MessageType", MessageRegistry.IrisCreateInteractionRequest)]
    class IrisCreateInteractionMessageHandler : RequestResponseHandler
    {
        public override IMessageBase HandleRequestResponse(object message)
        {
            try
            {
                LogMessageReceipt(message);
                var processor = new IrisCreateInteractionProcessor();
                return processor.Execute((IrisCreateInteractionRequest)message);
            }
            catch (Exception ex)
            {
                Logger.Instance.Error(ex);
                var exMessage = "";
                if (ex.Message != null)
                    exMessage = ex.Message;
                else
                    exMessage = "An exception occurred while trying to instantiate the processor in VIMT.";
                IrisCreateInteractionResponse response = new IrisCreateInteractionResponse()
                {
                    ExceptionOccurred = true,
                    ExceptionMessage = exMessage
                };
                return response;
                //throw new Exception(string.Format("Medallia.VEFT.MedalliaUpdateStatusStubRequest Error: {0}", ex.Message), ex);
            }
        }
    }
}
