﻿using System;
using System.Configuration;
using System.Reflection;
using VRM.Integration.Servicebus.Core;

namespace Medallia.VEFT.WebApi.Configuration
{
    public class MedalliaSecurityConfiguration : ObjectConfigHandler
    {
        public static MedalliaSecurityConfiguration Current
        {
            get
            {
                var section = (MedalliaSecurityConfiguration)ConfigurationManager.GetSection("MedalliaSecurityConfiguration");

                if (section == null)
                    throw new Exception("The MedalliaSecurityConfiguration Security configuration section has not been specified. Please add the configuration to the web.config");

                return section;
            }
        }

        public string Bucket_Name { get; set; }
        public string FilePath { get; set; }
        public string Service_URI { get; set; }
        public string S3_Key { get; set; }
        public string S3_Secret { get; set; }
        public string FileMatch { get; set; }
    }
}
