﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using PatsrSharepointLOB.Messages;

namespace PatsrSharepointLOB.Controllers
{
    public class SharePointController : ApiController
    {
        // GET api/<controller>
        public IEnumerable<string> Get()
        {
            return new string[] { "value1", "value2" };
        }

        // View api/<controller>/5
        [HttpPost()]
        [Route("api/SharePoint/View")]
        public SharePointViewLOBRes View([FromBody]SharePointViewLOBReq value)
        {
            SharePointViewSolnLOBProcessor processor = new SharePointViewSolnLOBProcessor();
            SharePointViewLOBRes response = (SharePointViewLOBRes)processor.Execute<SharePointViewLOBRes>(value);
            return response;
        }

        [HttpPost()]
        [Route("api/SharePoint/Upload")]
        // POST api/<controller>
        public SharePointUploadLOBRes Upload([FromBody]SharePointUploadLOBReq value)
        {
            SharePointUploadSolnLOBProcessor processor = new SharePointUploadSolnLOBProcessor();
            SharePointUploadLOBRes response = (SharePointUploadLOBRes)processor.Execute<SharePointUploadLOBRes>(value);
            return response;
        }

        //// PUT api/<controller>/5
        //public void Put(int id, [FromBody]string value)
        //{
        //}

        [HttpPost()]
        [Route("api/SharePoint/Remove")]
        // DELETE api/<controller>/5
        public SharePointRemoveLOBRes Remove([FromBody]SharePointRemoveLOBReq value)
        {
            SharePointRemoveSolnLOBProcessor processor = new SharePointRemoveSolnLOBProcessor();
            SharePointRemoveLOBRes response = (SharePointRemoveLOBRes)processor.Execute<SharePointRemoveLOBRes>(value);
            return response;
        }
    }
}