﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Web;
using System.Diagnostics;
using VIMT.SchoolSolutionService.Messages;
using PatsrSharepointLOB.Messages;
using VRMRest.WebApi;
using PatsrSharepointLOB.Configuration;
using VEIS.Core.Processor;
using VEIS.Core.Wcf;
using VEIS.Core.Messages;
using Microsoft.SharePoint.Client;
using System.Net;
using System.IO;
using System.Text;

namespace PatsrSharepointLOB
{
    public class SharePointUploadSolnLOBProcessor : EcProcessorBase
    {
        /// <summary>
        /// </summary>
        /// <param name=none></param>
        /// <returns>none</returns>
        public override VEISEcResponseBase Process(VEISEcRequestBase req)
        {
            ////RICH: Update: Declare Implementation request type var for method wide access, 
            //// but only cast base to implementation within the try so it is caught in case something 
            //// goes wrong with casting - but can still return the base response info            
            SharePointUploadLOBRes response = new SharePointUploadLOBRes();// null;
            SharePointUploadLOBReq request = null;
            //VIMTSchoolSolutionResponse getSchoolSolutionResponse = new VIMTSchoolSolutionResponse();

            Stopwatch serviceTimer = new Stopwatch();
            try
            {
                ////RICH: UPDATE: Change Progress String to be a Trace Function (which lives in ECBase) so we can do as we please with it - for now just appending to a stringbuilder
                Trace("Top of Processor");
                request = (SharePointUploadLOBReq)req;
                #region do legacy webservice calls

                try
                {
                    ////RICH: Update: Remove - now part of base class
                    //SoapLog.Current.Active = true;
                    ////RICH: ENDUPDATE
                    // Top of InputObjects
                    //var getSchoolSolutionRequestMessage = new VIMTSchoolSolutionRequest();
                    //getSchoolSolutionRequestMessage.InputValue = request.InputValue;
                    //getSchoolSolutionRequestMessage.LegacyServiceHeaderInfo = new HeaderInfo();
                    //getSchoolSolutionRequestMessage.LegacyServiceHeaderInfo.ApplicationName = request.LegacyServiceHeaderInfo.ApplicationName;
                    //getSchoolSolutionRequestMessage.LegacyServiceHeaderInfo.ClientMachine = request.LegacyServiceHeaderInfo.ClientMachine;
                    //getSchoolSolutionRequestMessage.LegacyServiceHeaderInfo.LoginName = request.LegacyServiceHeaderInfo.LoginName;
                    //getSchoolSolutionRequestMessage.LegacyServiceHeaderInfo.StationNumber = request.LegacyServiceHeaderInfo.StationNumber;
                    //getSchoolSolutionRequestMessage.OrganizationName = request.OrganizationName;
                    //getSchoolSolutionRequestMessage.MessageId = request.MessageId;
                    //var settings = VEISConfiguration.ReadConfigSettings();
                    //var operationname = "/api/SchoolSolution";
                    //string uri = settings["ECUri"] + operationname;
                    //getSchoolSolutionResponse = WebApiUtility.SendReceive<VIMTSchoolSolutionResponse>
                    //                                (new Uri(uri, UriKind.Absolute),
                    //                                "VIMTSchoolSolutionRequest",
                    //                                getSchoolSolutionRequestMessage,
                    //                                null);
                
                    try
                    {
                        string str1 = request.SharepointSite;
                        string str2 = request.SharepointList;
                        string [] strArrays = new string[] { str1, "/", str2, "/", HttpUtility.UrlEncode(request.FileName, Encoding.UTF8) };
                        string str3 = string.Concat(strArrays);
                        string item1 = request.Title;
                        NetworkCredential networkCredential = new NetworkCredential();
                        networkCredential.UserName = request.SharepointUsername;
                        networkCredential.Password = request.SharepointPassword;
                        byte[] numArray = Convert.FromBase64String(request.FileBody);

                        ClientContext clientContext = new ClientContext(str1);

                        try
                        {
                            SharepointApiUtility.SetupRequestAuthentication(clientContext, networkCredential);                            
                            Trace($"Getting Sharepoint Documents List...", LogLevel.Info);
                            List byTitle = clientContext.Web.Lists.GetByTitle(str2);                            
                            Trace($"Creating FileCreationInformation class...", LogLevel.Info);
                            FileCreationInformation fileCreationInformation = new FileCreationInformation()
                            {
                                ContentStream = new MemoryStream(numArray),
                                Overwrite = true,
                                Url = str3
                            };
                            Microsoft.SharePoint.Client.File file = byTitle.RootFolder.Files.Add(fileCreationInformation);
                            Trace($"Successfully uploaded document to sharepoint", LogLevel.Info);
                            ListItem listItemAllFields = file.ListItemAllFields;
                            listItemAllFields["Title"] = item1;
                            listItemAllFields.Update();
                            Trace($"Updated Title of document", LogLevel.Info);
                            clientContext.Load<ListItem>(listItemAllFields, new Expression<Func<ListItem, object>>[0]);
                            clientContext.ExecuteQuery();
                            Guid guid = (Guid)listItemAllFields["UniqueId"];
                            Trace($"Got SharepointID: " + guid.ToString(), LogLevel.Info);
                            response.SharepointID = guid.ToString();
                            response.FilePath = str3;
                            
                        }
                        finally
                        {
                            if (clientContext != null)
                            {
                                ((IDisposable)clientContext).Dispose();
                            }
                        }
                    }
                    catch (Exception exception1)
                    {
                        Exception exception = exception1;
                        //TODO: service.Trace(string.Concat("Exception on File Upload: ", exception.Message), new object[0]);
                        //TODO: pluginExecutionContext.OutputParameters["SharepointID"] = "0";
                        //TODO: pluginExecutionContext.OutputParameters["FilePath"] = "ERROR";
                        string str4 = string.Concat("Exception on File Upload: ", exception.Message);
                        //TODO: throw new InvalidPluginExecutionException(string.Format("An error has occurred in the UploadAttachment plugin: {0}", str4));
                    }
                

                    ////RICH: Working on the next 10 lines to capture request/timers
                serviceTimer.Start();
                    serviceTimer.Stop();
                    Trace("After Service Call");
                    /*Work with Pushkar on these - the new ServiceBus Core should expose these 2 new fields
                    //response.SerializedSOAPRequest = SoapLog.Current.Request;
                    //response.SerializedSOAPResonse = SoapLog.Current.Response;*/
                    ////RICH: ENDUPDATES

                    ////RICH: UPDATE - Use Helper Function For Readability and remove deprecated stuff like LogHelper and move to finally
                    //thisTimer.Stop();
                    //LogHelper.LogInfo(request.OrganizationName, request.LogSoap, request.UserId, request.RelatedParentId, request.RelatedParentEntityName, request.RelatedParentFieldName, method, SoapLog.Current.Log, thisTimer.ElapsedMilliseconds);
                    //SoapLog.Current.Active = false;
                    //SoapLog.Current.ClearLog();
                    //LogHelper.LogTiming(request.OrganizationName, request.LogTiming, request.UserId, request.RelatedParentId, request.RelatedParentEntityName, request.RelatedParentFieldName, method, webService,thisTimer.ElapsedMilliseconds);
                    ////RICH: UPDATE END REMOVE ITEMS
                }
                catch (Exception ex)
                {
                    serviceTimer.Stop();
                ////RICH: UPDATE - Use Helper Function For Readability and move to finally to ensure this is always run
                //thisTimer.Stop();
                //LogHelper.LogInfo(request.OrganizationName, request.LogSoap, request.UserId, request.RelatedParentId, request.RelatedParentEntityName, request.RelatedParentFieldName, method, SoapLog.Current.Log, thisTimer.ElapsedMilliseconds);
                //SoapLog.Current.Active = false;
                //SoapLog.Current.ClearLog();
                //LogHelper.LogTiming(request.OrganizationName, request.LogTiming, request.UserId, request.RelatedParentId, request.RelatedParentEntityName, request.RelatedParentFieldName, method, webService,thisTimer.ElapsedMilliseconds);
                ////RICH: UPDATE END REMOVE ITEMS
                if (response == null) response = new SharePointUploadLOBRes();// SchoolLOBRes();
                    var messageTest = ex.Message.ToLower();

                    if (messageTest.Contains("no records"))
                    {
                        ////RICH: Question: why does this just return a empty but new object?  dont we want to populate response exception = true and response message = ex.message?
                        return response;
                    }
                    ////RICH: UPDATE - Is it necessary to check for these and not Trace/LogHelper these specific errors?  if not, just call return error for all of these exception conditions for simplicity
                    if (!messageTest.Contains("shareexception") && !messageTest.Contains("access violation") && !messageTest.Contains("sensitive"))
                    {
                        Trace(ex.Message, LogLevel.Error);
                    }
                    return ReturnFailure(response, messageTest, SoapLog.Current);
                    //if (messageTest.Contains("shareexception"))
                    //{
                    //    response.ExceptionOccured = true;
                    //    response.ExceptionMessage = messageTest;
                    //    return response;
                    //}
                    //if (messageTest.Contains("access violation"))
                    //{
                    //    response.ExceptionOccured = true;
                    //    response.ExceptionMessage = messageTest;
                    //    return response;
                    //}
                    //if (messageTest.Contains("sensitive"))
                    //{
                    //    response.ExceptionOccured = true;
                    //    response.ExceptionMessage = messageTest;
                    //    return response;
                    //}
                    //LogHelper.LogError(request.OrganizationName, request.UserId, "getMediSpanPrice Processor", ex);
                    //response.ExceptionOccured = true;
                    //response.ExceptionMessage = messageTest;
                    //return response;
                    ////RICH: UPDATE END REMOVE ITEMS
                }

                #endregion

                //var config = new MockSvcWebServiceConfiguration(req.OrganizationName);
                #region do legacy webservice calls old
                string method = "GetDataProcessor", webService = "SchoolSolution";


                Trace("Before Mapping");
                //////try
                //////{
                //////    //getSchoolSolutionResponse Mapping 
                //////    #region  getSchoolSolutionResponse Mapping         
                //////    response = new SharePointUploadLOBRes();
                //////    if (response != null)
                //////    {
                //////        //response.BoolValue = getSchoolSolutionResponse.BoolValue;
                //////        response.StringValue = getSchoolSolutionResponse.StringValue;
                //////        response.StringValue2 = getSchoolSolutionResponse.StringValue2;
                //////        //response.StringValue3 = getSchoolSolutionResponse.StringValue3;
                //////        //response.StringValue4 = getSchoolSolutionResponse.StringValue4;
                //////        //response.StringValue5 = getSchoolSolutionResponse.StringValue5;
                //////        Trace("After getSchoolSolutionResponse Mapping");
                //////    }
                //////    #endregion
                //////}
                //////catch (Exception ex)
                //////{
                //////    ////RICH: UPDATE - Use Helper Functions For Readability and Remove this
                //////    return ReturnFailure(response, ex.Message, SoapLog.Current);
                //////    //if (response == null) response = new VIMTgMSPgetMediSpanPriceResponse();
                //////    //response.ExceptionOccured = true;
                //////    //response.ExceptionMessage = ex.Message;
                //////    //return response;
                //////    ////RICH: END UPDATE
                //////}
                #endregion

                return response;
            }
            catch (Exception ex)
            {
                ////RICH: UPDATE - Use Helper Function For Readability and Remove this
                return ReturnFailure(response, ex.Message, SoapLog.Current);
                // LogHelper.LogError(request.OrganizationName, request.UserId, "getmedispanprice Processor, Progess:" + progressString, ex);
                //if (response == null) response = new VIMTgMSPgetMediSpanPriceResponse();
                //response.ExceptionOccured = true;
                //response.ExceptionMessage = ex.Message;
                //return response;
            }
            ////RICH: Update - Adding in a finally clause to ensure that SoapLog is always closed and ServiceCall Timer is set (and stopped if service call threw uncaught exception)
            finally
            {
                if (response == null) response = new SharePointUploadLOBRes();
                if (serviceTimer != null)
                {
                    if (serviceTimer.IsRunning)
                        serviceTimer.Stop();
                    response.ServiceTimer = serviceTimer.ElapsedMilliseconds;
                }
                /*TODO - Get updated ServiceBus.Core from Pushkar with Req/Resp as public vars so we can grab them
                response.SerializedSOAPRequest = SoapLog.Current?.Request;
                response.SerializedSOAPResponse = SoapLog.Current?.Response; 
                */
                CloseOutSoapLog();
            }
        }

        ////RICH: UPDATE - Use Helper Functions For Readability From Above
        private SharePointUploadLOBRes ReturnFailure(SharePointUploadLOBRes response, string message, SoapLog log)
        {
            Trace($"LOB Error occurred in GetDataProcessor: {message}.", LogLevel.Error);
            if (response == null)
            {
                response = new SharePointUploadLOBRes();
            }

            response.ExceptionOccurred = true;
            response.ExceptionMessage = message;
            return response;
        }

        private static void CloseOutSoapLog()
        {
            SoapLog.Current.Active = false;
            SoapLog.Current.ClearLog();
        }
        ////RICH: End Helper Functions
    }

}