﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using VIMT.VeteranWebService.Messages;
using Iris.VEFT.Messages;
using VRM.Integration.Servicebus.Core;
using VEIS.Utilities.Models;
using VEIS.Utilities;

namespace IRISUnitTests
{
    [TestClass]
    public class IRISIntegrationTest
    {
        private static string _orgName;

        private static Guid _crmeUserId = Guid.Parse("6FF0CA08-2FD2-E411-B6F7-00155D5575E0");

        private static string veisUrl = "https://DNS.URL/";

        private static string clientId = "58d50ca3-b921-4d9b-ac76-8965be2eb80b";

        private static string clientSecret = "4RdVDdhq8cv/h2263Ojdy8fD3JI9OwHcr5hOkntAwTc=";

        private static string tenantId = "f7c49e36-971b-42c7-b244-a88eed6c0bf6";

        private static string veisOrgName = "CRMEDEV";

        private static string resourceId = "4a77476c-ceed-45db-ad7e-ac2bbbc4f72a";

        private static string subscriptionKey = "88784cf9396e41dab087c90a5da0c2c1";

        private static string medalliaPath = "patsr.lob.medallia/api";

        private static string irisPath = "patsr.lob.iris/api";

        private static string whhPath = "patsr.lob.whh/api";
        #region Initialize
        [TestInitialize]
        public void IRISInitialize()
        {
        }
        #endregion Initialize

        [TestMethod]
        public void TestIrisCreate()
        {
            IrisCreateInteractionRequest irisCreateInteractionRequest = new IrisCreateInteractionRequest
            {
                incidentNumber = "12345",
                contactDate = "11/11/2017",
                firstName = "Bob",
                institution = "699",
                issueText = "I had a problem!",
                lastName = "Hope",
                MessageId = Guid.NewGuid().ToString(),
                methodOfContact = "Phone",
                methodOfContactData = "123-123-1234",
                organizationName = "ftp",
                relationToVet = "Father",
                ssn = "123123123"
            };
            VeisConfig config = RetrieveVeisConfig(irisPath);
            IrisCreateInteractionResponse irisCreateInteractionResponse = WebApiUtility.SendReceiveVeisRequest<IrisCreateInteractionResponse>(config, "Interaction", irisCreateInteractionRequest);
            //var res = req.SendReceive<CreateInteractionResponse>(MessageProcessType.Local);
            var test = irisCreateInteractionResponse.MessageId;
        }

        internal static VeisConfig RetrieveVeisConfig(string path)
        {
            VeisConfig config = new VeisConfig()
            {
                OrgOverride = veisOrgName,
            };

            config.OrgName = veisOrgName;

            config.VeisConfiguration = new VeisConfiguration()
            {
                CRMAuthInfo = new CRMAuthTokenConfiguration()
                {
                    ClientApplicationId = clientId,
                    ClientSecret = clientSecret,
                    TenantId = tenantId,
                    ResourceId = resourceId,

                },
                SvcConfigInfo = new VEISSvcLOBConfiguration()
                {
                    ApimSubscriptionKey = subscriptionKey,
                }
            };

            config.VeisConfiguration.SvcConfigInfo.SvcLOBServiceUrl = veisUrl + path;
            return config;
        }
    }
}