﻿using System.Reflection;

namespace VEIS.Core.Configuration
{
    public static class ConfigurationLocation
    {
        public static string StripFileNameFromPath(string path)
        {
            return path.Substring(0, path.LastIndexOf(@"\", System.StringComparison.Ordinal));
        }

        public static string ConfigFilePath
        {
            get
            {
                //VINEXT:
                //var location = StripFileNameFromPath(Assembly.GetExecutingAssembly().Location);
                //var location = System.AppDomain.CurrentDomain.BaseDirectory;
                var location = System.AppDomain.CurrentDomain.RelativeSearchPath;

                if (location == null)
                {
                    location = StripFileNameFromPath(Assembly.GetExecutingAssembly().Location);
                }

                return string.Format("{0}\\" + "VEIS.Config", location);
            }
        }

        public static string GetConfigFilePath(string organizationName)
        {
            //var location = StripFileNameFromPath(Assembly.GetExecutingAssembly().Location);
            //var location = System.AppDomain.CurrentDomain.BaseDirectory;

            //VINEXT:
            var location = System.AppDomain.CurrentDomain.RelativeSearchPath;
            if (location == null)
            {
                location = StripFileNameFromPath(Assembly.GetExecutingAssembly().Location);
            }
            return string.Format("{0}\\" + "VEIS.{1}.Config", location, organizationName);
        }

        public static string ConfigDefiningAssemblyPath
        {
            get
            {
                //VINEXT: Changed location to the bin directory
                var location = Assembly.GetExecutingAssembly().CodeBase;
                if (location.EndsWith("dll"))
                {
                    location = Assembly.GetExecutingAssembly().Location;
                }
                return location;

                //return "C:\\dh\\RT\\VINextWebApi2\\VINextWebApi2\\VEIS..Core.dll";
                //return 
            }
        }
    }
}