﻿using System;
using System.Xml;
using System.Configuration;

namespace VEIS.Core.Configuration
{
    public class ObjectConfigHandler : IConfigurationSectionHandler
    {
        public object Create(object parent, object configContext, XmlNode section)
        {
            var xPathNavigator = section.CreateNavigator();

            var typeOfObject = (string)xPathNavigator.Evaluate("string(@type)");

            if (typeOfObject == null)
            {
                return null;
            }
            var type = Type.GetType(typeOfObject);

            if (type == null)
            {
                return null;
            }
            var xmlSerializer = new System.Xml.Serialization.XmlSerializer(type);

            var xmlNodeReader = new XmlNodeReader(section);

            return xmlSerializer.Deserialize(xmlNodeReader);
        }
    }
}