﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Configuration;


namespace VEIS.Core.Configuration
{

    [Serializable]
    public class ThreadSleepConfiguration : ObjectConfigHandler
    {
        private readonly List<ThreadSleepItem> _ThreadSleepItems = new List<ThreadSleepItem>();

        public ThreadSleepItem GetThreadSleepItemById(string id)
        {
            var result = ThreadSleepItems.FirstOrDefault(item =>
                string.Equals(item.Id, id));

            //if(result == null)
            //    throw new Exception(string.Format("ThreadSleepConfiguration was not found for Id = {0}", id));

            return result;
        }

        public static ThreadSleepConfiguration Current
        {
            get
            {
                var customConfigurationFileReader = new CustomConfigurationFileReader();

                var section = customConfigurationFileReader.GetCustomConfig<ThreadSleepConfiguration>(ConfigurationLocation.ConfigDefiningAssemblyPath,
                    ConfigurationLocation.ConfigFilePath,
                    "ThreadSleepConfiguration");

                //if (section == null)
                //    throw new Exception("The ThreadSleepConfiguration Section has not been specified");

                return section;
            }
        }

        public List<ThreadSleepItem> ThreadSleepItems
        {
            get
            {
                return _ThreadSleepItems;
            }
        }
    }

    [Serializable]
    public class ThreadSleepItem
    {
        [Key]
        [Required]
        public string Id { get; set; }

        public int SleepSeconds { get; set; }
    }
}
