﻿using log4net;

namespace VEIS.Core.Core
{
    public class Logger
    {
        private static readonly object _Lock = new object();
        private static volatile ILog _Log;

        public static ILog Instance
        {
            get
            {
                if (_Log != null)
                {
                    return _Log;
                }
                lock (_Lock)
                {
                    if (_Log != null)
                    {
                        return _Log;
                    }
                    log4net.Config.XmlConfigurator.Configure();

                    return _Log = LogManager.GetLogger(typeof(Logger));
                }
            }
        }
    }
}
