﻿using System;


namespace VEIS.Core.Core
{

    public abstract class RequestHandler : IMessageHandler
    {
        public abstract void Handle(object message);

        public void LogMessageReceipt(object message)
        {
            var request = message as MessageBase;

            if (request == null)
            {
                Logger.Instance.Warn(string.Format("{0} recieved a null message", GetType().FullName));

                return;
            }

            Logger.Instance.Info(string.Format("Message Id:{0}, Type={2}, Recieved Message: {1}",
                request.MessageId,
                request.MessageId,
                GetType().FullName));
        }

        public IMessageBase HandleRequestResponse(object message)
        {
            throw new NotSupportedException("this handler does not support request response");
        }

        public bool HandlesRequestResponseMessages
        {
            get
            {
                return false;
            }
        }

        public bool HandlesOneWayMessages
        {
            get
            {
                return true;
            }
        }

        public int Priority
        {
            get
            {
                return 1;
            }
        }

        public bool DeserializeRequestMessage
        {
            get
            {
                return true;
            }
        }
    }
}