﻿using System;
namespace VEIS.Core.Core
{
    public abstract class RequestResponseHandler : IMessageHandler
    {
        public abstract IMessageBase HandleRequestResponse(object message);

        public void LogMessageReceipt(object message)
        {
            var request = message as MessageBase;

            if (request == null)
            {
                Logger.Instance.Warn(string.Format("{0} recieved a null message", GetType().FullName));

                return;
            }

            Logger.Instance.Info(string.Format("Message Id:{0}, Type={2}, Recieved Message: {1}",
                request.MessageId,
                request.MessageId,
                GetType().FullName));
        }

        public void LogMessageResponse(object message)
        {
            var response = message as MessageBase;

            if (response == null)
            {
                Logger.Instance.Warn(string.Format("{0} send a null message", GetType().FullName));

                return;
            }

            Logger.Instance.Info(string.Format("Message Id:{0}, Type={2}, Send Message: {1}",
                response.MessageId,
                response.MessageId,
                GetType().FullName));
        }

        public void Handle(object message)
        {
            throw new NotSupportedException("this handler does not support request");
        }

        public bool HandlesRequestResponseMessages
        {
            get
            {
                return true;
            }
        }

        public bool HandlesOneWayMessages
        {
            get
            {
                return false;
            }
        }

        public int Priority
        {
            get
            {
                return 1;
            }
        }

        public bool DeserializeRequestMessage
        {
            get
            {
                return true;
            }
        }
    }
}