﻿using System;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;

namespace VEIS.Core.Wcf
{
    public class CustomClientBehavior : IEndpointBehavior
    {
        public void Validate(ServiceEndpoint endpoint)
        {
        }

        public void AddBindingParameters(ServiceEndpoint endpoint, BindingParameterCollection bindingParameters)
        {
        }

        public void ApplyDispatchBehavior(ServiceEndpoint endpoint, EndpointDispatcher endpointDispatcher)
        {
            throw new NotImplementedException("Behavior not implemented for the server side!");
        }

        public void ApplyClientBehavior(ServiceEndpoint endpoint, ClientRuntime clientRuntime)
        {
            var customClientMessageInspector = new CustomClientMessageInspector();

            customClientMessageInspector.OnAfterReceiveReply += OnAfterReceiveReplyHandler;
            customClientMessageInspector.OnBeforeSendRequest += OnBeforeSendRequestHandler;

            clientRuntime.MessageInspectors.Add(customClientMessageInspector);
        }

        protected void OnAfterReceiveReplyHandler(ref Message reply, object correlationState)
        {
            if (OnAfterReceiveReply != null)
                OnAfterReceiveReply(ref reply, correlationState);
        }

        protected object OnBeforeSendRequestHandler(ref Message request, IClientChannel channel)
        {
            return OnBeforeSendRequest != null ? OnBeforeSendRequest(ref request, channel) : null;
        }

        public OnBeforeSendRequestDelegate OnBeforeSendRequest;
        public OnAfterReceiveReplyDelegate OnAfterReceiveReply;
    }
}

