﻿using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Dispatcher;


namespace VEIS.Core.Wcf
{
    public class CustomClientMessageInspector : IClientMessageInspector
    {
        public object BeforeSendRequest(ref Message request, IClientChannel channel)
        {
            var result = OnBeforeSendRequest != null ? OnBeforeSendRequest(ref request, channel) : null;

            return result;
        }

        public void AfterReceiveReply(ref Message reply, object correlationState)
        {
            if (OnAfterReceiveReply != null)
                OnAfterReceiveReply(ref reply, correlationState);
        }

        public OnBeforeSendRequestDelegate OnBeforeSendRequest;
        public OnAfterReceiveReplyDelegate OnAfterReceiveReply;
    }

    public delegate object OnBeforeSendRequestDelegate(ref Message request, IClientChannel channel);

    public delegate void OnAfterReceiveReplyDelegate(ref Message reply, object correlationState);
}

