﻿using System.IO;
using System.ServiceModel.Channels;
using System.Xml;

namespace VEIS.Core.Wcf
{
    public static class WcfExtensions
    {
        public static XmlDocument ToXmlDocument(this Message message)
        {
            var xmlDocument = new XmlDocument();

            var memoryStream = new MemoryStream();

            var xmlWriter = XmlWriter.Create(memoryStream);

            message.WriteMessage(xmlWriter);

            xmlWriter.Flush();

            memoryStream.Position = 0;

            xmlDocument.Load(memoryStream);

            return xmlDocument;
        }

        public static Message ToMessage(this XmlDocument xmlDocument, MessageVersion messageVersion)
        {
            var memoryStream = new MemoryStream();

            var xmlWriter = XmlWriter.Create(memoryStream);

            xmlDocument.WriteTo(xmlWriter);

            xmlWriter.Flush();

            memoryStream.Position = 0;

            var xmlReader = XmlReader.Create(memoryStream);

            var message = Message.CreateMessage(xmlReader, int.MaxValue, messageVersion);

            return message;
        }
    }
}

