using System;
using VEIS.Core.Messages;
using System.Runtime.Serialization;


namespace VEIS.Messages.CpeAccountAdapterServiceV3
{ 
	[DataContract]
	/// <summary>
	/// VEIS Enterprise Component for VEIS.CpeAccountAdapterServiceV3.Api,getAccountProfileBill method, Response.
	/// Code Generated by IMS on: 5/22/2018 1:09:08 PM
	/// Version: 2018.05.09.05
	/// </summary>
	/// <param name=none></param>
	/// <returns>none</returns>
	public class VEISgAPBgetAccountProfileBillResponse : VEISEcResponseBase
	{
		[DataMember]
		public VEISgAPBCPEAccountAdapterv3getAccountProfileBillResponse VEISgAPBCPEAccountAdapterv3getAccountProfileBillResponseInfo { get; set; }
		[DataMember]
		public bool ExceptionOccured { get; set; } 
	}
	[DataContract]
	public class VEISgAPBCPEAccountAdapterv3getAccountProfileBillResponse
	{
		[DataMember]
		public VEISgAPBcode VEISgAPBcodeInfo { get; set; }
		[DataMember]
		public VEISgAPBbillProfile VEISgAPBbillProfileInfo { get; set; }
		[DataMember]
		public VEISgAPBfault VEISgAPBfaultInfo { get; set; }
	}
	[DataContract]
	public enum VEISgAPBcode
	{
		SUCCESS,
		ERROR,
	}
	[DataContract]
	public class VEISgAPBbillProfile
	{
		[DataMember]
		public string mcs_statementDay { get; set; }
		[DataMember]
		public string mcs_lastStatement { get; set; }
		[DataMember]
		public string mcs_amountOwed { get; set; }
		[DataMember]
		public DateTime mcs_accountForwardedToTOP { get; set; }
		[DataMember]
		public bool mcs_accountForwardedToTOPSpecified { get; set; }
		[DataMember]
		public DateTime mcs_topHoldDate { get; set; }
		[DataMember]
		public bool mcs_topHoldDateSpecified { get; set; }
		[DataMember]
		public string mcs_totalTOPAmount { get; set; }
		[DataMember]
		public string mcs_rxCopayExempt { get; set; }
		[DataMember]
		public string mcs_cvStatus { get; set; }
		[DataMember]
		public DateTime mcs_cvStatusEnds { get; set; }
		[DataMember]
		public bool mcs_cvStatusEndsSpecified { get; set; }
		[DataMember]
		public string mcs_exemptionReason { get; set; }
		[DataMember]
		public DateTime mcs_accountForwardedToDMC { get; set; }
		[DataMember]
		public bool mcs_accountForwardedToDMCSpecified { get; set; }
		[DataMember]
		public string mcs_totalDMCAmount { get; set; }
		[DataMember]
		public string mcs_lesserAmountToDMC { get; set; }
		[DataMember]
		public string mcs_xDebtRefferedToCrossServicing { get; set; }
		[DataMember]
		public string mcs_totalCrossServicingDebt { get; set; }
		[DataMember]
		public string mcs_comment { get; set; }
		[DataMember]
		public VEISgAPBdebtor VEISgAPBdebtorInfo { get; set; }
		[DataMember]
		public VEISgAPBbillMultipleResponse[] VEISgAPBbillInfo { get; set; }
	}
	[DataContract]
	public class VEISgAPBdebtor
	{
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_phoneNumber { get; set; }
		[DataMember]
		public VEISgAPBaddress VEISgAPBaddressInfo { get; set; }
	}
	[DataContract]
	public class VEISgAPBaddress
	{
		[DataMember]
		public bool mcs_typeSpecified { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_addressLine1 { get; set; }
		[DataMember]
		public string mcs_addressLine2 { get; set; }
		[DataMember]
		public string mcs_addressLine3 { get; set; }
		[DataMember]
		public string mcs_addressCityName { get; set; }
		[DataMember]
		public string mcs_addressUSStateCode { get; set; }
		[DataMember]
		public string mcs_addressZip5PostalCode { get; set; }
		[DataMember]
		public string mcs_country { get; set; }
		[DataMember]
		public string mcs_countryCode { get; set; }
		[DataMember]
		public string mcs_foreignAddressFlag { get; set; }
		[DataMember]
		public string mcs_phoneNumber { get; set; }
		[DataMember]
		public DateTime mcs_addressDocumentDate { get; set; }
		[DataMember]
		public bool mcs_addressDocumentDateSpecified { get; set; }
		[DataMember]
		public VEISgAPBtype VEISgAPBtypeInfo { get; set; }
		[DataMember]
		public VEISgAPBaddressDocument VEISgAPBaddressDocumentInfo { get; set; }
	}
	[DataContract]
	public enum VEISgAPBtype
	{
		SponsorRemitto,
		SponsorCorrespondence,
		SponsorPhysical,
		BeneficiaryRemitto,
		BeneficiaryCorrespondence,
		BeneficiaryGuardian,
		BeneficiaryPhysical,
		ProviderRemitto,
		ProviderBilling,
		ProviderProvider,
		ContactContact,
		FMPCorrespondence,
		FMPRemitto,
		FMPPhysical,
		DebtorCorrespondence,
		DebtorBilling,
		DebtorOrdering,
	}
	[DataContract]
	public class VEISgAPBaddressDocument
	{
		[DataMember]
		public string mcs_documentTypeID { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_abbreviation { get; set; }
	}
	[DataContract]
	public class VEISgAPBbillMultipleResponse
	{
		[DataMember]
		public string mcs_billNumber { get; set; }
		[DataMember]
		public string mcs_originalAmount { get; set; }
		[DataMember]
		public DateTime mcs_originalAmountDate { get; set; }
		[DataMember]
		public bool mcs_originalAmountDateSpecified { get; set; }
		[DataMember]
		public string mcs_transactionTotalAmount { get; set; }
		[DataMember]
		public VEISgAPBtransactionsMultipleResponse[] VEISgAPBtransactionsInfo { get; set; }
	}
	[DataContract]
	public class VEISgAPBtransactionsMultipleResponse
	{
		[DataMember]
		public string mcs_transactionNumber { get; set; }
		[DataMember]
		public string mcs_transactionType { get; set; }
		[DataMember]
		public DateTime mcs_transactionDate { get; set; }
		[DataMember]
		public bool mcs_transactionDateSpecified { get; set; }
		[DataMember]
		public string mcs_transactionAmount { get; set; }
	}
	[DataContract]
	public class VEISgAPBfault
	{
		[DataMember]
		public bool mcs_essCodeSpecified { get; set; }
		[DataMember]
		public string mcs_essText { get; set; }
		[DataMember]
		public string mcs_code { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public VEISgAPBessCode VEISgAPBessCodeInfo { get; set; }
		[DataMember]
		public VEISgAPBnestedFault VEISgAPBnestedFaultInfo { get; set; }
	}
	[DataContract]
	public enum VEISgAPBessCode
	{
		SUCCESS,
		ERROR,
		WARNING,
		REFUSED,
		ACCEPT,
		REJECT,
		FAIL,
	}
	[DataContract]
	public class VEISgAPBnestedFault
	{
		[DataMember]
		public bool mcs_essCodeSpecified { get; set; }
		[DataMember]
		public string mcs_essText { get; set; }
		[DataMember]
		public string mcs_code { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public VEISgAPBessCode1 VEISgAPBessCode1Info { get; set; }
	}
	[DataContract]
	public enum VEISgAPBessCode1
	{
		SUCCESS,
		ERROR,
		WARNING,
		REFUSED,
		ACCEPT,
		REJECT,
		FAIL,
	}
}
