using System;
using VEIS.Core.Messages;
using System.Runtime.Serialization;


namespace VEIS.Messages.CpeAccountAdapterServiceV3
{ 
	[DataContract]
	/// <summary>
	/// VEIS Enterprise Component for VEIS.CpeAccountAdapterServiceV3.Api,getAccountProfileDebtors method, Response.
	/// Code Generated by IMS on: 5/22/2018 11:58:00 AM
	/// Version: 2018.05.09.05
	/// </summary>
	/// <param name=none></param>
	/// <returns>none</returns>
	public class VEISgAPDgetAccountProfileDebtorsResponse : VEISEcResponseBase
	{
		[DataMember]
		public VEISgAPDCPEAccountAdapterv3getAccountProfileDebtorsResponse VEISgAPDCPEAccountAdapterv3getAccountProfileDebtorsResponseInfo { get; set; }
		[DataMember]
		public bool ExceptionOccured { get; set; } 
	}
	[DataContract]
	public class VEISgAPDCPEAccountAdapterv3getAccountProfileDebtorsResponse
	{
		[DataMember]
		public VEISgAPDcode VEISgAPDcodeInfo { get; set; }
		[DataMember]
		public VEISgAPDdebtorMultipleResponse[] VEISgAPDdebtorInfo { get; set; }
		[DataMember]
		public VEISgAPDnewPersonMultipleResponse[] VEISgAPDnewPersonInfo { get; set; }
		[DataMember]
		public VEISgAPDpatientMultipleResponse[] VEISgAPDpatientInfo { get; set; }
		[DataMember]
		public VEISgAPDfault VEISgAPDfaultInfo { get; set; }
	}
	[DataContract]
	public enum VEISgAPDcode
	{
		SUCCESS,
		ERROR,
	}
	[DataContract]
	public class VEISgAPDdebtorMultipleResponse
	{
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_phoneNumber { get; set; }
		[DataMember]
		public string mcs_fmsCode { get; set; }
		[DataMember]
		public string mcs_fmsName { get; set; }
		[DataMember]
		public string mcs_alternateAddressIndicator { get; set; }
		[DataMember]
		public string mcs_debtorID { get; set; }
		[DataMember]
		public VEISgAPDaddress VEISgAPDaddressInfo { get; set; }
	}
	[DataContract]
	public class VEISgAPDaddress
	{
		[DataMember]
		public bool mcs_typeSpecified { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_addressLine1 { get; set; }
		[DataMember]
		public string mcs_addressLine2 { get; set; }
		[DataMember]
		public string mcs_addressLine3 { get; set; }
		[DataMember]
		public string mcs_addressCityName { get; set; }
		[DataMember]
		public string mcs_addressUSStateCode { get; set; }
		[DataMember]
		public string mcs_addressZip5PostalCode { get; set; }
		[DataMember]
		public string mcs_country { get; set; }
		[DataMember]
		public string mcs_countryCode { get; set; }
		[DataMember]
		public string mcs_foreignAddressFlag { get; set; }
		[DataMember]
		public string mcs_phoneNumber { get; set; }
		[DataMember]
		public DateTime mcs_addressDocumentDate { get; set; }
		[DataMember]
		public bool mcs_addressDocumentDateSpecified { get; set; }
		[DataMember]
		public VEISgAPDtype VEISgAPDtypeInfo { get; set; }
		[DataMember]
		public VEISgAPDaddressDocument VEISgAPDaddressDocumentInfo { get; set; }
	}
	[DataContract]
	public enum VEISgAPDtype
	{
		SponsorRemitto,
		SponsorCorrespondence,
		SponsorPhysical,
		BeneficiaryRemitto,
		BeneficiaryCorrespondence,
		BeneficiaryGuardian,
		BeneficiaryPhysical,
		ProviderRemitto,
		ProviderBilling,
		ProviderProvider,
		ContactContact,
		FMPCorrespondence,
		FMPRemitto,
		FMPPhysical,
		DebtorCorrespondence,
		DebtorBilling,
		DebtorOrdering,
	}
	[DataContract]
	public class VEISgAPDaddressDocument
	{
		[DataMember]
		public string mcs_documentTypeID { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_abbreviation { get; set; }
	}
	[DataContract]
	public class VEISgAPDnewPersonMultipleResponse
	{
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_initials { get; set; }
		[DataMember]
		public string mcs_mailCode { get; set; }
		[DataMember]
		public string mcs_title { get; set; }
		[DataMember]
		public string mcs_debtorID { get; set; }
	}
	[DataContract]
	public class VEISgAPDpatientMultipleResponse
	{
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public DateTime mcs_dateOfBirth { get; set; }
		[DataMember]
		public bool mcs_dateOfBirthSpecified { get; set; }
		[DataMember]
		public string mcs_ssn { get; set; }
		[DataMember]
		public string mcs_vetFlag { get; set; }
		[DataMember]
		public string mcs_vetType { get; set; }
		[DataMember]
		public string mcs_debtorID { get; set; }
	}
	[DataContract]
	public class VEISgAPDfault
	{
		[DataMember]
		public bool mcs_essCodeSpecified { get; set; }
		[DataMember]
		public string mcs_essText { get; set; }
		[DataMember]
		public string mcs_code { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public VEISgAPDessCode VEISgAPDessCodeInfo { get; set; }
		[DataMember]
		public VEISgAPDnestedFault VEISgAPDnestedFaultInfo { get; set; }
	}
	[DataContract]
	public enum VEISgAPDessCode
	{
		SUCCESS,
		ERROR,
		WARNING,
		REFUSED,
		ACCEPT,
		REJECT,
		FAIL,
	}
	[DataContract]
	public class VEISgAPDnestedFault
	{
		[DataMember]
		public bool mcs_essCodeSpecified { get; set; }
		[DataMember]
		public string mcs_essText { get; set; }
		[DataMember]
		public string mcs_code { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public VEISgAPDessCode1 VEISgAPDessCode1Info { get; set; }
	}
	[DataContract]
	public enum VEISgAPDessCode1
	{
		SUCCESS,
		ERROR,
		WARNING,
		REFUSED,
		ACCEPT,
		REJECT,
		FAIL,
	}
}
