using System;
using VEIS.Core.Messages;
using System.Runtime.Serialization;


namespace VEIS.Messages.CpeAccountAdapterServiceV3
{ 
	[DataContract]
	/// <summary>
	/// VEIS Enterprise Component for VEIS.CpeAccountAdapterServiceV3.Api,getAccountProfile method, Response.
	/// Code Generated by IMS on: 5/22/2018 11:55:16 AM
	/// Version: 2018.05.09.05
	/// </summary>
	/// <param name=none></param>
	/// <returns>none</returns>
	public class VEISgAPgetAccountProfileResponse : VEISEcResponseBase
	{
		[DataMember]
		public VEISgAPCPEAccountAdapterv3getAccountProfileResponse VEISgAPCPEAccountAdapterv3getAccountProfileResponseInfo { get; set; }
		[DataMember]
		public bool ExceptionOccured { get; set; } 
	}
	[DataContract]
	public class VEISgAPCPEAccountAdapterv3getAccountProfileResponse
	{
		[DataMember]
		public VEISgAPcode VEISgAPcodeInfo { get; set; }
		[DataMember]
		public VEISgAPaccountProfile VEISgAPaccountProfileInfo { get; set; }
		[DataMember]
		public VEISgAPfault VEISgAPfaultInfo { get; set; }
	}
	[DataContract]
	public enum VEISgAPcode
	{
		SUCCESS,
		ERROR,
	}
	[DataContract]
	public class VEISgAPaccountProfile
	{
		[DataMember]
		public string mcs_statementDay { get; set; }
		[DataMember]
		public string mcs_lastStatement { get; set; }
		[DataMember]
		public string mcs_amountOwed { get; set; }
		[DataMember]
		public DateTime mcs_accountForwardedToTOP { get; set; }
		[DataMember]
		public bool mcs_accountForwardedToTOPSpecified { get; set; }
		[DataMember]
		public DateTime mcs_topHoldDate { get; set; }
		[DataMember]
		public bool mcs_topHoldDateSpecified { get; set; }
		[DataMember]
		public string mcs_totalTOPAmount { get; set; }
		[DataMember]
		public string mcs_rxCopayExempt { get; set; }
		[DataMember]
		public string mcs_cvStatus { get; set; }
		[DataMember]
		public DateTime mcs_cvStatusEnds { get; set; }
		[DataMember]
		public bool mcs_cvStatusEndsSpecified { get; set; }
		[DataMember]
		public string mcs_exemptionReason { get; set; }
		[DataMember]
		public DateTime mcs_accountForwardedToDMC { get; set; }
		[DataMember]
		public bool mcs_accountForwardedToDMCSpecified { get; set; }
		[DataMember]
		public string mcs_totalDMCAmount { get; set; }
		[DataMember]
		public string mcs_lesserAmountToDMC { get; set; }
		[DataMember]
		public string mcs_xDebtRefferedToCrossServicing { get; set; }
		[DataMember]
		public string mcs_totalCrossServicingDebt { get; set; }
		[DataMember]
		public string mcs_comment { get; set; }
		[DataMember]
		public VEISgAPdebtor VEISgAPdebtorInfo { get; set; }
		[DataMember]
		public VEISgAPbillsMultipleResponse[] VEISgAPbillsInfo { get; set; }
	}
	[DataContract]
	public class VEISgAPdebtor
	{
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_phoneNumber { get; set; }
		[DataMember]
		public VEISgAPaddress VEISgAPaddressInfo { get; set; }
	}
	[DataContract]
	public class VEISgAPaddress
	{
		[DataMember]
		public bool mcs_typeSpecified { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_addressLine1 { get; set; }
		[DataMember]
		public string mcs_addressLine2 { get; set; }
		[DataMember]
		public string mcs_addressLine3 { get; set; }
		[DataMember]
		public string mcs_addressCityName { get; set; }
		[DataMember]
		public string mcs_addressUSStateCode { get; set; }
		[DataMember]
		public string mcs_addressZip5PostalCode { get; set; }
		[DataMember]
		public string mcs_country { get; set; }
		[DataMember]
		public string mcs_countryCode { get; set; }
		[DataMember]
		public string mcs_foreignAddressFlag { get; set; }
		[DataMember]
		public string mcs_phoneNumber { get; set; }
		[DataMember]
		public DateTime mcs_addressDocumentDate { get; set; }
		[DataMember]
		public bool mcs_addressDocumentDateSpecified { get; set; }
		[DataMember]
		public VEISgAPtype VEISgAPtypeInfo { get; set; }
		[DataMember]
		public VEISgAPaddressDocument VEISgAPaddressDocumentInfo { get; set; }
	}
	[DataContract]
	public enum VEISgAPtype
	{
		SponsorRemitto,
		SponsorCorrespondence,
		SponsorPhysical,
		BeneficiaryRemitto,
		BeneficiaryCorrespondence,
		BeneficiaryGuardian,
		BeneficiaryPhysical,
		ProviderRemitto,
		ProviderBilling,
		ProviderProvider,
		ContactContact,
		FMPCorrespondence,
		FMPRemitto,
		FMPPhysical,
		DebtorCorrespondence,
		DebtorBilling,
		DebtorOrdering,
	}
	[DataContract]
	public class VEISgAPaddressDocument
	{
		[DataMember]
		public string mcs_documentTypeID { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_abbreviation { get; set; }
	}
	[DataContract]
	public class VEISgAPbillsMultipleResponse
	{
		[DataMember]
		public string mcs_listStatus { get; set; }
		[DataMember]
		public string mcs_listStatusTotal { get; set; }
		[DataMember]
		public VEISgAPbillMultipleResponse[] VEISgAPbillInfo { get; set; }
	}
	[DataContract]
	public class VEISgAPbillMultipleResponse
	{
		[DataMember]
		public string mcs_billNumber { get; set; }
		[DataMember]
		public DateTime mcs_billEstDate { get; set; }
		[DataMember]
		public bool mcs_billEstDateSpecified { get; set; }
		[DataMember]
		public string mcs_billType { get; set; }
		[DataMember]
		public string mcs_billPaid { get; set; }
		[DataMember]
		public string mcs_billPrincipal { get; set; }
		[DataMember]
		public string mcs_billInterest { get; set; }
		[DataMember]
		public string mcs_billAdministrative { get; set; }
		[DataMember]
		public string mcs_billBalance { get; set; }
	}
	[DataContract]
	public class VEISgAPfault
	{
		[DataMember]
		public bool mcs_essCodeSpecified { get; set; }
		[DataMember]
		public string mcs_essText { get; set; }
		[DataMember]
		public string mcs_code { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public VEISgAPessCode VEISgAPessCodeInfo { get; set; }
		[DataMember]
		public VEISgAPnestedFault VEISgAPnestedFaultInfo { get; set; }
	}
	[DataContract]
	public enum VEISgAPessCode
	{
		SUCCESS,
		ERROR,
		WARNING,
		REFUSED,
		ACCEPT,
		REJECT,
		FAIL,
	}
	[DataContract]
	public class VEISgAPnestedFault
	{
		[DataMember]
		public bool mcs_essCodeSpecified { get; set; }
		[DataMember]
		public string mcs_essText { get; set; }
		[DataMember]
		public string mcs_code { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public VEISgAPessCode1 VEISgAPessCode1Info { get; set; }
	}
	[DataContract]
	public enum VEISgAPessCode1
	{
		SUCCESS,
		ERROR,
		WARNING,
		REFUSED,
		ACCEPT,
		REJECT,
		FAIL,
	}
}
