using System;
using VEIS.Core.Messages;
using System.Runtime.Serialization;


namespace VEIS.Messages.CpeAccountAdapterServiceV3
{ 
	[DataContract]
	/// <summary>
	/// VEIS Enterprise Component for VEIS.CpeAccountAdapterServiceV3.Api,getPaymentInfo method, Response.
	/// Code Generated by IMS on: 5/22/2018 12:00:32 PM
	/// Version: 2018.05.09.05
	/// </summary>
	/// <param name=none></param>
	/// <returns>none</returns>
	public class VEISgPIgetPaymentInfoResponse : VEISEcResponseBase
	{
		[DataMember]
		public VEISgPICPEAccountAdapterv3getPaymentInfoResponse VEISgPICPEAccountAdapterv3getPaymentInfoResponseInfo { get; set; }
		[DataMember]
		public bool ExceptionOccured { get; set; } 
	}
	[DataContract]
	public class VEISgPICPEAccountAdapterv3getPaymentInfoResponse
	{
		[DataMember]
		public VEISgPIcode VEISgPIcodeInfo { get; set; }
		[DataMember]
		public VEISgPIpaymentsMultipleResponse[] VEISgPIpaymentsInfo { get; set; }
		[DataMember]
		public VEISgPIfault VEISgPIfaultInfo { get; set; }
	}
	[DataContract]
	public enum VEISgPIcode
	{
		SUCCESS,
		ERROR,
	}
	[DataContract]
	public class VEISgPIpaymentsMultipleResponse
	{
		[DataMember]
		public string mcs_vendorName { get; set; }
		[DataMember]
		public string mcs_vendorTaxID { get; set; }
		[DataMember]
		public string mcs_vendorIEN { get; set; }
		[DataMember]
		public string mcs_beneficiarySSN { get; set; }
		[DataMember]
		public string mcs_paymentMessage { get; set; }
		[DataMember]
		public VEISgPIbeneficiaryName VEISgPIbeneficiaryNameInfo { get; set; }
		[DataMember]
		public VEISgPIvendorClaimsPaidMultipleResponse[] VEISgPIvendorClaimsPaidInfo { get; set; }
		[DataMember]
		public VEISgPIbeneficiaryClaimsPaidMultipleResponse[] VEISgPIbeneficiaryClaimsPaidInfo { get; set; }
	}
	[DataContract]
	public class VEISgPIbeneficiaryName
	{
		[DataMember]
		public string mcs_prefix { get; set; }
		[DataMember]
		public string mcs_firstName { get; set; }
		[DataMember]
		public string mcs_middleName { get; set; }
		[DataMember]
		public string mcs_lastName { get; set; }
		[DataMember]
		public string mcs_suffix { get; set; }
	}
	[DataContract]
	public class VEISgPIvendorClaimsPaidMultipleResponse
	{
		[DataMember]
		public string mcs_fmsDocumentID { get; set; }
		[DataMember]
		public string mcs_checkNumber { get; set; }
		[DataMember]
		public VEISgPIcheckReturnedLinesMultipleResponse[] VEISgPIcheckReturnedLinesInfo { get; set; }
		[DataMember]
		public VEISgPIpaymentLinesMultipleResponse[] VEISgPIpaymentLinesInfo { get; set; }
	}
	[DataContract]
	public class VEISgPIcheckReturnedLinesMultipleResponse
	{
		[DataMember]
		public string mcs_checkReturnedNumber { get; set; }
		[DataMember]
		public DateTime mcs_checkReturnedDate { get; set; }
		[DataMember]
		public bool mcs_checkReturnedDateSpecified { get; set; }
		[DataMember]
		public string mcs_checkReturnedReason { get; set; }
		[DataMember]
		public DateTime mcs_checkReissueDate { get; set; }
		[DataMember]
		public bool mcs_checkReissueDateSpecified { get; set; }
		[DataMember]
		public VEISgPIcheckReissueUser VEISgPIcheckReissueUserInfo { get; set; }
	}
	[DataContract]
	public class VEISgPIcheckReissueUser
	{
		[DataMember]
		public string mcs_prefix { get; set; }
		[DataMember]
		public string mcs_firstName { get; set; }
		[DataMember]
		public string mcs_middleName { get; set; }
		[DataMember]
		public string mcs_lastName { get; set; }
		[DataMember]
		public string mcs_suffix { get; set; }
	}
	[DataContract]
	public class VEISgPIpaymentLinesMultipleResponse
	{
		[DataMember]
		public string mcs_claimNumber { get; set; }
		[DataMember]
		public string mcs_lineNumber { get; set; }
		[DataMember]
		public string mcs_amount { get; set; }
		[DataMember]
		public DateTime mcs_submitDate { get; set; }
		[DataMember]
		public bool mcs_submitDateSpecified { get; set; }
		[DataMember]
		public VEISgPIstatusMultipleResponse[] VEISgPIstatusInfo { get; set; }
	}
	[DataContract]
	public class VEISgPIstatusMultipleResponse
	{
		[DataMember]
		public string mcs_code { get; set; }
		[DataMember]
		public string mcs_description { get; set; }
	}
	[DataContract]
	public class VEISgPIbeneficiaryClaimsPaidMultipleResponse
	{
		[DataMember]
		public string mcs_fmsDocumentID { get; set; }
		[DataMember]
		public string mcs_checkNumber { get; set; }
		[DataMember]
		public VEISgPIcheckReturnedLines1MultipleResponse[] VEISgPIcheckReturnedLines1Info { get; set; }
		[DataMember]
		public VEISgPIpaymentLines1MultipleResponse[] VEISgPIpaymentLines1Info { get; set; }
	}
	[DataContract]
	public class VEISgPIcheckReturnedLines1MultipleResponse
	{
		[DataMember]
		public string mcs_checkReturnedNumber { get; set; }
		[DataMember]
		public DateTime mcs_checkReturnedDate { get; set; }
		[DataMember]
		public bool mcs_checkReturnedDateSpecified { get; set; }
		[DataMember]
		public string mcs_checkReturnedReason { get; set; }
		[DataMember]
		public DateTime mcs_checkReissueDate { get; set; }
		[DataMember]
		public bool mcs_checkReissueDateSpecified { get; set; }
		[DataMember]
		public VEISgPIcheckReissueUser1 VEISgPIcheckReissueUser1Info { get; set; }
	}
	[DataContract]
	public class VEISgPIcheckReissueUser1
	{
		[DataMember]
		public string mcs_prefix { get; set; }
		[DataMember]
		public string mcs_firstName { get; set; }
		[DataMember]
		public string mcs_middleName { get; set; }
		[DataMember]
		public string mcs_lastName { get; set; }
		[DataMember]
		public string mcs_suffix { get; set; }
	}
	[DataContract]
	public class VEISgPIpaymentLines1MultipleResponse
	{
		[DataMember]
		public string mcs_claimNumber { get; set; }
		[DataMember]
		public string mcs_lineNumber { get; set; }
		[DataMember]
		public string mcs_amount { get; set; }
		[DataMember]
		public DateTime mcs_submitDate { get; set; }
		[DataMember]
		public bool mcs_submitDateSpecified { get; set; }
		[DataMember]
		public VEISgPIstatus1MultipleResponse[] VEISgPIstatus1Info { get; set; }
	}
	[DataContract]
	public class VEISgPIstatus1MultipleResponse
	{
		[DataMember]
		public string mcs_code { get; set; }
		[DataMember]
		public string mcs_description { get; set; }
	}
	[DataContract]
	public class VEISgPIfault
	{
		[DataMember]
		public bool mcs_essCodeSpecified { get; set; }
		[DataMember]
		public string mcs_essText { get; set; }
		[DataMember]
		public string mcs_code { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public VEISgPIessCode VEISgPIessCodeInfo { get; set; }
		[DataMember]
		public VEISgPInestedFault VEISgPInestedFaultInfo { get; set; }
	}
	[DataContract]
	public enum VEISgPIessCode
	{
		SUCCESS,
		ERROR,
		WARNING,
		REFUSED,
		ACCEPT,
		REJECT,
		FAIL,
	}
	[DataContract]
	public class VEISgPInestedFault
	{
		[DataMember]
		public bool mcs_essCodeSpecified { get; set; }
		[DataMember]
		public string mcs_essText { get; set; }
		[DataMember]
		public string mcs_code { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public VEISgPIessCode1 VEISgPIessCode1Info { get; set; }
	}
	[DataContract]
	public enum VEISgPIessCode1
	{
		SUCCESS,
		ERROR,
		WARNING,
		REFUSED,
		ACCEPT,
		REJECT,
		FAIL,
	}
}
