using System;
using System.Runtime.Serialization;
using VEIS.Core.Messages;

namespace VEIS.Messages.ESRService
{
	[DataContract]
	/// <summary>
	/// VEIS Enterprise Component for VEIS.ESRService,getEESummary method, Response.
	/// Code Generated by IMS on: 1/4/2019 3:33:16 PM
	/// Version: 2018.12.11.01
	/// </summary>
	/// <param name=none></param>
	/// <returns>none</returns>
	public class VEISESRgetEEgetEESummaryResponse : VEISEcResponseBase
	{
		[DataMember]
		public VEISESRgetEEgetEESummaryResponseData VEISESRgetEEgetEESummaryResponseDataInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEgetEESummaryResponseData
	{
		[DataMember]
		public string mcs_eesVersion { get; set; }
		[DataMember]
		public DateTime mcs_invocationDate { get; set; }
		[DataMember]
		public bool mcs_invocationDateSpecified { get; set; }
		[DataMember]
		public string mcs_noDataMessage { get; set; }
		[DataMember]
		public VEISESRgetEEsummary VEISESRgetEEsummaryInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEsummary
	{
		[DataMember]
		public VEISESRgetEEassociationsMultipleResponse[] VEISESRgetEEassociationsInfo { get; set; }
		[DataMember]
		public VEISESRgetEEdeathRecond VEISESRgetEEdeathRecondInfo { get; set; }
		[DataMember]
		public VEISESRgetEEdemographics VEISESRgetEEdemographicsInfo { get; set; }
		[DataMember]
		public VEISESRgetEEeligibilityVerificationInfo VEISESRgetEEeligibilityVerificationInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEemploymentInfo VEISESRgetEEemploymentInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEenrollmentDeterminationInfo VEISESRgetEEenrollmentDeterminationInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEfeeBasisListMultipleResponse[] VEISESRgetEEfeeBasisListInfo { get; set; }
		[DataMember]
		public VEISESRgetEEfinancialsInfo VEISESRgetEEfinancialsInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEincompetenceRulingInfo VEISESRgetEEincompetenceRulingInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEinsuranceListMultipleResponse[] VEISESRgetEEinsuranceListInfo { get; set; }
		[DataMember]
		public VEISESRgetEEmilitaryServiceInfo VEISESRgetEEmilitaryServiceInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEprisonerOfWarInfo VEISESRgetEEprisonerOfWarInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEpurpleHeart VEISESRgetEEpurpleHeartInfo { get; set; }
		[DataMember]
		public VEISESRgetEErelationsMultipleResponse[] VEISESRgetEErelationsInfo { get; set; }
		[DataMember]
		public VEISESRgetEEsensitivityInfo VEISESRgetEEsensitivityInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEspinalCordInjuryInfo VEISESRgetEEspinalCordInjuryInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEpersonInfo VEISESRgetEEpersonInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEconsentInfo VEISESRgetEEconsentInfoInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEassociationsMultipleResponse
	{
		[DataMember]
		public string mcs_alternatePhone { get; set; }
		[DataMember]
		public string mcs_contactType { get; set; }
		[DataMember]
		public string mcs_familyName { get; set; }
		[DataMember]
		public string mcs_givenName { get; set; }
		[DataMember]
		public DateTime mcs_lastUpdateDate { get; set; }
		[DataMember]
		public bool mcs_lastUpdateDateSpecified { get; set; }
		[DataMember]
		public string mcs_middleName { get; set; }
		[DataMember]
		public string mcs_organizationName { get; set; }
		[DataMember]
		public string mcs_prefix { get; set; }
		[DataMember]
		public string mcs_primaryPhone { get; set; }
		[DataMember]
		public string mcs_relationship { get; set; }
		[DataMember]
		public string mcs_suffix { get; set; }
		[DataMember]
		public VEISESRgetEEaddress VEISESRgetEEaddressInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEaddress
	{
		[DataMember]
		public string mcs_city { get; set; }
		[DataMember]
		public string mcs_country { get; set; }
		[DataMember]
		public string mcs_county { get; set; }
		[DataMember]
		public string mcs_line1 { get; set; }
		[DataMember]
		public string mcs_line2 { get; set; }
		[DataMember]
		public string mcs_line3 { get; set; }
		[DataMember]
		public string mcs_postalCode { get; set; }
		[DataMember]
		public string mcs_provinceCode { get; set; }
		[DataMember]
		public string mcs_state { get; set; }
		[DataMember]
		public string mcs_zipCode { get; set; }
		[DataMember]
		public string mcs_zipPlus4 { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEdeathRecond
	{
		[DataMember]
		public string mcs_dataSource { get; set; }
		[DataMember]
		public string mcs_deathDate { get; set; }
		[DataMember]
		public DateTime mcs_deathLastModified { get; set; }
		[DataMember]
		public bool mcs_deathLastModifiedSpecified { get; set; }
		[DataMember]
		public DateTime mcs_deathReportDate { get; set; }
		[DataMember]
		public bool mcs_deathReportDateSpecified { get; set; }
		[DataMember]
		public string mcs_facilityReceived { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEdemographics
	{
		[DataMember]
		public DateTime mcs_appointmentRequestDate { get; set; }
		[DataMember]
		public bool mcs_appointmentRequestDateSpecified { get; set; }
		[DataMember]
		public bool mcs_appointmentRequestResponse { get; set; }
		[DataMember]
		public bool mcs_appointmentRequestResponseSpecified { get; set; }
		[DataMember]
		public string mcs_claimFolderLocation { get; set; }
		[DataMember]
		public string mcs_claimFolderNumber { get; set; }
		[DataMember]
		public string mcs_ethnicity { get; set; }
		[DataMember]
		public string mcs_maritalStatus { get; set; }
		[DataMember]
		public string mcs_preferredFacility { get; set; }
		[DataMember]
		public DateTime mcs_assignmentDate { get; set; }
		[DataMember]
		public bool mcs_assignmentDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_unassignmentDate { get; set; }
		[DataMember]
		public bool mcs_unassignmentDateSpecified { get; set; }
		[DataMember]
		public String[] mcs_races { get; set; }
		[DataMember]
		public string mcs_religion { get; set; }
		[DataMember]
		public bool mcs_acaIndicator { get; set; }
		[DataMember]
		public bool mcs_acaIndicatorSpecified { get; set; }
		[DataMember]
		public string mcs_preferredLanguage { get; set; }
		[DataMember]
		public DateTime mcs_preferredLanguageEntryDate { get; set; }
		[DataMember]
		public bool mcs_preferredLanguageEntryDateSpecified { get; set; }
		[DataMember]
		public VEISESRgetEEcontactInfo VEISESRgetEEcontactInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEpreferredFacilitiesMultipleResponse[] VEISESRgetEEpreferredFacilitiesInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEcontactInfo
	{
		[DataMember]
		public VEISESRgetEEaddressesMultipleResponse[] VEISESRgetEEaddressesInfo { get; set; }
		[DataMember]
		public VEISESRgetEEemailsMultipleResponse[] VEISESRgetEEemailsInfo { get; set; }
		[DataMember]
		public VEISESRgetEEphonesMultipleResponse[] VEISESRgetEEphonesInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEaddressesMultipleResponse
	{
		[DataMember]
		public string mcs_city { get; set; }
		[DataMember]
		public string mcs_country { get; set; }
		[DataMember]
		public string mcs_county { get; set; }
		[DataMember]
		public string mcs_line1 { get; set; }
		[DataMember]
		public string mcs_line2 { get; set; }
		[DataMember]
		public string mcs_line3 { get; set; }
		[DataMember]
		public string mcs_postalCode { get; set; }
		[DataMember]
		public string mcs_provinceCode { get; set; }
		[DataMember]
		public string mcs_state { get; set; }
		[DataMember]
		public string mcs_zipCode { get; set; }
		[DataMember]
		public string mcs_zipPlus4 { get; set; }
		[DataMember]
		public DateTime mcs_addressChangeDateTime { get; set; }
		[DataMember]
		public bool mcs_addressChangeDateTimeSpecified { get; set; }
		[DataMember]
		public string mcs_addressChangeEffectiveDate { get; set; }
		[DataMember]
		public string mcs_addressChangeSite { get; set; }
		[DataMember]
		public string mcs_addressChangeSource { get; set; }
		[DataMember]
		public string mcs_addressTypeCode { get; set; }
		[DataMember]
		public string mcs_badAddressReason { get; set; }
		[DataMember]
		public String[] mcs_confidentialAddressCategories { get; set; }
		[DataMember]
		public string mcs_endDate { get; set; }
		[DataMember]
		public string mcs_phoneNumber { get; set; }
		[DataMember]
		public string mcs_contactMethodType { get; set; }
		[DataMember]
		public DateTime mcs_contactMethodReportDate { get; set; }
		[DataMember]
		public bool mcs_contactMethodReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEemailsMultipleResponse
	{
		[DataMember]
		public string mcs_address { get; set; }
		[DataMember]
		public DateTime mcs_changeDate { get; set; }
		[DataMember]
		public bool mcs_changeDateSpecified { get; set; }
		[DataMember]
		public string mcs_siteOfChange { get; set; }
		[DataMember]
		public string mcs_sourceOfChange { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEphonesMultipleResponse
	{
		[DataMember]
		public string mcs_phoneNumber { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public DateTime mcs_phoneNumberReportDate { get; set; }
		[DataMember]
		public bool mcs_phoneNumberReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEpreferredFacilitiesMultipleResponse
	{
		[DataMember]
		public string mcs_preferredFacility { get; set; }
		[DataMember]
		public DateTime mcs_assignmentDate { get; set; }
		[DataMember]
		public bool mcs_assignmentDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_unassignmentDate { get; set; }
		[DataMember]
		public bool mcs_unassignmentDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEeligibilityVerificationInfo
	{
		[DataMember]
		public string mcs_eligibilityStatus { get; set; }
		[DataMember]
		public string mcs_eligibilityStatusDate { get; set; }
		[DataMember]
		public string mcs_verificationMethod { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEemploymentInfo
	{
		[DataMember]
		public string mcs_employerName { get; set; }
		[DataMember]
		public string mcs_employerPhone { get; set; }
		[DataMember]
		public string mcs_employmentStatus { get; set; }
		[DataMember]
		public string mcs_occupation { get; set; }
		[DataMember]
		public string mcs_retirementDate { get; set; }
		[DataMember]
		public VEISESRgetEEemployerAddress VEISESRgetEEemployerAddressInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEemployerAddress
	{
		[DataMember]
		public string mcs_city { get; set; }
		[DataMember]
		public string mcs_country { get; set; }
		[DataMember]
		public string mcs_county { get; set; }
		[DataMember]
		public string mcs_line1 { get; set; }
		[DataMember]
		public string mcs_line2 { get; set; }
		[DataMember]
		public string mcs_line3 { get; set; }
		[DataMember]
		public string mcs_postalCode { get; set; }
		[DataMember]
		public string mcs_provinceCode { get; set; }
		[DataMember]
		public string mcs_state { get; set; }
		[DataMember]
		public string mcs_zipCode { get; set; }
		[DataMember]
		public string mcs_zipPlus4 { get; set; }
		[DataMember]
		public DateTime mcs_addressChangeDateTime { get; set; }
		[DataMember]
		public bool mcs_addressChangeDateTimeSpecified { get; set; }
		[DataMember]
		public string mcs_addressChangeEffectiveDate { get; set; }
		[DataMember]
		public string mcs_addressChangeSite { get; set; }
		[DataMember]
		public string mcs_addressChangeSource { get; set; }
		[DataMember]
		public string mcs_addressTypeCode { get; set; }
		[DataMember]
		public string mcs_badAddressReason { get; set; }
		[DataMember]
		public String[] mcs_confidentialAddressCategories { get; set; }
		[DataMember]
		public string mcs_endDate { get; set; }
		[DataMember]
		public string mcs_phoneNumber { get; set; }
		[DataMember]
		public string mcs_contactMethodType { get; set; }
		[DataMember]
		public DateTime mcs_contactMethodReportDate { get; set; }
		[DataMember]
		public bool mcs_contactMethodReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEenrollmentDeterminationInfo
	{
		[DataMember]
		public DateTime mcs_applicationDate { get; set; }
		[DataMember]
		public bool mcs_applicationDateSpecified { get; set; }
		[DataMember]
		public string mcs_calculationSource { get; set; }
		[DataMember]
		public DateTime mcs_effectiveDate { get; set; }
		[DataMember]
		public bool mcs_effectiveDateSpecified { get; set; }
		[DataMember]
		public bool mcs_eligibleForMedicaid { get; set; }
		[DataMember]
		public bool mcs_eligibleForMedicaidSpecified { get; set; }
		[DataMember]
		public DateTime mcs_medicaidLastModifiedDate { get; set; }
		[DataMember]
		public bool mcs_medicaidLastModifiedDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_endDate { get; set; }
		[DataMember]
		public bool mcs_endDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_enrollmentDate { get; set; }
		[DataMember]
		public bool mcs_enrollmentDateSpecified { get; set; }
		[DataMember]
		public string mcs_enrollmentStatus { get; set; }
		[DataMember]
		public string mcs_facilityReceived { get; set; }
		[DataMember]
		public string mcs_enrollmentCategoryName { get; set; }
		[DataMember]
		public string mcs_priorityGroup { get; set; }
		[DataMember]
		public string mcs_prioritySubGroup { get; set; }
		[DataMember]
		public string mcs_userEnrolleeSite { get; set; }
		[DataMember]
		public Int32 mcs_userEnrolleeValidThrough { get; set; }
		[DataMember]
		public bool mcs_userEnrolleeValidThroughSpecified { get; set; }
		[DataMember]
		public bool mcs_veteran { get; set; }
		[DataMember]
		public bool mcs_veteranSpecified { get; set; }
		[DataMember]
		public DateTime mcs_recordCreatedDate { get; set; }
		[DataMember]
		public bool mcs_recordCreatedDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_recordModifiedDate { get; set; }
		[DataMember]
		public bool mcs_recordModifiedDateSpecified { get; set; }
		[DataMember]
		public VEISESRgetEEcancelDeclineInfo VEISESRgetEEcancelDeclineInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEcatastrophicDisabilityInfo VEISESRgetEEcatastrophicDisabilityInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEineligibilityFactor VEISESRgetEEineligibilityFactorInfo { get; set; }
		[DataMember]
		public VEISESRgetEEmilitarySexualTraumaInfo VEISESRgetEEmilitarySexualTraumaInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEmonetaryBenefitAwardInfo VEISESRgetEEmonetaryBenefitAwardInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEnoseThroatRadiumInfo VEISESRgetEEnoseThroatRadiumInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEotherEligibilitiesMultipleResponse[] VEISESRgetEEotherEligibilitiesInfo { get; set; }
		[DataMember]
		public VEISESRgetEEprimaryEligibility VEISESRgetEEprimaryEligibilityInfo { get; set; }
		[DataMember]
		public VEISESRgetEEsecondaryEligibilitiesMultipleResponse[] VEISESRgetEEsecondaryEligibilitiesInfo { get; set; }
		[DataMember]
		public VEISESRgetEEserviceConnectionAward VEISESRgetEEserviceConnectionAwardInfo { get; set; }
		[DataMember]
		public VEISESRgetEEspecialFactors VEISESRgetEEspecialFactorsInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEcancelDeclineInfo
	{
		[DataMember]
		public bool mcs_cancelDeclineIndicator { get; set; }
		[DataMember]
		public bool mcs_cancelDeclineIndicatorSpecified { get; set; }
		[DataMember]
		public string mcs_reason { get; set; }
		[DataMember]
		public string mcs_remarks { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEcatastrophicDisabilityInfo
	{
		[DataMember]
		public bool mcs_catastrophicallyDisabled { get; set; }
		[DataMember]
		public bool mcs_catastrophicallyDisabledSpecified { get; set; }
		[DataMember]
		public DateTime mcs_decisionDate { get; set; }
		[DataMember]
		public bool mcs_decisionDateSpecified { get; set; }
		[DataMember]
		public string mcs_determinationFacility { get; set; }
		[DataMember]
		public string mcs_determinationMethod { get; set; }
		[DataMember]
		public string mcs_determinedBy { get; set; }
		[DataMember]
		public String[] mcs_diagnoses { get; set; }
		[DataMember]
		public DateTime mcs_facilityInitiatedCDReviewDate { get; set; }
		[DataMember]
		public bool mcs_facilityInitiatedCDReviewDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_reviewDate { get; set; }
		[DataMember]
		public bool mcs_reviewDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_veteranRequestedCDReviewDate { get; set; }
		[DataMember]
		public bool mcs_veteranRequestedCDReviewDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_veteranWasNotifiedCDDate { get; set; }
		[DataMember]
		public bool mcs_veteranWasNotifiedCDDateSpecified { get; set; }
		[DataMember]
		public VEISESRgetEEcdConditionsMultipleResponse[] VEISESRgetEEcdConditionsInfo { get; set; }
		[DataMember]
		public VEISESRgetEEcdProceduresMultipleResponse[] VEISESRgetEEcdProceduresInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEcdConditionsMultipleResponse
	{
		[DataMember]
		public string mcs_condition { get; set; }
		[DataMember]
		public bool mcs_permanentIndicator { get; set; }
		[DataMember]
		public bool mcs_permanentIndicatorSpecified { get; set; }
		[DataMember]
		public Int32 mcs_score { get; set; }
		[DataMember]
		public bool mcs_scoreSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEcdProceduresMultipleResponse
	{
		[DataMember]
		public string mcs_affectedExtremity { get; set; }
		[DataMember]
		public string mcs_procedure { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEineligibilityFactor
	{
		[DataMember]
		public string mcs_facilityReceived { get; set; }
		[DataMember]
		public DateTime mcs_ineligibleDate { get; set; }
		[DataMember]
		public bool mcs_ineligibleDateSpecified { get; set; }
		[DataMember]
		public string mcs_reason { get; set; }
		[DataMember]
		public string mcs_varoDecision { get; set; }
		[DataMember]
		public DateTime mcs_recordCreatedDate { get; set; }
		[DataMember]
		public bool mcs_recordCreatedDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEmilitarySexualTraumaInfo
	{
		[DataMember]
		public string mcs_determinationFacility { get; set; }
		[DataMember]
		public string mcs_status { get; set; }
		[DataMember]
		public DateTime mcs_statusChangeDate { get; set; }
		[DataMember]
		public bool mcs_statusChangeDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEmonetaryBenefitAwardInfo
	{
		[DataMember]
		public Decimal mcs_checkAmount { get; set; }
		[DataMember]
		public bool mcs_checkAmountSpecified { get; set; }
		[DataMember]
		public VEISESRgetEEmonetaryBenefitsMultipleResponse[] VEISESRgetEEmonetaryBenefitsInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEmonetaryBenefitsMultipleResponse
	{
		[DataMember]
		public bool mcs_monetaryBenefitIndicator { get; set; }
		[DataMember]
		public bool mcs_monetaryBenefitIndicatorSpecified { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public DateTime mcs_monetaryBenefitReportDate { get; set; }
		[DataMember]
		public bool mcs_monetaryBenefitReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEnoseThroatRadiumInfo
	{
		[DataMember]
		public string mcs_determinationFacility { get; set; }
		[DataMember]
		public bool mcs_diagnosedWithCancer { get; set; }
		[DataMember]
		public bool mcs_diagnosedWithCancerSpecified { get; set; }
		[DataMember]
		public DateTime mcs_diagnosisVerifiedDate { get; set; }
		[DataMember]
		public bool mcs_diagnosisVerifiedDateSpecified { get; set; }
		[DataMember]
		public bool mcs_fromAviatorServiceBefore1955 { get; set; }
		[DataMember]
		public bool mcs_fromAviatorServiceBefore1955Specified { get; set; }
		[DataMember]
		public bool mcs_fromSubmarinerServiceBefore1965 { get; set; }
		[DataMember]
		public bool mcs_fromSubmarinerServiceBefore1965Specified { get; set; }
		[DataMember]
		public string mcs_receivingTreatment { get; set; }
		[DataMember]
		public DateTime mcs_verificationDate { get; set; }
		[DataMember]
		public bool mcs_verificationDateSpecified { get; set; }
		[DataMember]
		public string mcs_verificationFacility { get; set; }
		[DataMember]
		public string mcs_verificationMethod { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEotherEligibilitiesMultipleResponse
	{
		[DataMember]
		public string mcs_indicator { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public DateTime mcs_eligibilityReportDate { get; set; }
		[DataMember]
		public bool mcs_eligibilityReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEprimaryEligibility
	{
		[DataMember]
		public string mcs_indicator { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public DateTime mcs_eligibilityReportDate { get; set; }
		[DataMember]
		public bool mcs_eligibilityReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEsecondaryEligibilitiesMultipleResponse
	{
		[DataMember]
		public string mcs_indicator { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public DateTime mcs_eligibilityReportDate { get; set; }
		[DataMember]
		public bool mcs_eligibilityReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEserviceConnectionAward
	{
		[DataMember]
		public string mcs_awardDate { get; set; }
		[DataMember]
		public string mcs_combinedServiceConnectedPercentageEffectiveDate { get; set; }
		[DataMember]
		public bool mcs_permanentAndTotal { get; set; }
		[DataMember]
		public bool mcs_permanentAndTotalSpecified { get; set; }
		[DataMember]
		public DateTime mcs_permanentAndTotalEffectiveDate { get; set; }
		[DataMember]
		public bool mcs_permanentAndTotalEffectiveDateSpecified { get; set; }
		[DataMember]
		public bool mcs_serviceConnectedIndicator { get; set; }
		[DataMember]
		public bool mcs_serviceConnectedIndicatorSpecified { get; set; }
		[DataMember]
		public Int32 mcs_serviceConnectedPercentage { get; set; }
		[DataMember]
		public bool mcs_serviceConnectedPercentageSpecified { get; set; }
		[DataMember]
		public bool mcs_unemployable { get; set; }
		[DataMember]
		public bool mcs_unemployableSpecified { get; set; }
		[DataMember]
		public DateTime mcs_scReportDate { get; set; }
		[DataMember]
		public bool mcs_scReportDateSpecified { get; set; }
		[DataMember]
		public VEISESRgetEEratedDisabilitiesMultipleResponse[] VEISESRgetEEratedDisabilitiesInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEratedDisabilitiesMultipleResponse
	{
		[DataMember]
		public string mcs_diagnosticExtremity { get; set; }
		[DataMember]
		public string mcs_disability { get; set; }
		[DataMember]
		public string mcs_disabilityCode { get; set; }
		[DataMember]
		public string mcs_originalEffectiveRatingDate { get; set; }
		[DataMember]
		public Int32 mcs_percentage { get; set; }
		[DataMember]
		public bool mcs_percentageSpecified { get; set; }
		[DataMember]
		public string mcs_ratingDate { get; set; }
		[DataMember]
		public bool mcs_serviceConnected { get; set; }
		[DataMember]
		public bool mcs_serviceConnectedSpecified { get; set; }
		[DataMember]
		public DateTime mcs_recordModifiedDate { get; set; }
		[DataMember]
		public bool mcs_recordModifiedDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEspecialFactors
	{
		[DataMember]
		public bool mcs_agentOrangeInd { get; set; }
		[DataMember]
		public bool mcs_agentOrangeIndSpecified { get; set; }
		[DataMember]
		public string mcs_agentOrangeLocation { get; set; }
		[DataMember]
		public bool mcs_envContaminantsInd { get; set; }
		[DataMember]
		public bool mcs_envContaminantsIndSpecified { get; set; }
		[DataMember]
		public bool mcs_campLejeuneInd { get; set; }
		[DataMember]
		public bool mcs_campLejeuneIndSpecified { get; set; }
		[DataMember]
		public bool mcs_radiationExposureInd { get; set; }
		[DataMember]
		public bool mcs_radiationExposureIndSpecified { get; set; }
		[DataMember]
		public string mcs_radiationExposureMethod { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEfeeBasisListMultipleResponse
	{
		[DataMember]
		public DateTime mcs_authorizationFromDate { get; set; }
		[DataMember]
		public bool mcs_authorizationFromDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_authorizationToDate { get; set; }
		[DataMember]
		public bool mcs_authorizationToDateSpecified { get; set; }
		[DataMember]
		public string mcs_program { get; set; }
		[DataMember]
		public DateTime mcs_reportDate { get; set; }
		[DataMember]
		public bool mcs_reportDateSpecified { get; set; }
		[DataMember]
		public string mcs_reportSite { get; set; }
		[DataMember]
		public string mcs_treatmentType { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEfinancialsInfo
	{
		[DataMember]
		public string mcs_reportSite { get; set; }
		[DataMember]
		public VEISESRgetEEbeneficiaryTravelsMultipleResponse[] VEISESRgetEEbeneficiaryTravelsInfo { get; set; }
		[DataMember]
		public VEISESRgetEEfinancialStatement VEISESRgetEEfinancialStatementInfo { get; set; }
		[DataMember]
		public VEISESRgetEEincomeTest VEISESRgetEEincomeTestInfo { get; set; }
		[DataMember]
		public VEISESRgetEEnonPrimaryFinancialsInfoMultipleResponse[] VEISESRgetEEnonPrimaryFinancialsInfoInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEbeneficiaryTravelsMultipleResponse
	{
		[DataMember]
		public Decimal mcs_amountCertified { get; set; }
		[DataMember]
		public bool mcs_amountCertifiedSpecified { get; set; }
		[DataMember]
		public DateTime mcs_dateCertified { get; set; }
		[DataMember]
		public bool mcs_dateCertifiedSpecified { get; set; }
		[DataMember]
		public bool mcs_eligible { get; set; }
		[DataMember]
		public bool mcs_eligibleSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEfinancialStatement
	{
		[DataMember]
		public Int32 mcs_incomeYear { get; set; }
		[DataMember]
		public bool mcs_incomeYearSpecified { get; set; }
		[DataMember]
		public Decimal mcs_contributionToSpouse { get; set; }
		[DataMember]
		public bool mcs_contributionToSpouseSpecified { get; set; }
		[DataMember]
		public bool mcs_marriedLastCalendarYear { get; set; }
		[DataMember]
		public bool mcs_marriedLastCalendarYearSpecified { get; set; }
		[DataMember]
		public Int32 mcs_numberOfDependentChildren { get; set; }
		[DataMember]
		public bool mcs_numberOfDependentChildrenSpecified { get; set; }
		[DataMember]
		public Int32 mcs_inpatientDays { get; set; }
		[DataMember]
		public bool mcs_inpatientDaysSpecified { get; set; }
		[DataMember]
		public Int32 mcs_outpatientDays { get; set; }
		[DataMember]
		public bool mcs_outpatientDaysSpecified { get; set; }
		[DataMember]
		public DateTime mcs_lastVisitDate { get; set; }
		[DataMember]
		public bool mcs_lastVisitDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_vamcReportDate { get; set; }
		[DataMember]
		public bool mcs_vamcReportDateSpecified { get; set; }
		[DataMember]
		public VEISESRgetEEassetsMultipleResponse[] VEISESRgetEEassetsInfo { get; set; }
		[DataMember]
		public VEISESRgetEEdebits VEISESRgetEEdebitsInfo { get; set; }
		[DataMember]
		public VEISESRgetEEexpensesMultipleResponse[] VEISESRgetEEexpensesInfo { get; set; }
		[DataMember]
		public VEISESRgetEEincomesMultipleResponse[] VEISESRgetEEincomesInfo { get; set; }
		[DataMember]
		public VEISESRgetEEdependentFinancialsListMultipleResponse[] VEISESRgetEEdependentFinancialsListInfo { get; set; }
		[DataMember]
		public VEISESRgetEEspouseFinancialsListMultipleResponse[] VEISESRgetEEspouseFinancialsListInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEassetsMultipleResponse
	{
		[DataMember]
		public Decimal mcs_amount { get; set; }
		[DataMember]
		public bool mcs_amountSpecified { get; set; }
		[DataMember]
		public string mcs_assetType { get; set; }
		[DataMember]
		public DateTime mcs_assetReportDate { get; set; }
		[DataMember]
		public bool mcs_assetReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEdebits
	{
		[DataMember]
		public Decimal mcs_amount { get; set; }
		[DataMember]
		public bool mcs_amountSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEexpensesMultipleResponse
	{
		[DataMember]
		public Decimal mcs_amount { get; set; }
		[DataMember]
		public bool mcs_amountSpecified { get; set; }
		[DataMember]
		public string mcs_expenseType { get; set; }
		[DataMember]
		public DateTime mcs_expenseReportDate { get; set; }
		[DataMember]
		public bool mcs_expenseReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEincomesMultipleResponse
	{
		[DataMember]
		public Decimal mcs_amount { get; set; }
		[DataMember]
		public bool mcs_amountSpecified { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public DateTime mcs_incomeReportDate { get; set; }
		[DataMember]
		public bool mcs_incomeReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEdependentFinancialsListMultipleResponse
	{
		[DataMember]
		public Int32 mcs_incomeYear { get; set; }
		[DataMember]
		public bool mcs_incomeYearSpecified { get; set; }
		[DataMember]
		public bool mcs_livedWithPatient { get; set; }
		[DataMember]
		public bool mcs_livedWithPatientSpecified { get; set; }
		[DataMember]
		public Int32 mcs_inpatientDays { get; set; }
		[DataMember]
		public bool mcs_inpatientDaysSpecified { get; set; }
		[DataMember]
		public Int32 mcs_outpatientDays { get; set; }
		[DataMember]
		public bool mcs_outpatientDaysSpecified { get; set; }
		[DataMember]
		public bool mcs_validDependent { get; set; }
		[DataMember]
		public bool mcs_validDependentSpecified { get; set; }
		[DataMember]
		public Decimal mcs_amountContributedToSupport { get; set; }
		[DataMember]
		public bool mcs_amountContributedToSupportSpecified { get; set; }
		[DataMember]
		public bool mcs_attendedSchool { get; set; }
		[DataMember]
		public bool mcs_attendedSchoolSpecified { get; set; }
		[DataMember]
		public bool mcs_contributedToSupport { get; set; }
		[DataMember]
		public bool mcs_contributedToSupportSpecified { get; set; }
		[DataMember]
		public bool mcs_hasIncome { get; set; }
		[DataMember]
		public bool mcs_hasIncomeSpecified { get; set; }
		[DataMember]
		public bool mcs_incapableOfSelfSupport { get; set; }
		[DataMember]
		public bool mcs_incapableOfSelfSupportSpecified { get; set; }
		[DataMember]
		public bool mcs_incomeAvailableToPatient { get; set; }
		[DataMember]
		public bool mcs_incomeAvailableToPatientSpecified { get; set; }
		[DataMember]
		public VEISESRgetEEassets1MultipleResponse[] VEISESRgetEEassets1Info { get; set; }
		[DataMember]
		public VEISESRgetEEdebits1 VEISESRgetEEdebits1Info { get; set; }
		[DataMember]
		public VEISESRgetEEexpenses1MultipleResponse[] VEISESRgetEEexpenses1Info { get; set; }
		[DataMember]
		public VEISESRgetEEincomes1MultipleResponse[] VEISESRgetEEincomes1Info { get; set; }
		[DataMember]
		public VEISESRgetEEdependentInfo VEISESRgetEEdependentInfoInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEassets1MultipleResponse
	{
		[DataMember]
		public Decimal mcs_amount { get; set; }
		[DataMember]
		public bool mcs_amountSpecified { get; set; }
		[DataMember]
		public string mcs_assetType { get; set; }
		[DataMember]
		public DateTime mcs_assetReportDate { get; set; }
		[DataMember]
		public bool mcs_assetReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEdebits1
	{
		[DataMember]
		public Decimal mcs_amount { get; set; }
		[DataMember]
		public bool mcs_amountSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEexpenses1MultipleResponse
	{
		[DataMember]
		public Decimal mcs_amount { get; set; }
		[DataMember]
		public bool mcs_amountSpecified { get; set; }
		[DataMember]
		public string mcs_expenseType { get; set; }
		[DataMember]
		public DateTime mcs_expenseReportDate { get; set; }
		[DataMember]
		public bool mcs_expenseReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEincomes1MultipleResponse
	{
		[DataMember]
		public Decimal mcs_amount { get; set; }
		[DataMember]
		public bool mcs_amountSpecified { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public DateTime mcs_incomeReportDate { get; set; }
		[DataMember]
		public bool mcs_incomeReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEdependentInfo
	{
		[DataMember]
		public string mcs_dob { get; set; }
		[DataMember]
		public DateTime mcs_endDate { get; set; }
		[DataMember]
		public bool mcs_endDateSpecified { get; set; }
		[DataMember]
		public string mcs_familyName { get; set; }
		[DataMember]
		public string mcs_gender { get; set; }
		[DataMember]
		public string mcs_givenName { get; set; }
		[DataMember]
		public string mcs_middleName { get; set; }
		[DataMember]
		public string mcs_relationship { get; set; }
		[DataMember]
		public string mcs_startDate { get; set; }
		[DataMember]
		public string mcs_prefix { get; set; }
		[DataMember]
		public string mcs_suffix { get; set; }
		[DataMember]
		public bool mcs_incapableOfSelfSupport { get; set; }
		[DataMember]
		public bool mcs_incapableOfSelfSupportSpecified { get; set; }
		[DataMember]
		public VEISESRgetEEssnsMultipleResponse[] VEISESRgetEEssnsInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEssnsMultipleResponse
	{
		[DataMember]
		public string mcs_pseudoSSNReason { get; set; }
		[DataMember]
		public string mcs_sourceOfChange { get; set; }
		[DataMember]
		public string mcs_ssaMessage { get; set; }
		[DataMember]
		public DateTime mcs_ssaReceivedDate { get; set; }
		[DataMember]
		public bool mcs_ssaReceivedDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_ssaSentDate { get; set; }
		[DataMember]
		public bool mcs_ssaSentDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_ssaVerificationDate { get; set; }
		[DataMember]
		public bool mcs_ssaVerificationDateSpecified { get; set; }
		[DataMember]
		public string mcs_ssaVerificationStatus { get; set; }
		[DataMember]
		public string mcs_ssnText { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEspouseFinancialsListMultipleResponse
	{
		[DataMember]
		public Int32 mcs_incomeYear { get; set; }
		[DataMember]
		public bool mcs_incomeYearSpecified { get; set; }
		[DataMember]
		public bool mcs_livedWithPatient { get; set; }
		[DataMember]
		public bool mcs_livedWithPatientSpecified { get; set; }
		[DataMember]
		public Int32 mcs_inpatientDays { get; set; }
		[DataMember]
		public bool mcs_inpatientDaysSpecified { get; set; }
		[DataMember]
		public Int32 mcs_outpatientDays { get; set; }
		[DataMember]
		public bool mcs_outpatientDaysSpecified { get; set; }
		[DataMember]
		public bool mcs_validDependent { get; set; }
		[DataMember]
		public bool mcs_validDependentSpecified { get; set; }
		[DataMember]
		public Decimal mcs_contributionToSpouseAmt { get; set; }
		[DataMember]
		public bool mcs_contributionToSpouseAmtSpecified { get; set; }
		[DataMember]
		public bool mcs_contributedToSpouseInd { get; set; }
		[DataMember]
		public bool mcs_contributedToSpouseIndSpecified { get; set; }
		[DataMember]
		public VEISESRgetEEassets2MultipleResponse[] VEISESRgetEEassets2Info { get; set; }
		[DataMember]
		public VEISESRgetEEdebits2 VEISESRgetEEdebits2Info { get; set; }
		[DataMember]
		public VEISESRgetEEexpenses2MultipleResponse[] VEISESRgetEEexpenses2Info { get; set; }
		[DataMember]
		public VEISESRgetEEincomes2MultipleResponse[] VEISESRgetEEincomes2Info { get; set; }
		[DataMember]
		public VEISESRgetEEspouse VEISESRgetEEspouseInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEassets2MultipleResponse
	{
		[DataMember]
		public Decimal mcs_amount { get; set; }
		[DataMember]
		public bool mcs_amountSpecified { get; set; }
		[DataMember]
		public string mcs_assetType { get; set; }
		[DataMember]
		public DateTime mcs_assetReportDate { get; set; }
		[DataMember]
		public bool mcs_assetReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEdebits2
	{
		[DataMember]
		public Decimal mcs_amount { get; set; }
		[DataMember]
		public bool mcs_amountSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEexpenses2MultipleResponse
	{
		[DataMember]
		public Decimal mcs_amount { get; set; }
		[DataMember]
		public bool mcs_amountSpecified { get; set; }
		[DataMember]
		public string mcs_expenseType { get; set; }
		[DataMember]
		public DateTime mcs_expenseReportDate { get; set; }
		[DataMember]
		public bool mcs_expenseReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEincomes2MultipleResponse
	{
		[DataMember]
		public Decimal mcs_amount { get; set; }
		[DataMember]
		public bool mcs_amountSpecified { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public DateTime mcs_incomeReportDate { get; set; }
		[DataMember]
		public bool mcs_incomeReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEspouse
	{
		[DataMember]
		public string mcs_dob { get; set; }
		[DataMember]
		public DateTime mcs_endDate { get; set; }
		[DataMember]
		public bool mcs_endDateSpecified { get; set; }
		[DataMember]
		public string mcs_familyName { get; set; }
		[DataMember]
		public string mcs_gender { get; set; }
		[DataMember]
		public string mcs_givenName { get; set; }
		[DataMember]
		public string mcs_middleName { get; set; }
		[DataMember]
		public string mcs_relationship { get; set; }
		[DataMember]
		public string mcs_startDate { get; set; }
		[DataMember]
		public string mcs_maidenName { get; set; }
		[DataMember]
		public string mcs_prefix { get; set; }
		[DataMember]
		public string mcs_suffix { get; set; }
		[DataMember]
		public VEISESRgetEEssns1MultipleResponse[] VEISESRgetEEssns1Info { get; set; }
		[DataMember]
		public VEISESRgetEEaddress1 VEISESRgetEEaddress1Info { get; set; }
		[DataMember]
		public VEISESRgetEEemployment VEISESRgetEEemploymentInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEssns1MultipleResponse
	{
		[DataMember]
		public string mcs_pseudoSSNReason { get; set; }
		[DataMember]
		public string mcs_sourceOfChange { get; set; }
		[DataMember]
		public string mcs_ssaMessage { get; set; }
		[DataMember]
		public DateTime mcs_ssaReceivedDate { get; set; }
		[DataMember]
		public bool mcs_ssaReceivedDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_ssaSentDate { get; set; }
		[DataMember]
		public bool mcs_ssaSentDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_ssaVerificationDate { get; set; }
		[DataMember]
		public bool mcs_ssaVerificationDateSpecified { get; set; }
		[DataMember]
		public string mcs_ssaVerificationStatus { get; set; }
		[DataMember]
		public string mcs_ssnText { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEaddress1
	{
		[DataMember]
		public string mcs_city { get; set; }
		[DataMember]
		public string mcs_country { get; set; }
		[DataMember]
		public string mcs_county { get; set; }
		[DataMember]
		public string mcs_line1 { get; set; }
		[DataMember]
		public string mcs_line2 { get; set; }
		[DataMember]
		public string mcs_line3 { get; set; }
		[DataMember]
		public string mcs_postalCode { get; set; }
		[DataMember]
		public string mcs_provinceCode { get; set; }
		[DataMember]
		public string mcs_state { get; set; }
		[DataMember]
		public string mcs_zipCode { get; set; }
		[DataMember]
		public string mcs_zipPlus4 { get; set; }
		[DataMember]
		public DateTime mcs_addressChangeDateTime { get; set; }
		[DataMember]
		public bool mcs_addressChangeDateTimeSpecified { get; set; }
		[DataMember]
		public string mcs_addressChangeEffectiveDate { get; set; }
		[DataMember]
		public string mcs_addressChangeSite { get; set; }
		[DataMember]
		public string mcs_addressChangeSource { get; set; }
		[DataMember]
		public string mcs_addressTypeCode { get; set; }
		[DataMember]
		public string mcs_badAddressReason { get; set; }
		[DataMember]
		public String[] mcs_confidentialAddressCategories { get; set; }
		[DataMember]
		public string mcs_endDate { get; set; }
		[DataMember]
		public string mcs_phoneNumber { get; set; }
		[DataMember]
		public string mcs_contactMethodType { get; set; }
		[DataMember]
		public DateTime mcs_contactMethodReportDate { get; set; }
		[DataMember]
		public bool mcs_contactMethodReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEemployment
	{
		[DataMember]
		public string mcs_employerName { get; set; }
		[DataMember]
		public string mcs_employerPhone { get; set; }
		[DataMember]
		public string mcs_employmentStatus { get; set; }
		[DataMember]
		public string mcs_occupation { get; set; }
		[DataMember]
		public string mcs_retirementDate { get; set; }
		[DataMember]
		public VEISESRgetEEemployerAddress1 VEISESRgetEEemployerAddress1Info { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEemployerAddress1
	{
		[DataMember]
		public string mcs_city { get; set; }
		[DataMember]
		public string mcs_country { get; set; }
		[DataMember]
		public string mcs_county { get; set; }
		[DataMember]
		public string mcs_line1 { get; set; }
		[DataMember]
		public string mcs_line2 { get; set; }
		[DataMember]
		public string mcs_line3 { get; set; }
		[DataMember]
		public string mcs_postalCode { get; set; }
		[DataMember]
		public string mcs_provinceCode { get; set; }
		[DataMember]
		public string mcs_state { get; set; }
		[DataMember]
		public string mcs_zipCode { get; set; }
		[DataMember]
		public string mcs_zipPlus4 { get; set; }
		[DataMember]
		public DateTime mcs_addressChangeDateTime { get; set; }
		[DataMember]
		public bool mcs_addressChangeDateTimeSpecified { get; set; }
		[DataMember]
		public string mcs_addressChangeEffectiveDate { get; set; }
		[DataMember]
		public string mcs_addressChangeSite { get; set; }
		[DataMember]
		public string mcs_addressChangeSource { get; set; }
		[DataMember]
		public string mcs_addressTypeCode { get; set; }
		[DataMember]
		public string mcs_badAddressReason { get; set; }
		[DataMember]
		public String[] mcs_confidentialAddressCategories { get; set; }
		[DataMember]
		public string mcs_endDate { get; set; }
		[DataMember]
		public string mcs_phoneNumber { get; set; }
		[DataMember]
		public string mcs_contactMethodType { get; set; }
		[DataMember]
		public DateTime mcs_contactMethodReportDate { get; set; }
		[DataMember]
		public bool mcs_contactMethodReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEincomeTest
	{
		[DataMember]
		public DateTime mcs_adjudicationDate { get; set; }
		[DataMember]
		public bool mcs_adjudicationDateSpecified { get; set; }
		[DataMember]
		public bool mcs_agreesToPayDeductible { get; set; }
		[DataMember]
		public bool mcs_agreesToPayDeductibleSpecified { get; set; }
		[DataMember]
		public bool mcs_cadAdjusted { get; set; }
		[DataMember]
		public bool mcs_cadAdjustedSpecified { get; set; }
		[DataMember]
		public Decimal mcs_childIncomeExclusionThreshold { get; set; }
		[DataMember]
		public bool mcs_childIncomeExclusionThresholdSpecified { get; set; }
		[DataMember]
		public string mcs_comments { get; set; }
		[DataMember]
		public DateTime mcs_dateMTNoLongerRequired { get; set; }
		[DataMember]
		public bool mcs_dateMTNoLongerRequiredSpecified { get; set; }
		[DataMember]
		public Decimal mcs_deductibleExpenses { get; set; }
		[DataMember]
		public bool mcs_deductibleExpensesSpecified { get; set; }
		[DataMember]
		public bool mcs_discloseFinancialInformation { get; set; }
		[DataMember]
		public bool mcs_discloseFinancialInformationSpecified { get; set; }
		[DataMember]
		public DateTime mcs_effectiveDate { get; set; }
		[DataMember]
		public bool mcs_effectiveDateSpecified { get; set; }
		[DataMember]
		public bool mcs_futureTest { get; set; }
		[DataMember]
		public bool mcs_futureTestSpecified { get; set; }
		[DataMember]
		public Decimal mcs_gmtThresholdAmount { get; set; }
		[DataMember]
		public bool mcs_gmtThresholdAmountSpecified { get; set; }
		[DataMember]
		public string mcs_hardShipReason { get; set; }
		[DataMember]
		public string mcs_incomeTestType { get; set; }
		[DataMember]
		public string mcs_incomeTestsource { get; set; }
		[DataMember]
		public string mcs_incomeVerificationStatus { get; set; }
		[DataMember]
		public DateTime mcs_incomeVerificationStatusDate { get; set; }
		[DataMember]
		public bool mcs_incomeVerificationStatusDateSpecified { get; set; }
		[DataMember]
		public Int32 mcs_incomeYear { get; set; }
		[DataMember]
		public bool mcs_incomeYearSpecified { get; set; }
		[DataMember]
		public DateTime mcs_ivmTestCompletionDate { get; set; }
		[DataMember]
		public bool mcs_ivmTestCompletionDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_ivmConversionDate { get; set; }
		[DataMember]
		public bool mcs_ivmConversionDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_incomeTestReportDate { get; set; }
		[DataMember]
		public bool mcs_incomeTestReportDateSpecified { get; set; }
		[DataMember]
		public Decimal mcs_netIncome { get; set; }
		[DataMember]
		public bool mcs_netIncomeSpecified { get; set; }
		[DataMember]
		public Decimal mcs_netWorth { get; set; }
		[DataMember]
		public bool mcs_netWorthSpecified { get; set; }
		[DataMember]
		public Decimal mcs_networthThreshold { get; set; }
		[DataMember]
		public bool mcs_networthThresholdSpecified { get; set; }
		[DataMember]
		public Decimal mcs_pensionThreshold { get; set; }
		[DataMember]
		public bool mcs_pensionThresholdSpecified { get; set; }
		[DataMember]
		public bool mcs_previousYearThresholdApplies { get; set; }
		[DataMember]
		public bool mcs_previousYearThresholdAppliesSpecified { get; set; }
		[DataMember]
		public bool mcs_primaryIncomeTest { get; set; }
		[DataMember]
		public bool mcs_primaryIncomeTestSpecified { get; set; }
		[DataMember]
		public Decimal mcs_reasonMTNoLongerRequired { get; set; }
		[DataMember]
		public bool mcs_reasonMTNoLongerRequiredSpecified { get; set; }
		[DataMember]
		public bool mcs_refusedToSign { get; set; }
		[DataMember]
		public bool mcs_refusedToSignSpecified { get; set; }
		[DataMember]
		public bool mcs_sendForAdjudication { get; set; }
		[DataMember]
		public bool mcs_sendForAdjudicationSpecified { get; set; }
		[DataMember]
		public string mcs_siteConductingTest { get; set; }
		[DataMember]
		public Decimal mcs_thresholdA { get; set; }
		[DataMember]
		public bool mcs_thresholdASpecified { get; set; }
		[DataMember]
		public Decimal mcs_totalIncome { get; set; }
		[DataMember]
		public bool mcs_totalIncomeSpecified { get; set; }
		[DataMember]
		public Int32 mcs_totalNumberOfDependents { get; set; }
		[DataMember]
		public bool mcs_totalNumberOfDependentsSpecified { get; set; }
		[DataMember]
		public bool mcs_priorityGroup8Relaxation { get; set; }
		[DataMember]
		public bool mcs_priorityGroup8RelaxationSpecified { get; set; }
		[DataMember]
		public string mcs_ivmCaseStatus { get; set; }
		[DataMember]
		public VEISESRgetEEgmtAddressInfo VEISESRgetEEgmtAddressInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEhardshipInfo VEISESRgetEEhardshipInfoInfo { get; set; }
		[DataMember]
		public VEISESRgetEEstatusesMultipleResponse[] VEISESRgetEEstatusesInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEgmtAddressInfo
	{
		[DataMember]
		public string mcs_city { get; set; }
		[DataMember]
		public string mcs_country { get; set; }
		[DataMember]
		public string mcs_county { get; set; }
		[DataMember]
		public string mcs_line1 { get; set; }
		[DataMember]
		public string mcs_line2 { get; set; }
		[DataMember]
		public string mcs_line3 { get; set; }
		[DataMember]
		public string mcs_postalCode { get; set; }
		[DataMember]
		public string mcs_provinceCode { get; set; }
		[DataMember]
		public string mcs_state { get; set; }
		[DataMember]
		public string mcs_zipCode { get; set; }
		[DataMember]
		public string mcs_zipPlus4 { get; set; }
		[DataMember]
		public DateTime mcs_addressChangeDateTime { get; set; }
		[DataMember]
		public bool mcs_addressChangeDateTimeSpecified { get; set; }
		[DataMember]
		public string mcs_addressChangeEffectiveDate { get; set; }
		[DataMember]
		public string mcs_addressChangeSite { get; set; }
		[DataMember]
		public string mcs_addressChangeSource { get; set; }
		[DataMember]
		public string mcs_addressTypeCode { get; set; }
		[DataMember]
		public string mcs_badAddressReason { get; set; }
		[DataMember]
		public String[] mcs_confidentialAddressCategories { get; set; }
		[DataMember]
		public string mcs_endDate { get; set; }
		[DataMember]
		public string mcs_phoneNumber { get; set; }
		[DataMember]
		public string mcs_contactMethodType { get; set; }
		[DataMember]
		public DateTime mcs_contactMethodReportDate { get; set; }
		[DataMember]
		public bool mcs_contactMethodReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEhardshipInfo
	{
		[DataMember]
		public DateTime mcs_effectiveDate { get; set; }
		[DataMember]
		public bool mcs_effectiveDateSpecified { get; set; }
		[DataMember]
		public bool mcs_hardshipGranted { get; set; }
		[DataMember]
		public bool mcs_hardshipGrantedSpecified { get; set; }
		[DataMember]
		public string mcs_reason { get; set; }
		[DataMember]
		public DateTime mcs_reviewDate { get; set; }
		[DataMember]
		public bool mcs_reviewDateSpecified { get; set; }
		[DataMember]
		public string mcs_siteGrantingHardship { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEstatusesMultipleResponse
	{
		[DataMember]
		public DateTime mcs_completedDate { get; set; }
		[DataMember]
		public bool mcs_completedDateSpecified { get; set; }
		[DataMember]
		public string mcs_determinedStatus { get; set; }
		[DataMember]
		public string mcs_incomeTestType { get; set; }
		[DataMember]
		public DateTime mcs_lastEditedDate { get; set; }
		[DataMember]
		public bool mcs_lastEditedDateSpecified { get; set; }
		[DataMember]
		public string mcs_status { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEnonPrimaryFinancialsInfoMultipleResponse
	{
		[DataMember]
		public Int32 mcs_incomeYear { get; set; }
		[DataMember]
		public bool mcs_incomeYearSpecified { get; set; }
		[DataMember]
		public string mcs_facilityVisitedCode { get; set; }
		[DataMember]
		public Int32 mcs_inpatientDays { get; set; }
		[DataMember]
		public bool mcs_inpatientDaysSpecified { get; set; }
		[DataMember]
		public Int32 mcs_outpatientDays { get; set; }
		[DataMember]
		public bool mcs_outpatientDaysSpecified { get; set; }
		[DataMember]
		public DateTime mcs_lastVisitDate { get; set; }
		[DataMember]
		public bool mcs_lastVisitDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_vamcReportDate { get; set; }
		[DataMember]
		public bool mcs_vamcReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEincompetenceRulingInfo
	{
		[DataMember]
		public string mcs_civilRulingDate { get; set; }
		[DataMember]
		public bool mcs_incompetent { get; set; }
		[DataMember]
		public bool mcs_incompetentSpecified { get; set; }
		[DataMember]
		public string mcs_vaRulingDate { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEinsuranceListMultipleResponse
	{
		[DataMember]
		public string mcs_companyName { get; set; }
		[DataMember]
		public bool mcs_enrolledInPartA { get; set; }
		[DataMember]
		public bool mcs_enrolledInPartASpecified { get; set; }
		[DataMember]
		public bool mcs_enrolledInPartB { get; set; }
		[DataMember]
		public bool mcs_enrolledInPartBSpecified { get; set; }
		[DataMember]
		public string mcs_groupName { get; set; }
		[DataMember]
		public string mcs_groupNumber { get; set; }
		[DataMember]
		public string mcs_insuranceSiteUploadStatus { get; set; }
		[DataMember]
		public string mcs_insuredRelationship { get; set; }
		[DataMember]
		public string mcs_insuranceMappingTypeName { get; set; }
		[DataMember]
		public DateTime mcs_lastEditedDate { get; set; }
		[DataMember]
		public bool mcs_lastEditedDateSpecified { get; set; }
		[DataMember]
		public string mcs_partAEffectiveDate { get; set; }
		[DataMember]
		public string mcs_partBEffectiveDate { get; set; }
		[DataMember]
		public string mcs_planType { get; set; }
		[DataMember]
		public string mcs_policyEffectiveDate { get; set; }
		[DataMember]
		public string mcs_policyExpirationDate { get; set; }
		[DataMember]
		public string mcs_policyHolderName { get; set; }
		[DataMember]
		public string mcs_policyNumber { get; set; }
		[DataMember]
		public bool mcs_preadmitCertification { get; set; }
		[DataMember]
		public bool mcs_preadmitCertificationSpecified { get; set; }
		[DataMember]
		public string mcs_reasonInsuranceNotUploaded { get; set; }
		[DataMember]
		public string mcs_subscriber { get; set; }
		[DataMember]
		public VEISESRgetEEinsAddress VEISESRgetEEinsAddressInfo { get; set; }
		[DataMember]
		public VEISESRgetEEinsurancePhonesMultipleResponse[] VEISESRgetEEinsurancePhonesInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEinsAddress
	{
		[DataMember]
		public string mcs_city { get; set; }
		[DataMember]
		public string mcs_country { get; set; }
		[DataMember]
		public string mcs_county { get; set; }
		[DataMember]
		public string mcs_line1 { get; set; }
		[DataMember]
		public string mcs_line2 { get; set; }
		[DataMember]
		public string mcs_line3 { get; set; }
		[DataMember]
		public string mcs_postalCode { get; set; }
		[DataMember]
		public string mcs_provinceCode { get; set; }
		[DataMember]
		public string mcs_state { get; set; }
		[DataMember]
		public string mcs_zipCode { get; set; }
		[DataMember]
		public string mcs_zipPlus4 { get; set; }
		[DataMember]
		public DateTime mcs_addressChangeDateTime { get; set; }
		[DataMember]
		public bool mcs_addressChangeDateTimeSpecified { get; set; }
		[DataMember]
		public string mcs_addressChangeEffectiveDate { get; set; }
		[DataMember]
		public string mcs_addressChangeSite { get; set; }
		[DataMember]
		public string mcs_addressChangeSource { get; set; }
		[DataMember]
		public string mcs_addressTypeCode { get; set; }
		[DataMember]
		public string mcs_badAddressReason { get; set; }
		[DataMember]
		public String[] mcs_confidentialAddressCategories { get; set; }
		[DataMember]
		public string mcs_endDate { get; set; }
		[DataMember]
		public string mcs_phoneNumber { get; set; }
		[DataMember]
		public string mcs_contactMethodType { get; set; }
		[DataMember]
		public DateTime mcs_contactMethodReportDate { get; set; }
		[DataMember]
		public bool mcs_contactMethodReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEinsurancePhonesMultipleResponse
	{
		[DataMember]
		public string mcs_phoneNumber { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public DateTime mcs_phoneNumberReportDate { get; set; }
		[DataMember]
		public bool mcs_phoneNumberReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEmilitaryServiceInfo
	{
		[DataMember]
		public DateTime mcs_combatVeteranEligibilityEndDate { get; set; }
		[DataMember]
		public bool mcs_combatVeteranEligibilityEndDateSpecified { get; set; }
		[DataMember]
		public bool mcs_disabilityRetirementIndicator { get; set; }
		[DataMember]
		public bool mcs_disabilityRetirementIndicatorSpecified { get; set; }
		[DataMember]
		public bool mcs_dischargeDueToDisability { get; set; }
		[DataMember]
		public bool mcs_dischargeDueToDisabilitySpecified { get; set; }
		[DataMember]
		public bool mcs_shadIndicator { get; set; }
		[DataMember]
		public bool mcs_shadIndicatorSpecified { get; set; }
		[DataMember]
		public bool mcs_medalofHonorIndicator { get; set; }
		[DataMember]
		public bool mcs_medalofHonorIndicatorSpecified { get; set; }
		[DataMember]
		public bool mcs_eligibleForClassIIDental { get; set; }
		[DataMember]
		public bool mcs_eligibleForClassIIDentalSpecified { get; set; }
		[DataMember]
		public DateTime mcs_classIIDentalApplicationDueBefore { get; set; }
		[DataMember]
		public bool mcs_classIIDentalApplicationDueBeforeSpecified { get; set; }
		[DataMember]
		public VEISESRgetEEcombatEpisodesMultipleResponse[] VEISESRgetEEcombatEpisodesInfo { get; set; }
		[DataMember]
		public VEISESRgetEEmilitaryServiceSiteRecordsMultipleResponse[] VEISESRgetEEmilitaryServiceSiteRecordsInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEcombatEpisodesMultipleResponse
	{
		[DataMember]
		public string mcs_combatPayType { get; set; }
		[DataMember]
		public string mcs_conflictLocation { get; set; }
		[DataMember]
		public string mcs_endDate { get; set; }
		[DataMember]
		public string mcs_OEFOIFSource { get; set; }
		[DataMember]
		public string mcs_OEFOIFStationNumber { get; set; }
		[DataMember]
		public string mcs_startDate { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEmilitaryServiceSiteRecordsMultipleResponse
	{
		[DataMember]
		public string mcs_servicePeriod { get; set; }
		[DataMember]
		public string mcs_site { get; set; }
		[DataMember]
		public VEISESRgetEEconflictExperiencesMultipleResponse[] VEISESRgetEEconflictExperiencesInfo { get; set; }
		[DataMember]
		public VEISESRgetEEmilitaryServiceEpisodesMultipleResponse[] VEISESRgetEEmilitaryServiceEpisodesInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEconflictExperiencesMultipleResponse
	{
		[DataMember]
		public string mcs_conflictLocation { get; set; }
		[DataMember]
		public string mcs_endDate { get; set; }
		[DataMember]
		public string mcs_startDate { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEmilitaryServiceEpisodesMultipleResponse
	{
		[DataMember]
		public string mcs_endDate { get; set; }
		[DataMember]
		public string mcs_serviceBranch { get; set; }
		[DataMember]
		public string mcs_serviceNumber { get; set; }
		[DataMember]
		public string mcs_startDate { get; set; }
		[DataMember]
		public string mcs_dischargeType { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEprisonerOfWarInfo
	{
		[DataMember]
		public string mcs_powIndicator { get; set; }
		[DataMember]
		public VEISESRgetEEepisodesMultipleResponse[] VEISESRgetEEepisodesInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEepisodesMultipleResponse
	{
		[DataMember]
		public string mcs_captureDate { get; set; }
		[DataMember]
		public string mcs_dataSource { get; set; }
		[DataMember]
		public string mcs_documentType { get; set; }
		[DataMember]
		public string mcs_releaseDate { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEpurpleHeart
	{
		[DataMember]
		public string mcs_status { get; set; }
		[DataMember]
		public bool mcs_indicator { get; set; }
		[DataMember]
		public bool mcs_indicatorSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEErelationsMultipleResponse
	{
		[DataMember]
		public string mcs_dob { get; set; }
		[DataMember]
		public DateTime mcs_endDate { get; set; }
		[DataMember]
		public bool mcs_endDateSpecified { get; set; }
		[DataMember]
		public string mcs_familyName { get; set; }
		[DataMember]
		public string mcs_gender { get; set; }
		[DataMember]
		public string mcs_givenName { get; set; }
		[DataMember]
		public string mcs_middleName { get; set; }
		[DataMember]
		public string mcs_relationship { get; set; }
		[DataMember]
		public string mcs_startDate { get; set; }
		[DataMember]
		public VEISESRgetEEssns2MultipleResponse[] VEISESRgetEEssns2Info { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEssns2MultipleResponse
	{
		[DataMember]
		public string mcs_pseudoSSNReason { get; set; }
		[DataMember]
		public string mcs_sourceOfChange { get; set; }
		[DataMember]
		public string mcs_ssaMessage { get; set; }
		[DataMember]
		public DateTime mcs_ssaReceivedDate { get; set; }
		[DataMember]
		public bool mcs_ssaReceivedDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_ssaSentDate { get; set; }
		[DataMember]
		public bool mcs_ssaSentDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_ssaVerificationDate { get; set; }
		[DataMember]
		public bool mcs_ssaVerificationDateSpecified { get; set; }
		[DataMember]
		public string mcs_ssaVerificationStatus { get; set; }
		[DataMember]
		public string mcs_ssnText { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEsensitivityInfo
	{
		[DataMember]
		public DateTime mcs_sensitivityChangeDate { get; set; }
		[DataMember]
		public bool mcs_sensitivityChangeDateSpecified { get; set; }
		[DataMember]
		public string mcs_sensitivityChangeSite { get; set; }
		[DataMember]
		public string mcs_sensitivityChangeSource { get; set; }
		[DataMember]
		public bool mcs_sensityFlag { get; set; }
		[DataMember]
		public bool mcs_sensityFlagSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEspinalCordInjuryInfo
	{
		[DataMember]
		public string mcs_determinationFacility { get; set; }
		[DataMember]
		public string mcs_spinalCordInjuryType { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEpersonInfo
	{
		[DataMember]
		public string mcs_firstName { get; set; }
		[DataMember]
		public string mcs_middleName { get; set; }
		[DataMember]
		public string mcs_lastName { get; set; }
		[DataMember]
		public string mcs_prefix { get; set; }
		[DataMember]
		public string mcs_suffix { get; set; }
		[DataMember]
		public string mcs_ssnText { get; set; }
		[DataMember]
		public string mcs_gender { get; set; }
		[DataMember]
		public string mcs_dob { get; set; }
		[DataMember]
		public string mcs_ssaVerificationStatus { get; set; }
		[DataMember]
		public DateTime mcs_ssaVerificationDate { get; set; }
		[DataMember]
		public bool mcs_ssaVerificationDateSpecified { get; set; }
		[DataMember]
		public string mcs_mothersMaidenName { get; set; }
		[DataMember]
		public string mcs_placeOfBirthCity { get; set; }
		[DataMember]
		public string mcs_placeOfBirthState { get; set; }
		[DataMember]
		public VEISESRgetEEvamcDataMultipleResponse[] VEISESRgetEEvamcDataInfo { get; set; }
		[DataMember]
		public VEISESRgetEEnamesMultipleResponse[] VEISESRgetEEnamesInfo { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEvamcDataMultipleResponse
	{
		[DataMember]
		public string mcs_dfnNumber { get; set; }
		[DataMember]
		public string mcs_facilityNumber { get; set; }
		[DataMember]
		public DateTime mcs_lastVisitDate { get; set; }
		[DataMember]
		public bool mcs_lastVisitDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_vamcReportDate { get; set; }
		[DataMember]
		public bool mcs_vamcReportDateSpecified { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEnamesMultipleResponse
	{
		[DataMember]
		public string mcs_otherName { get; set; }
	}
	[DataContract]
	public class VEISESRgetEEconsentInfo
	{
		[DataMember]
		public string mcs_consentAuthCode { get; set; }
		[DataMember]
		public string mcs_consentImagingSite { get; set; }
		[DataMember]
		public string mcs_consentImageIndexNumber { get; set; }
		[DataMember]
		public DateTime mcs_consentReportDate { get; set; }
		[DataMember]
		public bool mcs_consentReportDateSpecified { get; set; }
		[DataMember]
		public DateTime mcs_consentLastUpdateDate { get; set; }
		[DataMember]
		public bool mcs_consentLastUpdateDateSpecified { get; set; }
	}
}
