using System;
using System.Runtime.Serialization;
using VEIS.Core.Messages;

namespace VEIS.Messages.FMCService
{
	[DataContract]
	/// <summary>
	/// VEIS Enterprise Component for VEIS.FMCService,RequestPayment method, Request.
	/// Code Generated by IMS on: 1/7/2019 8:09:22 PM
	/// Version: 2018.12.11.01
	/// </summary>
	/// <param name=none></param>
	/// <returns>none</returns>
	public class VEISFMCRpRequestPaymentRequest : VEISEcRequestBase
	{
		[DataMember]
		public Guid RelatedParentId { get; set; }
		[DataMember]
		public string RelatedParentEntityName { get; set; }
		[DataMember]
		public string RelatedParentFieldName { get; set; }
		[DataMember]
		public bool LogTiming { get; set; }
		[DataMember]
		public bool LogSoap { get; set; }
		[DataMember]
		public bool Debug { get; set; }
		[DataMember]
		public LegacyHeaderInfo LegacyServiceHeaderInfo { get; set; }
		[DataMember]
		public VEISFMCRpReqrequest VEISFMCRpReqrequestInfo { get; set; }
	}
	[DataContract]
	public class VEISFMCRpReqrequest
	{
		[DataMember]
		public VEISFMCRpReqPaymentTransaction VEISFMCRpReqPaymentTransactionInfo { get; set; }
	}
	[DataContract]
	public class VEISFMCRpReqPaymentTransaction
	{
		[DataMember]
		public bool mcs_ClientSpecified { get; set; }
		[DataMember]
		public bool mcs_TransactionCodeSpecified { get; set; }
		[DataMember]
		public VEISFMCRpReqClient VEISFMCRpReqClientInfo { get; set; }
		[DataMember]
		public VEISFMCRpReqPaymentDetailLinesMultipleResponse[] VEISFMCRpReqPaymentDetailLinesInfo { get; set; }
		[DataMember]
		public VEISFMCRpReqPaymentHeader VEISFMCRpReqPaymentHeaderInfo { get; set; }
		[DataMember]
		public VEISFMCRpReqTransactionCode VEISFMCRpReqTransactionCodeInfo { get; set; }
	}
	[DataContract]
	public enum VEISFMCRpReqClient
	{
		CLFM,
		PCS,
		IPPS,
		VAC,
		BTSSS,
	}
	[DataContract]
	public class VEISFMCRpReqPaymentDetailLinesMultipleResponse
	{
		[DataMember]
		public DateTime? mcs_AcceptanceDate { get; set; }
		[DataMember]
		public bool mcs_AcceptanceDateSpecified { get; set; }
		[DataMember]
		public string mcs_AdvanceIndicator { get; set; }
		[DataMember]
		public string mcs_BeginningBudgetFYear { get; set; }
		[DataMember]
		public string mcs_EndingBudgetFYear { get; set; }
		[DataMember]
		public string mcs_Fund { get; set; }
		[DataMember]
		public Decimal? mcs_LineAmount { get; set; }
		[DataMember]
		public bool mcs_LineAmountSpecified { get; set; }
		[DataMember]
		public string mcs_LineDescription { get; set; }
		[DataMember]
		public string mcs_LineTransactionType { get; set; }
		[DataMember]
		public string mcs_LineType { get; set; }
		[DataMember]
		public Decimal? mcs_LiquidationAmount { get; set; }
		[DataMember]
		public bool mcs_LiquidationAmountSpecified { get; set; }
		[DataMember]
		public string mcs_Organization { get; set; }
		[DataMember]
		public string mcs_PartialFinalIndicator { get; set; }
		[DataMember]
		public string mcs_ProgramExtended { get; set; }
		[DataMember]
		public string mcs_RefAdvTransactionCode { get; set; }
		[DataMember]
		public string mcs_RefAdvTransactionLine { get; set; }
		[DataMember]
		public string mcs_RefAdvTransactionNumber { get; set; }
		[DataMember]
		public string mcs_RefTransactionCode { get; set; }
		[DataMember]
		public string mcs_RefTransactionLine { get; set; }
		[DataMember]
		public string mcs_RefTransactionNumber { get; set; }
		[DataMember]
		public string mcs_SubOrganization { get; set; }
	}
	[DataContract]
	public class VEISFMCRpReqPaymentHeader
	{
		[DataMember]
		public Decimal? mcs_AdvanceLiquidationAmount { get; set; }
		[DataMember]
		public bool mcs_AdvanceLiquidationAmountSpecified { get; set; }
		[DataMember]
		public string mcs_CommentsToPrint { get; set; }
		[DataMember]
		public string mcs_DiscountAmount1 { get; set; }
		[DataMember]
		public string mcs_DiscountAmount2 { get; set; }
		[DataMember]
		public string mcs_DiscountDays1 { get; set; }
		[DataMember]
		public string mcs_DiscountDays2 { get; set; }
		[DataMember]
		public string mcs_DiscountPercent1 { get; set; }
		[DataMember]
		public string mcs_DiscountPercent2 { get; set; }
		[DataMember]
		public string mcs_DocumentAction { get; set; }
		[DataMember]
		public string mcs_DocumentDescription { get; set; }
		[DataMember]
		public string mcs_DocumentId { get; set; }
		[DataMember]
		public Decimal? mcs_DocumentTotalAmount { get; set; }
		[DataMember]
		public bool mcs_DocumentTotalAmountSpecified { get; set; }
		[DataMember]
		public string mcs_FiscMonth { get; set; }
		[DataMember]
		public string mcs_FiscYear { get; set; }
		[DataMember]
		public string mcs_FiscalApproval { get; set; }
		[DataMember]
		public DateTime? mcs_HdViDate { get; set; }
		[DataMember]
		public bool mcs_HdViDateSpecified { get; set; }
		[DataMember]
		public DateTime? mcs_HdViLogDate { get; set; }
		[DataMember]
		public bool mcs_HdViLogDateSpecified { get; set; }
		[DataMember]
		public string mcs_HdrBudgetFy { get; set; }
		[DataMember]
		public string mcs_HdrEndBudgetFy { get; set; }
		[DataMember]
		public string mcs_HdrFund { get; set; }
		[DataMember]
		public string mcs_HdrVendorInvoice { get; set; }
		[DataMember]
		public string mcs_HdrsTransType { get; set; }
		[DataMember]
		public Decimal? mcs_HoldbackPaymentAmount { get; set; }
		[DataMember]
		public bool mcs_HoldbackPaymentAmountSpecified { get; set; }
		[DataMember]
		public string mcs_InvoiceDln { get; set; }
		[DataMember]
		public Int32? mcs_InvoiceDlnSeqNbr { get; set; }
		[DataMember]
		public bool mcs_InvoiceDlnSeqNbrSpecified { get; set; }
		[DataMember]
		public Decimal? mcs_NetPaymentAmount { get; set; }
		[DataMember]
		public bool mcs_NetPaymentAmountSpecified { get; set; }
		[DataMember]
		public string mcs_PromptPayType { get; set; }
		[DataMember]
		public string mcs_ReceiverDln { get; set; }
		[DataMember]
		public Int32? mcs_ReceiverDlnSeqNbr { get; set; }
		[DataMember]
		public bool mcs_ReceiverDlnSeqNbrSpecified { get; set; }
		[DataMember]
		public DateTime? mcs_RecordDate { get; set; }
		[DataMember]
		public bool mcs_RecordDateSpecified { get; set; }
		[DataMember]
		public DateTime? mcs_ScheduleDate { get; set; }
		[DataMember]
		public bool mcs_ScheduleDateSpecified { get; set; }
		[DataMember]
		public string mcs_VendorAddress1 { get; set; }
		[DataMember]
		public string mcs_VendorAddress2 { get; set; }
		[DataMember]
		public string mcs_VendorCity { get; set; }
		[DataMember]
		public string mcs_VendorId { get; set; }
		[DataMember]
		public DateTime? mcs_VendorInvoiceDate { get; set; }
		[DataMember]
		public bool mcs_VendorInvoiceDateSpecified { get; set; }
		[DataMember]
		public string mcs_VendorInvoiceNumber { get; set; }
		[DataMember]
		public DateTime? mcs_VendorInvoiceReceivedDate { get; set; }
		[DataMember]
		public bool mcs_VendorInvoiceReceivedDateSpecified { get; set; }
		[DataMember]
		public string mcs_VendorName { get; set; }
		[DataMember]
		public string mcs_VendorState { get; set; }
		[DataMember]
		public string mcs_VendorZip { get; set; }
		[DataMember]
		public Decimal? mcs_WipAmount { get; set; }
		[DataMember]
		public bool mcs_WipAmountSpecified { get; set; }
	}
	[DataContract]
	public enum VEISFMCRpReqTransactionCode
	{
		IT,
		IP,
		MV,
		PV,
		SO,
		MB,
		RO,
		EA,
		EV,
	}
}
