using System;
using System.Runtime.Serialization;
using VEIS.Core.Messages;

namespace VEIS.Messages.VIAScheduling
{
	[DataContract]
	/// <summary>
	/// VEIS Enterprise Component for VEIS.VIAScheduling,cancelAppointment method, Request.
	/// Code Generated by IMS on: 1/24/2019 5:31:30 PM
	/// Version: 2018.12.11.01
	/// </summary>
	/// <param name=none></param>
	/// <returns>none</returns>
	public class VEISVIASchedCancApcancelAppointmentRequest : VEISEcRequestBase
	{
		[DataMember]
		public Guid RelatedParentId { get; set; }
		[DataMember]
		public string RelatedParentEntityName { get; set; }
		[DataMember]
		public string RelatedParentFieldName { get; set; }
		[DataMember]
		public bool LogTiming { get; set; }
		[DataMember]
		public bool LogSoap { get; set; }
		[DataMember]
		public bool Debug { get; set; }
		[DataMember]
		public LegacyHeaderInfo LegacyServiceHeaderInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqqueryBean VEISVIASchedCancApReqqueryBeanInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqappointment VEISVIASchedCancApReqappointmentInfo { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqqueryBean
	{
		[DataMember]
		public string mcs_recordSiteCode { get; set; }
		[DataMember]
		public string mcs_requestingApp { get; set; }
		[DataMember]
		public string mcs_active { get; set; }
		[DataMember]
		public string mcs_endDate { get; set; }
		[DataMember]
		public string mcs_startDate { get; set; }
		[DataMember]
		public string mcs_maxRecords { get; set; }
		[DataMember]
		public string mcs_status { get; set; }
		[DataMember]
		public string mcs_supplementalParameters { get; set; }
		[DataMember]
		public string mcs_itemId { get; set; }
		[DataMember]
		public string mcs_target { get; set; }
		[DataMember]
		public string mcs_criteria { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public string mcs_direction { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public bool mcs_multiSiteQuery { get; set; }
		[DataMember]
		public string mcs_consumingAppToken { get; set; }
		[DataMember]
		public string mcs_consumingAppPassword { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqprovider VEISVIASchedCancApReqproviderInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqpatient VEISVIASchedCancApReqpatientInfo { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqprovider
	{
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_userId { get; set; }
		[DataMember]
		public string mcs_loginSiteCode { get; set; }
		[DataMember]
		public string mcs_contextMenu { get; set; }
		[DataMember]
		public string mcs_vistaLocations { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqpatient
	{
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_localPid { get; set; }
		[DataMember]
		public string mcs_localSiteId { get; set; }
		[DataMember]
		public string mcs_mpiPid { get; set; }
		[DataMember]
		public string mcs_vistaLocations { get; set; }
		[DataMember]
		public string mcs_ssn { get; set; }
		[DataMember]
		public string mcs_inPatient { get; set; }
		[DataMember]
		public string mcs_age { get; set; }
		[DataMember]
		public string mcs_gender { get; set; }
		[DataMember]
		public string mcs_scPercentage { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqappointment
	{
		[DataMember]
		public string mcs_id { get; set; }
		[DataMember]
		public string mcs_timestamp { get; set; }
		[DataMember]
		public string mcs_title { get; set; }
		[DataMember]
		public string mcs_status { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public string mcs_labDateTime { get; set; }
		[DataMember]
		public string mcs_xrayDateTime { get; set; }
		[DataMember]
		public string mcs_ekgDateTime { get; set; }
		[DataMember]
		public string mcs_purpose { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public string mcs_currentStatus { get; set; }
		[DataMember]
		public string mcs_clinicId { get; set; }
		[DataMember]
		public string mcs_appointmentTimestamp { get; set; }
		[DataMember]
		public string mcs_purposeSubcategory { get; set; }
		[DataMember]
		public string mcs_appointmentLength { get; set; }
		[DataMember]
		public string mcs_appointmentType { get; set; }
		[DataMember]
		public string mcs_bookNotes { get; set; }
		[DataMember]
		public string mcs_consultIen { get; set; }
		[DataMember]
		public string mcs_lvl { get; set; }
		[DataMember]
		public string mcs_desiredDateTime { get; set; }
		[DataMember]
		public string mcs_visitId { get; set; }
		[DataMember]
		public string mcs_providerName { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_cancelCode { get; set; }
		[DataMember]
		public string mcs_cancelReason { get; set; }
		[DataMember]
		public string mcs_remarks { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqfacility VEISVIASchedCancApReqfacilityInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqclinic VEISVIASchedCancApReqclinicInfo { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqfacility
	{
		[DataMember]
		public string mcs_id { get; set; }
		[DataMember]
		public string mcs_lastEvent { get; set; }
		[DataMember]
		public string mcs_lastSeenDate { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqclinic
	{
		[DataMember]
		public string mcs_abbr { get; set; }
		[DataMember]
		public string mcs_appointmentLength { get; set; }
		[DataMember]
		public string mcs_appointmentTimestamp { get; set; }
		[DataMember]
		public bool mcs_askForCheckIn { get; set; }
		[DataMember]
		public bool mcs_askForCheckInSpecified { get; set; }
		[DataMember]
		public string mcs_bed { get; set; }
		[DataMember]
		public string mcs_building { get; set; }
		[DataMember]
		public string mcs_displayIncrements { get; set; }
		[DataMember]
		public string mcs_dispositionAction { get; set; }
		[DataMember]
		public string mcs_floor { get; set; }
		[DataMember]
		public string mcs_id { get; set; }
		[DataMember]
		public string mcs_maxOverbooksPerDay { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_phone { get; set; }
		[DataMember]
		public string mcs_physicalLocation { get; set; }
		[DataMember]
		public string mcs_prohibitAccessToClinic { get; set; }
		[DataMember]
		public string mcs_room { get; set; }
		[DataMember]
		public string mcs_status { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public string mcs_visitLocation { get; set; }
		[DataMember]
		public string mcs_siteId { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqavailabilityMultipleResponse[] VEISVIASchedCancApReqavailabilityInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqcreditStopCode VEISVIASchedCancApReqcreditStopCodeInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqdepartment VEISVIASchedCancApReqdepartmentInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqdivision VEISVIASchedCancApReqdivisionInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqfacility1 VEISVIASchedCancApReqfacility1Info { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqinstitution VEISVIASchedCancApReqinstitutionInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqmodule VEISVIASchedCancApReqmoduleInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqprincipalClinic VEISVIASchedCancApReqprincipalClinicInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqservice VEISVIASchedCancApReqserviceInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqspecialty VEISVIASchedCancApReqspecialtyInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqstopCode VEISVIASchedCancApReqstopCodeInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqtypeExtension VEISVIASchedCancApReqtypeExtensionInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqwardLocation VEISVIASchedCancApReqwardLocationInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApReqfault VEISVIASchedCancApReqfaultInfo { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqavailabilityMultipleResponse
	{
		[DataMember]
		public bool mcs_available { get; set; }
		[DataMember]
		public string mcs_end { get; set; }
		[DataMember]
		public string mcs_start { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqcreditStopCode
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqdepartment
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqdivision
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqfacility1
	{
		[DataMember]
		public string mcs_id { get; set; }
		[DataMember]
		public string mcs_lastEvent { get; set; }
		[DataMember]
		public string mcs_lastSeenDate { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqinstitution
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqmodule
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqprincipalClinic
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqservice
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqspecialty
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqstopCode
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqtypeExtension
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqwardLocation
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApReqfault
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
}
