using System;
using System.Runtime.Serialization;
using VEIS.Core.Messages;

namespace VEIS.Messages.VIAScheduling
{
	[DataContract]
	/// <summary>
	/// VEIS Enterprise Component for VEIS.VIAScheduling,cancelAppointment method, Response.
	/// Code Generated by IMS on: 1/24/2019 5:31:31 PM
	/// Version: 2018.12.11.01
	/// </summary>
	/// <param name=none></param>
	/// <returns>none</returns>
	public class VEISVIASchedCancApcancelAppointmentResponse : VEISEcResponseBase
	{
		[DataMember]
		public VEISVIASchedCancApcancelAppointmentTO VEISVIASchedCancApcancelAppointmentTOInfo { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApcancelAppointmentTO
	{
		[DataMember]
		public string mcs_timestamp { get; set; }
		[DataMember]
		public string mcs_purpose { get; set; }
		[DataMember]
		public string mcs_reason { get; set; }
		[DataMember]
		public string mcs_remarks { get; set; }
		[DataMember]
		public VEISVIASchedCancApclinic VEISVIASchedCancApclinicInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault16 VEISVIASchedCancApfault16Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApclinic
	{
		[DataMember]
		public string mcs_id { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_building { get; set; }
		[DataMember]
		public string mcs_floor { get; set; }
		[DataMember]
		public string mcs_room { get; set; }
		[DataMember]
		public string mcs_bed { get; set; }
		[DataMember]
		public string mcs_status { get; set; }
		[DataMember]
		public string mcs_phone { get; set; }
		[DataMember]
		public string mcs_appointmentTimestamp { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public string mcs_physicalLocation { get; set; }
		[DataMember]
		public bool mcs_askForCheckIn { get; set; }
		[DataMember]
		public bool mcs_askForCheckInSpecified { get; set; }
		[DataMember]
		public string mcs_appointmentLength { get; set; }
		[DataMember]
		public string mcs_clinicDisplayStartTime { get; set; }
		[DataMember]
		public string mcs_displayIncrements { get; set; }
		[DataMember]
		public string mcs_maxOverbooksPerDay { get; set; }
		[DataMember]
		public string mcs_prohibitAccessToClinic { get; set; }
		[DataMember]
		public VEISVIASchedCancApdepartment VEISVIASchedCancApdepartmentInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApservice VEISVIASchedCancApserviceInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApspecialty VEISVIASchedCancApspecialtyInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApstopCode VEISVIASchedCancApstopCodeInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApcreditStopCode VEISVIASchedCancApcreditStopCodeInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApfacility VEISVIASchedCancApfacilityInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApavailability VEISVIASchedCancApavailabilityInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault15 VEISVIASchedCancApfault15Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApdepartment
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public String[] mcs_textArray { get; set; }
		[DataMember]
		public VEISVIASchedCancAptaggedResultsMultipleResponse[] VEISVIASchedCancAptaggedResultsInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault VEISVIASchedCancApfaultInfo { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancAptaggedResultsMultipleResponse
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public String[] mcs_textArray { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApservice
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public String[] mcs_textArray { get; set; }
		[DataMember]
		public VEISVIASchedCancAptaggedResults1MultipleResponse[] VEISVIASchedCancAptaggedResults1Info { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault1 VEISVIASchedCancApfault1Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancAptaggedResults1MultipleResponse
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public String[] mcs_textArray { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault1
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApspecialty
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public String[] mcs_textArray { get; set; }
		[DataMember]
		public VEISVIASchedCancAptaggedResults2MultipleResponse[] VEISVIASchedCancAptaggedResults2Info { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault2 VEISVIASchedCancApfault2Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancAptaggedResults2MultipleResponse
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public String[] mcs_textArray { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault2
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApstopCode
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public String[] mcs_textArray { get; set; }
		[DataMember]
		public VEISVIASchedCancAptaggedResults3MultipleResponse[] VEISVIASchedCancAptaggedResults3Info { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault3 VEISVIASchedCancApfault3Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancAptaggedResults3MultipleResponse
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public String[] mcs_textArray { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault3
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApcreditStopCode
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public String[] mcs_textArray { get; set; }
		[DataMember]
		public VEISVIASchedCancAptaggedResults4MultipleResponse[] VEISVIASchedCancAptaggedResults4Info { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault4 VEISVIASchedCancApfault4Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancAptaggedResults4MultipleResponse
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public String[] mcs_textArray { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault4
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfacility
	{
		[DataMember]
		public string mcs_sitecode { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_displayName { get; set; }
		[DataMember]
		public string mcs_moniker { get; set; }
		[DataMember]
		public string mcs_regionID { get; set; }
		[DataMember]
		public string mcs_lastEventTimestamp { get; set; }
		[DataMember]
		public string mcs_lastEventReason { get; set; }
		[DataMember]
		public string mcs_uid { get; set; }
		[DataMember]
		public string mcs_pid { get; set; }
		[DataMember]
		public string mcs_parentSiteId { get; set; }
		[DataMember]
		public string mcs_address { get; set; }
		[DataMember]
		public string mcs_city { get; set; }
		[DataMember]
		public string mcs_state { get; set; }
		[DataMember]
		public string mcs_systemName { get; set; }
		[DataMember]
		public string mcs_siteType { get; set; }
		[DataMember]
		public VEISVIASchedCancApdataSources VEISVIASchedCancApdataSourcesInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApchildSites VEISVIASchedCancApchildSitesInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault12 VEISVIASchedCancApfault12Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApdataSources
	{
		[DataMember]
		public Int32 mcs_count { get; set; }
		[DataMember]
		public bool mcs_countSpecified { get; set; }
		[DataMember]
		public VEISVIASchedCancApitemsMultipleResponse[] VEISVIASchedCancApitemsInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault7 VEISVIASchedCancApfault7Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApitemsMultipleResponse
	{
		[DataMember]
		public string mcs_protocol { get; set; }
		[DataMember]
		public string mcs_modality { get; set; }
		[DataMember]
		public Int32 mcs_timeout { get; set; }
		[DataMember]
		public Int32 mcs_port { get; set; }
		[DataMember]
		public string mcs_provider { get; set; }
		[DataMember]
		public string mcs_status { get; set; }
		[DataMember]
		public string mcs_description { get; set; }
		[DataMember]
		public string mcs_context { get; set; }
		[DataMember]
		public bool mcs_testSource { get; set; }
		[DataMember]
		public string mcs_vendor { get; set; }
		[DataMember]
		public string mcs_version { get; set; }
		[DataMember]
		public string mcs_welcomeMessage { get; set; }
		[DataMember]
		public VEISVIASchedCancApsiteId VEISVIASchedCancApsiteIdInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault6 VEISVIASchedCancApfault6Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApsiteId
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public String[] mcs_textArray { get; set; }
		[DataMember]
		public VEISVIASchedCancAptaggedResults5MultipleResponse[] VEISVIASchedCancAptaggedResults5Info { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault5 VEISVIASchedCancApfault5Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancAptaggedResults5MultipleResponse
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public String[] mcs_textArray { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault5
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault6
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault7
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApchildSites
	{
		[DataMember]
		public Int32 mcs_count { get; set; }
		[DataMember]
		public bool mcs_countSpecified { get; set; }
		[DataMember]
		public VEISVIASchedCancApsitesMultipleResponse[] VEISVIASchedCancApsitesInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault11 VEISVIASchedCancApfault11Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApsitesMultipleResponse
	{
		[DataMember]
		public string mcs_sitecode { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_displayName { get; set; }
		[DataMember]
		public string mcs_moniker { get; set; }
		[DataMember]
		public string mcs_regionID { get; set; }
		[DataMember]
		public string mcs_lastEventTimestamp { get; set; }
		[DataMember]
		public string mcs_lastEventReason { get; set; }
		[DataMember]
		public string mcs_uid { get; set; }
		[DataMember]
		public string mcs_pid { get; set; }
		[DataMember]
		public string mcs_parentSiteId { get; set; }
		[DataMember]
		public string mcs_address { get; set; }
		[DataMember]
		public string mcs_city { get; set; }
		[DataMember]
		public string mcs_state { get; set; }
		[DataMember]
		public string mcs_systemName { get; set; }
		[DataMember]
		public string mcs_siteType { get; set; }
		[DataMember]
		public VEISVIASchedCancApdataSources1 VEISVIASchedCancApdataSources1Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApdataSources1
	{
		[DataMember]
		public Int32 mcs_count { get; set; }
		[DataMember]
		public bool mcs_countSpecified { get; set; }
		[DataMember]
		public VEISVIASchedCancApitems1MultipleResponse[] VEISVIASchedCancApitems1Info { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault10 VEISVIASchedCancApfault10Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApitems1MultipleResponse
	{
		[DataMember]
		public string mcs_protocol { get; set; }
		[DataMember]
		public string mcs_modality { get; set; }
		[DataMember]
		public Int32 mcs_timeout { get; set; }
		[DataMember]
		public Int32 mcs_port { get; set; }
		[DataMember]
		public string mcs_provider { get; set; }
		[DataMember]
		public string mcs_status { get; set; }
		[DataMember]
		public string mcs_description { get; set; }
		[DataMember]
		public string mcs_context { get; set; }
		[DataMember]
		public bool mcs_testSource { get; set; }
		[DataMember]
		public string mcs_vendor { get; set; }
		[DataMember]
		public string mcs_version { get; set; }
		[DataMember]
		public string mcs_welcomeMessage { get; set; }
		[DataMember]
		public VEISVIASchedCancApsiteId1 VEISVIASchedCancApsiteId1Info { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault9 VEISVIASchedCancApfault9Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApsiteId1
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public String[] mcs_textArray { get; set; }
		[DataMember]
		public VEISVIASchedCancAptaggedResults6MultipleResponse[] VEISVIASchedCancAptaggedResults6Info { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault8 VEISVIASchedCancApfault8Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancAptaggedResults6MultipleResponse
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public String[] mcs_textArray { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault8
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault9
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault10
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault11
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault12
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApavailability
	{
		[DataMember]
		public string mcs_tag { get; set; }
		[DataMember]
		public Int32 mcs_count { get; set; }
		[DataMember]
		public bool mcs_countSpecified { get; set; }
		[DataMember]
		public VEISVIASchedCancApslotsMultipleResponse[] VEISVIASchedCancApslotsInfo { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault14 VEISVIASchedCancApfault14Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApslotsMultipleResponse
	{
		[DataMember]
		public string mcs_start { get; set; }
		[DataMember]
		public string mcs_end { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public bool mcs_available { get; set; }
		[DataMember]
		public VEISVIASchedCancApfault13 VEISVIASchedCancApfault13Info { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault13
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault14
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault15
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
	[DataContract]
	public class VEISVIASchedCancApfault16
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
}
