using System;
using System.Runtime.Serialization;
using VEIS.Core.Messages;

namespace VEIS.Messages.VIAScheduling
{
	[DataContract]
	/// <summary>
	/// VEIS Enterprise Component for VEIS.VIAScheduling,makeAppointment method, Request.
	/// Code Generated by IMS on: 1/24/2019 5:43:22 PM
	/// Version: 2018.12.11.01
	/// </summary>
	/// <param name=none></param>
	/// <returns>none</returns>
	public class VEISVIASchdMakeApptmakeAppointmentRequest : VEISEcRequestBase
	{
		[DataMember]
		public Guid RelatedParentId { get; set; }
		[DataMember]
		public string RelatedParentEntityName { get; set; }
		[DataMember]
		public string RelatedParentFieldName { get; set; }
		[DataMember]
		public bool LogTiming { get; set; }
		[DataMember]
		public bool LogSoap { get; set; }
		[DataMember]
		public bool Debug { get; set; }
		[DataMember]
		public LegacyHeaderInfo LegacyServiceHeaderInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqqueryBean VEISVIASchdMakeApptReqqueryBeanInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqappointment VEISVIASchdMakeApptReqappointmentInfo { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqqueryBean
	{
		[DataMember]
		public string mcs_recordSiteCode { get; set; }
		[DataMember]
		public string mcs_requestingApp { get; set; }
		[DataMember]
		public string mcs_active { get; set; }
		[DataMember]
		public string mcs_endDate { get; set; }
		[DataMember]
		public string mcs_startDate { get; set; }
		[DataMember]
		public string mcs_maxRecords { get; set; }
		[DataMember]
		public string mcs_status { get; set; }
		[DataMember]
		public string mcs_supplementalParameters { get; set; }
		[DataMember]
		public string mcs_itemId { get; set; }
		[DataMember]
		public string mcs_target { get; set; }
		[DataMember]
		public string mcs_criteria { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public string mcs_direction { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public bool mcs_multiSiteQuery { get; set; }
		[DataMember]
		public string mcs_consumingAppToken { get; set; }
		[DataMember]
		public string mcs_consumingAppPassword { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqprovider VEISVIASchdMakeApptReqproviderInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqpatient VEISVIASchdMakeApptReqpatientInfo { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqprovider
	{
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_userId { get; set; }
		[DataMember]
		public string mcs_loginSiteCode { get; set; }
		[DataMember]
		public string mcs_contextMenu { get; set; }
		[DataMember]
		public string mcs_vistaLocations { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqpatient
	{
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_localPid { get; set; }
		[DataMember]
		public string mcs_localSiteId { get; set; }
		[DataMember]
		public string mcs_mpiPid { get; set; }
		[DataMember]
		public string mcs_vistaLocations { get; set; }
		[DataMember]
		public string mcs_ssn { get; set; }
		[DataMember]
		public string mcs_inPatient { get; set; }
		[DataMember]
		public string mcs_age { get; set; }
		[DataMember]
		public string mcs_gender { get; set; }
		[DataMember]
		public string mcs_scPercentage { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqappointment
	{
		[DataMember]
		public string mcs_id { get; set; }
		[DataMember]
		public string mcs_timestamp { get; set; }
		[DataMember]
		public string mcs_title { get; set; }
		[DataMember]
		public string mcs_status { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
		[DataMember]
		public string mcs_labDateTime { get; set; }
		[DataMember]
		public string mcs_xrayDateTime { get; set; }
		[DataMember]
		public string mcs_ekgDateTime { get; set; }
		[DataMember]
		public string mcs_purpose { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public string mcs_currentStatus { get; set; }
		[DataMember]
		public string mcs_clinicId { get; set; }
		[DataMember]
		public string mcs_appointmentTimestamp { get; set; }
		[DataMember]
		public string mcs_purposeSubcategory { get; set; }
		[DataMember]
		public string mcs_appointmentLength { get; set; }
		[DataMember]
		public string mcs_appointmentType { get; set; }
		[DataMember]
		public string mcs_bookNotes { get; set; }
		[DataMember]
		public string mcs_consultIen { get; set; }
		[DataMember]
		public string mcs_lvl { get; set; }
		[DataMember]
		public string mcs_desiredDateTime { get; set; }
		[DataMember]
		public string mcs_visitId { get; set; }
		[DataMember]
		public string mcs_providerName { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_cancelCode { get; set; }
		[DataMember]
		public string mcs_cancelReason { get; set; }
		[DataMember]
		public string mcs_remarks { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqfacility VEISVIASchdMakeApptReqfacilityInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqclinic VEISVIASchdMakeApptReqclinicInfo { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqfacility
	{
		[DataMember]
		public string mcs_id { get; set; }
		[DataMember]
		public string mcs_lastEvent { get; set; }
		[DataMember]
		public string mcs_lastSeenDate { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqclinic
	{
		[DataMember]
		public string mcs_abbr { get; set; }
		[DataMember]
		public string mcs_appointmentLength { get; set; }
		[DataMember]
		public string mcs_appointmentTimestamp { get; set; }
		[DataMember]
		public bool mcs_askForCheckIn { get; set; }
		[DataMember]
		public bool mcs_askForCheckInSpecified { get; set; }
		[DataMember]
		public string mcs_bed { get; set; }
		[DataMember]
		public string mcs_building { get; set; }
		[DataMember]
		public string mcs_displayIncrements { get; set; }
		[DataMember]
		public string mcs_dispositionAction { get; set; }
		[DataMember]
		public string mcs_floor { get; set; }
		[DataMember]
		public string mcs_id { get; set; }
		[DataMember]
		public string mcs_maxOverbooksPerDay { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
		[DataMember]
		public string mcs_phone { get; set; }
		[DataMember]
		public string mcs_physicalLocation { get; set; }
		[DataMember]
		public string mcs_prohibitAccessToClinic { get; set; }
		[DataMember]
		public string mcs_room { get; set; }
		[DataMember]
		public string mcs_status { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
		[DataMember]
		public string mcs_visitLocation { get; set; }
		[DataMember]
		public string mcs_siteId { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqavailabilityMultipleResponse[] VEISVIASchdMakeApptReqavailabilityInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqcreditStopCode VEISVIASchdMakeApptReqcreditStopCodeInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqdepartment VEISVIASchdMakeApptReqdepartmentInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqdivision VEISVIASchdMakeApptReqdivisionInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqfacility1 VEISVIASchdMakeApptReqfacility1Info { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqinstitution VEISVIASchdMakeApptReqinstitutionInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqmodule VEISVIASchdMakeApptReqmoduleInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqprincipalClinic VEISVIASchdMakeApptReqprincipalClinicInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqservice VEISVIASchdMakeApptReqserviceInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqspecialty VEISVIASchdMakeApptReqspecialtyInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqstopCode VEISVIASchdMakeApptReqstopCodeInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqtypeExtension VEISVIASchdMakeApptReqtypeExtensionInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqwardLocation VEISVIASchdMakeApptReqwardLocationInfo { get; set; }
		[DataMember]
		public VEISVIASchdMakeApptReqfault VEISVIASchdMakeApptReqfaultInfo { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqavailabilityMultipleResponse
	{
		[DataMember]
		public bool mcs_available { get; set; }
		[DataMember]
		public string mcs_end { get; set; }
		[DataMember]
		public string mcs_start { get; set; }
		[DataMember]
		public string mcs_text { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqcreditStopCode
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqdepartment
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqdivision
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqfacility1
	{
		[DataMember]
		public string mcs_id { get; set; }
		[DataMember]
		public string mcs_lastEvent { get; set; }
		[DataMember]
		public string mcs_lastSeenDate { get; set; }
		[DataMember]
		public string mcs_name { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqinstitution
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqmodule
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqprincipalClinic
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqservice
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqspecialty
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqstopCode
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqtypeExtension
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqwardLocation
	{
		[DataMember]
		public Object mcs_key { get; set; }
		[DataMember]
		public Object mcs_value { get; set; }
	}
	[DataContract]
	public class VEISVIASchdMakeApptReqfault
	{
		[DataMember]
		public string mcs_innerMessage { get; set; }
		[DataMember]
		public string mcs_innerStackTrace { get; set; }
		[DataMember]
		public string mcs_innerType { get; set; }
		[DataMember]
		public string mcs_message { get; set; }
		[DataMember]
		public string mcs_stackTrace { get; set; }
		[DataMember]
		public string mcs_suggestion { get; set; }
		[DataMember]
		public string mcs_type { get; set; }
	}
}
