using System;
using System.Runtime.Serialization;
using VEIS.Core.Messages;


namespace VEIS.Messages.VideoVistService
{
    [DataContract(Name = "Appointment", Namespace = "gov.va.vamf.videoconnect/1.0")]
    public class VEISVideoVistCancelRequest : VEISEcRequestBase
    {
        public VEISVideoVistCancelRequest()
        {
            MessageId = Guid.NewGuid().ToString();
        }
         

        [DataMember]
        public Guid RelatedParentId { get; set; }

        [DataMember]
        public string RelatedParentEntityName { get; set; }

        [DataMember]
        public string RelatedParentFieldName { get; set; }

        [DataMember]
        public string Id { get; set; }

        [DataMember]
        public string SourceSystem { get; set; }

        [DataMember]
        public EcPersonBookingStatuses PatientBookingStatuses { get; set; }

        [DataMember]
        public string SamlToken { get; set; }
        [DataMember]
        public LegacyHeaderInfo LegacyServiceHeaderInfo { get; set; }
        [DataMember]
        public bool LogTiming { get; set; }
        [DataMember]
        public bool LogSoap { get; set; }
    }        

    [DataContract]
    public class EcPersonBookingStatus
    {
        [DataMember]
        public EcPersonIdentifier Id { get; set; }

        [DataMember]
        public EcStatus Status { get; set; }
    }

    [DataContract]
    public class EcPersonBookingStatuses
    {
        [DataMember]
        public EcPersonBookingStatus[] PersonBookingStatus { get; set; }
    }
}