﻿using System;
using System.Runtime.Serialization;
using VEIS.Core.Messages;

namespace VEIS.Messages.VirtualMeetingRoomService
{
    /// <summary>
    /// Message for VmrOnDemandCreateRequestMessage.
    /// </summary>
    public class VEISVmrOnDemandCreateRequestMessage : VEISEcRequestBase
    {
        /// <summary>
        /// Gets or sets the Video On Demand Id.
        /// </summary>
        [DataMember]
        public Guid VideoOnDemandId { get; set; }

        /// <summary>
        /// Gets or sets the Patient Id.
        /// </summary>
        [DataMember]
        public Guid PatientId { get; set; }

        /// <summary>
        /// Gets or sets the Provider Id.
        /// </summary>
        [DataMember]
        public Guid ProviderId { get; set; }

        /// <summary>
        /// Gets or sets the Misc Flag.
        /// </summary>
        [DataMember]
        public string MiscData { get; set; }
    }
}