﻿using System;
using System.Runtime.Serialization;
using VEIS.Core.Messages;

namespace VEIS.Messages.VirtualMeetingRoomService
{
    /// <summary>
    /// Message for VmrOnDemandreateResponseMessage.
    /// </summary>
    [DataContract]
    public class VEISVmrOnDemandCreateResponseMessage : VEISEcResponseBase
    {
        /// <summary>
        /// Gets or sets the Meeting Room Name.
        /// </summary>
        [DataMember]
        public string MeetingRoomName { get; set; }

        /// <summary>
        /// Gets or sets the Patient URL.
        /// </summary>
        [DataMember]
        public string PatientUrl { get; set; }

        /// <summary>
        /// Gets or sets the Provider URL.
        /// </summary>
        [DataMember]
        public string ProviderUrl { get; set; }

        /// <summary>
        /// Gets or sets the Patient PIN.
        /// </summary>
        [DataMember]
        public string PatientPin { get; set; }

        /// <summary>
        /// Gets or sets the Provider PIN.
        /// </summary>
        [DataMember]
        public string ProviderPin { get; set; }

        /// <summary>
        /// Gets or sets the CorrelationId.
        /// </summary>
        [DataMember]
        public string AppointmentId { get; set; }

        /// <summary>
        /// Gets or sets the Dialing Alias.
        /// </summary>
        [DataMember]
        public string DialingAlias { get; set; }

        /// <summary>
        /// Gets or sets the Misc data.
        /// </summary>
        [DataMember]
        public string MiscData { get; set; }
    }
}