﻿using Microsoft.IdentityModel.Clients.ActiveDirectory;
using Microsoft.Xrm.Sdk;
//using Microsoft.Xrm.Sdk.Client;
using Microsoft.Xrm.Sdk.WebServiceClient;
using System;
//using Microsoft.Pfe.Xrm;
using System.Collections.Concurrent;
using System.Linq;
using System.Net;
using CRMOLConnect.Config;
using System.Threading.Tasks;
using VEIS.Security;
using System.Configuration;
using CRMOLConnect;

namespace VEIS.Utilities
{
    public class CRMConnect
    {
        private static string UrlFormat;
        private static string _token;
        private static DateTime _expires = DateTime.Now;
        private static AuthenticationParameters _ap = null;
        private static ClientCredential _clientCredentials = null;
        private static string _orgName = string.Empty;
        //public OrganizationServiceProxy OrgServiceProxy { get; set; }

        //public OrganizationServiceProxy ConnectToCrm(string OrgName)
        //{
        //    return ConnectionManager.GetConnectionManager(OrgName).GetProxy();
        //}
        //public OrganizationServiceProxy ConnectToCRMOL(string OrgName)
        //{
        //    return ConnectionManager.GetConnectionManagerCRMOL(OrgName).GetProxy();
        //}
        public static async Task<OrganizationWebProxyClient> ConnectToCRMOL(string OrgName)
        {
            log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType).Info("In ConnectToCRMOL");

            System.Diagnostics.Stopwatch watch = new System.Diagnostics.Stopwatch();
            log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType).Info("Top pf crm ol connect");
            if (!string.IsNullOrEmpty(OrgName))
            {
                var orgNameUpper = OrgName.ToUpper();
                log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType).Info("about to get parms for OrgName");
                var section = (CRMOLConnectionParmsConfiguration)ConfigurationManager.GetSection("CRMOLConnectionParmsConfiguration");
                CRMOLConnectionParms connectionParms = section.ConnectionParmsCRMOL.FirstOrDefault(s => s.Name.ToUpper() == orgNameUpper);

                //var connectionParms = CRMOLConnectionConfiguration.Current.GetCRMOLConnectionParmsByOrganizationName(OrgName.ToUpper());

                if (string.IsNullOrEmpty(_token) || DateTime.Now.ToUniversalTime() >= _expires || _orgName != OrgName)
                {
                    if (_clientCredentials == null || _orgName != OrgName)
                    {
                        _clientCredentials = new ClientCredential(connectionParms.ClientId, connectionParms.ClientSecret);// clientSecret);// parms.ClientSecret);
                    }
                    log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType).Info("Before CreateFromResourceUrlAsync");

                    watch.Start();

                    if (_ap == null || _orgName != OrgName)
                    {
                        try
                        {
                            _ap = await AuthenticationParameters.CreateFromResourceUrlAsync(
                                    new Uri(String.Format("{0}/api/data", connectionParms.CrmUrl))).ConfigureAwait(false);
                        }
                        catch (Exception ex)
                        {
                            log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType).Info(ex.Message);
                            log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType).Info(ex.InnerException.Message);
                        }
                    }
                    log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType).Info("After CreateFromResourceUrlAsync");

                    watch.Stop();
                    //Logger.Instance.Debug(String.Format("Time to get Authenitcation Parameters CreateFromResourceURL {0}", watch.Elapsed));
                    //Logger.Instance.Debug(string.Format("got AuthenticationParameters"));
                    String authorityUrl = _ap.Authority;
                    String resourceUrl = _ap.Resource;

                    var index = authorityUrl.IndexOf("/oauth2/authorize");
                    if (index != -1)
                    {
                        authorityUrl = authorityUrl.Substring(0, index);
                    }
                    var authContext = new AuthenticationContext(authorityUrl, false);
                    //authContext.TokenCache.Clear();
                    watch.Start();
                    log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType).Info("Before acquire token" + authorityUrl);

                    var result = await authContext.AcquireTokenAsync(connectionParms.CrmUrl, _clientCredentials).ConfigureAwait(false);
                    log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType).Info("After acquire token");

                    watch.Stop();
                    //Logger.Instance.Debug(String.Format("Time to get access token {0} ", watch.Elapsed));
                    _token = result.AccessToken;
                    _orgName = OrgName;
                    //Logger.Instance.Debug(string.Format("got AccessToken"));
                }

                watch.Start();
                //Put in using block and test

                var serviceProxy = new OrganizationWebProxyClient(new Uri(string.Format(connectionParms.OrgServiceUrl + "{0}", "/web")), true)
                {
                    HeaderToken = _token,
                    //SdkClientVersion = "8.2",
                };
                watch.Stop();
                //Logger.Instance.Debug(String.Format("Time to get OrganizationWebProxyClient {0} ", watch.Elapsed));
                //Logger.Instance.Debug(string.Format("got serviceProxy"));

                return serviceProxy;
            }
            else
            {
                //Logger.Instance.Debug(string.Format("in ConnectToCRMOL, but did not get ORGNAME {0}", OrgName));

                throw new Exception("Passed in OrgName is Null, cannot proceed");
            }

        }
    }
}