using Iris.VEFT.Messages;
using Medallia.VEFT.Messages;
using Microsoft.Xrm.Sdk;
using System;
using System.Collections.Generic;
using VEIS.Utilities;
using VEIS.Utilities.Models;
using VRM.Integration.Servicebus.Extensions;
using VRMRest.WebApi;
using WHH.VEFT.Messages;

namespace VEFTStub.DAC
{
    internal class Program
    {
        private static int recordCount;

        private static string _orgName;

        private static Guid _crmeUserId = Guid.Parse("6FF0CA08-2FD2-E411-B6F7-00155D5575E0");

        private static string veisUrl = "https://DNS.URL/";

        private static string clientId = "58d50ca3-b921-4d9b-ac76-8965be2eb80b";

        private static string clientSecret = "4RdVDdhq8cv/h2263Ojdy8fD3JI9OwHcr5hOkntAwTc=";

        private static string tenantId = "f7c49e36-971b-42c7-b244-a88eed6c0bf6";

        private static string veisOrgName = "CRMEDEV";

        private static string resourceId = "4a77476c-ceed-45db-ad7e-ac2bbbc4f72a";

        private static string subscriptionKey = "88784cf9396e41dab087c90a5da0c2c1";

        private static string medalliaPath = "patsr.lob.medallia/api";

        private static string irisPath = "patsr.lob.iris/api";

        private static string whhPath = "patsr.lob.whh/api";

        private static void Main(string[] args)
        {
            Console.WriteLine("***VEFT-Medallia Integration Stub Tool V3.0 (Iris & WHH Simulation)***");
            Console.WriteLine("Use this tool to auto-generate Test Data in the VEFT CRM representative of its various integration partners.");
            Console.WriteLine("\nThis tool leverages the DAC server to create records in CRM. It is only usable from within the VRMCloud.");
            Console.WriteLine("Which integration partner are you simulating data for?\n1. Medallia\n2. WHH\n3. Iris");
            string s = Console.ReadLine();
            int result = 0;
            bool flag = false;
            while (!flag)
            {
                if (int.TryParse(s, out result))
                {
                    if (result == 1 || result == 2 || result == 3)
                    {
                        flag = true;
                    }
                    else
                    {
                        Console.WriteLine("Please select 1, 2, or 3");
                    }
                }
                else
                {
                    Console.WriteLine("Please select 1, 2 or 3");
                }
            }
            Console.WriteLine("\nHow many test records would you like to generate?");
            checkInteger(Console.ReadLine());
            Console.WriteLine("\nPlease enter the destination CRM Organization Name (organization name ONLY)");
            _orgName = Console.ReadLine();
            DoAction(result);
            Console.WriteLine("\nRecord generation complete.");
            Console.ReadLine();
        }

        private static void checkInteger(string input)
        {
            if (!int.TryParse(input, out recordCount))
            {
                Console.WriteLine("Entry must be a valid integer. Please try again.");
                checkInteger(Console.ReadLine());
            }
        }

        internal static VeisConfig RetrieveVeisConfig(string path)
        {
            VeisConfig config = new VeisConfig()
            {
                OrgOverride = veisOrgName,
            };

            config.OrgName = veisOrgName;

            config.VeisConfiguration = new VeisConfiguration()
            {
                CRMAuthInfo = new CRMAuthTokenConfiguration()
                {
                    ClientApplicationId = clientId,
                    ClientSecret = clientSecret,
                    TenantId = tenantId,
                    ResourceId = resourceId,

                },
                SvcConfigInfo = new VEISSvcLOBConfiguration()
                {
                    ApimSubscriptionKey = subscriptionKey,
                }
            };

            config.VeisConfiguration.SvcConfigInfo.SvcLOBServiceUrl = veisUrl + path;
            return config;
        }
        private static void DoAction(int system)
        {
            switch (system)
            {
                case 1:
                    {
                        Random random = new Random();
                        for (int i = 0; i < recordCount; i++)
                        {
                            string contactFirstName = (Math.Round(random.NextDouble()) != 0.0) ? "Jane" : "John";
                            CreateInteractionRequest createInteractionRequest = new CreateInteractionRequest
                            {
                                MessageLogging = new MessageLogging
                                {
                                    IgnoreState = false,
                                    MaxRetry = -1,
                                    MessageName = "MedalliaCreateInteractionRequest",
                                    MessageType = "LOB",
                                    OrganizationName = _orgName
                                },
                                CallbackNumber = $"({random.Next(100, 999)}){random.Next(100, 999)}-{random.Next(1000, 9999)}",
                                ContactFirstName = contactFirstName,
                                ContactLastName = "Doe" + random.Next(1, 999).ToString(),
                                DateOfBirth = "12/01/1970",
                                DateOfContact = DateTime.Now.Date.ToString(),
                                ExperienceComments = "LOVE IT",
                                ExperienceScore = random.Next(1, 5).ToString(),
                                LastFour = random.Next(1000, 9999).ToString(),
                                OrganizationName = _orgName,
                                SurveyID = random.Next(1000000, 9000000).ToString(),
                                SurveyLink = "WWW.BING.COM",
                                FeedbackType = "Compliment",
                                AlertType = "Homelessness",
                                StationID = "629",
                                SurveyGroup = "MOC Test"
                            };
                            createInteractionRequest.ContactEmail = createInteractionRequest.ContactFirstName + "." + createInteractionRequest.ContactLastName + "@test.test";
                            try
                            {
                                VeisConfig config = RetrieveVeisConfig(medalliaPath);
                                CreateInteractionResponse createInteractionResponse = WebApiUtility.SendReceiveVeisRequest<CreateInteractionResponse>(config, "Interaction", createInteractionRequest);
                                if (createInteractionResponse.ExceptionOccurred)
                                {
                                    catchMethod(createInteractionResponse.ExceptionMessage);
                                }
                                if (createInteractionResponse != null && createInteractionResponse.InteractionID != null)
                                {
                                    Console.WriteLine($"Created Interaction for {createInteractionRequest.ContactFirstName} {createInteractionRequest.ContactLastName}.");
                                }
                                else
                                {
                                    Console.WriteLine("record not created. Null response returned.");
                                }
                            }
                            catch (Exception ex)
                            {
                                Console.WriteLine($"Exception Occurred: {ex.Message}");
                            }
                        }
                        Console.WriteLine("Complete.");
                        Console.ReadLine();
                        return;
                    }
                case 2:
                    {
                        Random random2 = new Random();
                        new Entity("incident");
                        List<WHHCreateInteractionRequest> requests = new List<WHHCreateInteractionRequest>();
                        for (int j = 0; j < recordCount; j++)
                        {
                            string firstName = (Math.Round(random2.NextDouble()) != 0.0) ? "Jane" : "John";
                            MessageLogging messageLogging = new MessageLogging
                            {
                                IgnoreState = false,
                                MaxRetry = -1,
                                MessageName = "WHHCreateInteractionRequest",
                                MessageType = "LOB",
                                OrganizationName = _orgName
                            };
                            WHHCreateInteractionRequest wHHCreateInteractionRequest = new WHHCreateInteractionRequest
                            {
                                OrganizationName = _orgName,
                                CaseId = Guid.NewGuid().ToString(),
                                CaseNumber = random2.Next(1000000, 9999999),
                                CreatedDate = DateTime.Now.Date.ToString(),
                                VIEWS_Facility__c = Convert.ToString(629),
                                SENSITIVE_WHVAHotline_Subject__c = "This is the subject",
                                WHVAHotline_Comments__c = "These are the comments",
                                OCR_Notes = "This is the OCR Notes",
                                WHVAHotline_SLA_Start_Date_Tim = DateTime.Now.Date.AddDays(-3.0).ToString(),
                                WHVAHotline_SLA_Business_Days__c = 6,
                                VIEWS_SLA_End_Date_DateTime__c = DateTime.Now.Date.AddDays(3.0).ToString(),
                                Days_Until_SLA_Overdue__c = 3,
                                VIEWS_Tier_1_Complaint_Category__c = "The complaint category",
                                VIEWS_Complaint_Category_Description__c = "The complaint category description",
                                Short_Description__c = "Other complaint type",
                                Owner = "The owner",
                                LastModifiedBy = "Last Modified By",
                                Status = "Status",
                                WHVAHotline_Priority_One_High__c = "Priority One String",
                                PriorityOne_Indicator = true,
                                WH_VA_Hotline_Reason_Priority__c = "",
                                Secondary_Phone__c = "(123) 234-3456",
                                WHHotline_Other_Location__c = "Some other facility",
                                Views_Administration__c = "Board",
                                Secondary_Email__c = "test@test.com",
                                RecordType = "non-complaint",
                                VIEWS_Other_Relationship_Informtation__c = "Other Relationship Information",
                                VIEWS_Relationship_to_Veteran_ = "Other",
                                Anonymous__c = false,
                                FirstName = firstName,
                                LastName = "Doe" + random2.Next(100, 999).ToString(),
                                Email = "test@test.test",
                                Phone = "123-123-1234",
                                Birthdate = "01/15/1977",
                                FirstName_Proxy = "Another",
                                LastName_Proxy = "Doe",
                                Phone_Proxy = "321-321-3214",
                                Email_Proxy = "thing@stuff.net",
                                SecondaryPhone_Proxy = "345-345-3456",
                                PreferredEmail_Proxy = "stuff@thing.net",
                                Internal_OCR_DueDate = "06/06/2018",
                                VISN = "629",
                                Social = "123-12-1234",
                                ICN = "1012901147V954482"
                            };

                            try
                            {
                                VeisConfig config = RetrieveVeisConfig(whhPath);
                                WHHCreateInteractionResponse wHHCreateInteractionResponse = WebApiUtility.SendReceiveVeisRequest<WHHCreateInteractionResponse>(config, "Interaction", wHHCreateInteractionRequest);

                                if (wHHCreateInteractionResponse.ExceptionOccurred)
                                {
                                    catchMethod(wHHCreateInteractionResponse.ExceptionMessage);
                                }
                                if (wHHCreateInteractionResponse != null && wHHCreateInteractionResponse.InteractionID != null)
                                {
                                    Console.WriteLine($"Created Interaction for {wHHCreateInteractionRequest.FirstName} {wHHCreateInteractionRequest.LastName}.");
                                    requests.Add(wHHCreateInteractionRequest);
                                }
                                else
                                {
                                    Console.WriteLine("record not created. Null response returned.");
                                }
                            }
                            catch (Exception ex2)
                            {
                                Console.WriteLine($"Exception Occurred: {ex2.Message}");
                            }
                        }

                        Console.WriteLine("Would you like to resolve and accept or reject this case? (1 to resolve and accept, 2 to resolve and reject, otherwise do nothing)");
                        string resp = Console.ReadLine();
                        if (resp == "1" || resp == "2")
                        {
                            foreach (WHHCreateInteractionRequest wHHCreateInteractionRequest in requests)
                            {
                                WHHResolutionRequest resReq = new WHHResolutionRequest();
                                resReq.CaseId = wHHCreateInteractionRequest.CaseId;
                                resReq.OrganizationName = _orgName;
                                resReq.AcceptanceNotes = "This is the resolution notes";
                                resReq.Acceptance = (resp == "1");
                                VeisConfig config = RetrieveVeisConfig(whhPath);
                                WHHResolutionResponse resResponse = WebApiUtility.SendReceiveVeisRequest<WHHResolutionResponse>(config, "Resolution", resReq);
                                if (resResponse.ExceptionOccurred)
                                {
                                    catchMethod(resResponse.ExceptionMessage);
                                }
                                else
                                {
                                    Console.WriteLine($"The case has been resolved.");
                                }
                            }
                        }

                        Console.WriteLine("Complete.");
                        Console.ReadLine();
                        return;
                    }
            }
            Random random3 = new Random();
            new Entity("incident");
            for (int k = 0; k < recordCount; k++)
            {
                string firstName2 = (Math.Round(random3.NextDouble()) != 0.0) ? "Jane" : "John";
                new MessageLogging
                {
                    IgnoreState = false,
                    MaxRetry = -1,
                    MessageName = "IrisCreateInteractionRequest",
                    MessageType = "TestStubMessage",
                    OrganizationName = _orgName
                };
                int num = random3.Next(1, 4);
                string text = "";
                string methodOfContactData = "";
                switch (num)
                {
                    case 1:
                        text = "Email";
                        methodOfContactData = "test@test.com";
                        break;
                    case 2:
                        text = "Phone";
                        methodOfContactData = "123-123-1234";
                        break;
                    case 3:
                        text = "US Mail";
                        methodOfContactData = "123 Main Street";
                        break;
                }
                IrisCreateInteractionRequest irisCreateInteractionRequest = new IrisCreateInteractionRequest
                {
                    organizationName = _orgName,
                    incidentNumber = "123456-" + random3.Next(100000, 999999),
                    firstName = firstName2,
                    lastName = "Doe" + random3.Next(1, 999).ToString(),
                    ssn = "666551414",
                    issueText = $"MethodOfContact: {text} (but this is actually where text about the case goes!)",
                    methodOfContact = text,
                    methodOfContactData = methodOfContactData,
                    relationToVet = "Daughter",
                    institution = "629",
                    contactDate = DateTime.Now.ToString(),
                    MessageId = Guid.NewGuid().ToString()
                };
                try
                {
                    VeisConfig config = RetrieveVeisConfig(irisPath);
                    IrisCreateInteractionResponse irisCreateInteractionResponse = WebApiUtility.SendReceiveVeisRequest<IrisCreateInteractionResponse>(config, "Interaction", irisCreateInteractionRequest);
                    if (irisCreateInteractionResponse.ExceptionOccurred)
                    {
                        catchMethod(irisCreateInteractionResponse.ExceptionMessage);
                    }
                    if (irisCreateInteractionResponse != null && irisCreateInteractionResponse.InteractionID != null)
                    {
                        Console.WriteLine($"Created Interaction for {irisCreateInteractionRequest.firstName} {irisCreateInteractionRequest.lastName}.");
                    }
                    else
                    {
                        Console.WriteLine("record not created. Null response returned.");
                    }
                }
                catch (Exception ex3)
                {
                    Console.WriteLine($"Exception Occurred: {ex3.Message}");
                }
            }
        }

        private static void catchMethod(string message)
        {
            Console.WriteLine("Unable to create record. Exception: " + message);
        }
    }
}
