﻿using System;
using System.Text;
using System.ComponentModel.Composition;
using System.Runtime.Serialization;
using VRM.Integration.Servicebus.Core;
//using VRM.Integration.Servicebus.Extensions;

namespace WHH.VEFT.Messages
{
    [Export(typeof(IMessageBase))]
    [ExportMetadata("MessageType", MessageRegistry.WHHCreateInteractionRequest)]
    [DataContract]
    public class WHHCreateInteractionRequest : MessageBase
    {
        [DataMember(IsRequired = true)]
        public string OrganizationName { get; set; }
        [DataMember(IsRequired = true)]
        public string CaseId { get; set; }
        [DataMember(IsRequired = true)]
        public int CaseNumber { get; set; }
        [DataMember]
        public string CreatedDate { get; set; }
        [DataMember(IsRequired = true)]
        public string VIEWS_Facility__c { get; set; }
        [DataMember]
        public string SENSITIVE_WHVAHotline_Subject__c { get; set; }
        [DataMember(IsRequired = true)]
        public string WHVAHotline_Comments__c { get; set; }
        [DataMember]
        public string OCR_Notes { get; set; }
        [DataMember]
        public string WHVAHotline_SLA_Start_Date_Tim { get; set; }
        [DataMember]
        public int WHVAHotline_SLA_Business_Days__c { get; set; }
        [DataMember]
        public string VIEWS_SLA_End_Date_DateTime__c { get; set; }
        [DataMember]
        public int Days_Until_SLA_Overdue__c { get; set; }
        [DataMember]
        public string VIEWS_Tier_1_Complaint_Category__c { get; set; }
        [DataMember]
        public string VIEWS_Complaint_Category_Description__c { get; set; }
        [DataMember]
        public string Short_Description__c { get; set; }
        [DataMember]
        public string Owner { get; set; }
        [DataMember]
        public string LastModifiedBy { get; set; }
        [DataMember]
        public string Status { get; set; }
        [DataMember]
        public string WHVAHotline_Priority_One_High__c { get; set; }
        [DataMember]
        public bool PriorityOne_Indicator { get; set; }
        [DataMember]
        public string WH_VA_Hotline_Reason_Priority__c { get; set; }
        [DataMember]
        public string Secondary_Phone__c { get; set; }
        [DataMember]
        public string WHHotline_Other_Location__c { get; set; }
        [DataMember]
        public string Views_Administration__c { get; set; }
        [DataMember]
        public string Secondary_Email__c { get; set; }
        [DataMember]
        public string RecordType { get; set; }
        [DataMember]
        public string VIEWS_Other_Relationship_Informtation__c { get; set; }
        [DataMember(IsRequired = true)]
        public string VIEWS_Relationship_to_Veteran_ { get; set; }
        [DataMember]
        public bool Anonymous__c { get; set; }
        [DataMember]
        public string FirstName { get; set; }
        [DataMember]
        public string LastName { get; set; }
        [DataMember]
        public string Email { get; set; }
        [DataMember]
        public string Phone { get; set; }
        [DataMember]
        public string Birthdate { get; set; }
        [DataMember]
        public string FirstName_Proxy { get; set; }
        [DataMember]
        public string LastName_Proxy { get; set; }
        [DataMember]
        public string Email_Proxy { get; set; }
        [DataMember]
        public string Phone_Proxy { get; set; }
        [DataMember]
        public string SecondaryPhone_Proxy { get; set; }
        [DataMember]
        public string PreferredEmail_Proxy { get; set; }
        [DataMember]
        public string Internal_OCR_DueDate { get; set; }
        [DataMember]
        public string VISN { get; set; }
        [DataMember]
        public string Social { get; set; }
        [DataMember]
        public string ICN { get; set; }
    }
}
