﻿using System;
using System.ComponentModel.Composition;
using VRM.Integration.Servicebus.Core;
using WHH.VEFT.Messages;
using WHH.VEFT.Processors;
//using VRM.Integration.Servicebus.Extensions;

namespace WHH.VEFT.MessageHandler
{
    [Export(typeof(IMessageHandler))]
    [ExportMetadata("MessageType", MessageRegistry.WHHResolutionRequest)]
    class WHHResolutionMessageHandler : RequestResponseHandler
    {
        public override IMessageBase HandleRequestResponse(object message)
        {
            try
            {
                LogMessageReceipt(message);
                var processor = new WHHResolutionProcessor();
                return processor.Execute((WHHResolutionRequest)message);
            }
            catch (Exception ex)
            {
                Logger.Instance.Error(ex);
                var exMessage = "";
                if (ex.Message != null)
                    exMessage = ex.Message;
                else
                    exMessage = "An exception occurred while trying to instantiate the processor in VIMT.";
                WHHResolutionResponse response = new WHHResolutionResponse()
                {
                    ExceptionOccurred = true,
                    ExceptionMessage = exMessage,
                    //FailureDetails = new System.Collections.Generic.List<FailureDetail>()
                    //{
                    //    new FailureDetail()
                    //    {
                    //        Reason = FailureReason.OtherException,
                    //        Details = exMessage
                    //    }
                    //}
                };
                return response;
                //throw new Exception(string.Format("Medallia.VEFT.MedalliaUpdateStatusStubRequest Error: {0}", ex.Message), ex);
            }
        }
    }
}
