﻿select top 40 * from dbo.[Transaction] where EndTime is not null
select top 20 * from dbo.[Message]
select top 10 * from dbo.[MessageState]
select top 10 * from dbo.[Failure]

DROP TABLE [dbo].[Message]
CREATE TABLE [dbo].[Message]
(
	[MessageId] UNIQUEIDENTIFIER NOT NULL PRIMARY KEY, 
    [EncodedString] NVARCHAR(MAX) NULL, 
    [MessageName] NVARCHAR(50) NULL, 
    [OrganizationName] NVARCHAR(50) NULL, 
    [MessageType] NVARCHAR(50) NULL, 
    [ParentMessageName] NVARCHAR(50) NULL
)

DROP TABLE [dbo].[MessageState]
CREATE TABLE [dbo].[MessageState]
(
	[MessageId] UNIQUEIDENTIFIER NOT NULL PRIMARY KEY, 
    [RetryCount] INT NOT NULL, 
    [State] NVARCHAR(50) NULL
)

DROP TABLE [dbo].[Transaction]
CREATE TABLE [dbo].[Transaction]
(
	[TransactionId] UNIQUEIDENTIFIER NOT NULL PRIMARY KEY, 
    [MessageId] UNIQUEIDENTIFIER NOT NULL,
	[StartTime] DATETIME NULL, 
	[EndTime] DATETIME NULL, 
    [Result] NVARCHAR(50) NULL
)

DROP TABLE [dbo].[Failure]
CREATE TABLE [dbo].[Failure]
(
	[FailureId] UNIQUEIDENTIFIER NOT NULL PRIMARY KEY, 
	[TransactionId] UNIQUEIDENTIFIER NOT NULL,
    [Reason] NVARCHAR(50) NULL,
	[Detail] NVARCHAR(MAX) NULL
)