using System;
using System.Linq;
using System.Runtime.CompilerServices;

namespace VRM.VEFT.Workflow.Messages
{
	public class PatientPerson
	{
		public PatientAddress Address
		{
			get;
			set;
		}

		public string BirthDate
		{
			get;
			set;
		}

		public string BranchOfService
		{
			get;
			set;
		}

		public CorrespondingIDs[] CorrespondingIdList
		{
			get;
			set;
		}

		public string DeceasedDate
		{
			get;
			set;
		}

		public string EdiPi
		{
			get;
			set;
		}

		public string FileNumber
		{
			get;
			set;
		}

		public string FullAddress
		{
			get
			{
				string empty;
				if (this.Address != null)
				{
					object[] streetAddressLine = new object[] { this.Address.StreetAddressLine, this.Address.City, this.Address.State, this.Address.PostalCode };
					empty = string.Format("{0} {1} {2} {3}", streetAddressLine);
				}
				else
				{
					empty = string.Empty;
				}
				return empty;
			}
		}

		public string FullName
		{
			get
			{
				string str;
				str = ((this.NameList == null ? true : !this.NameList.Any<Name>()) ? string.Empty : string.Format("{0} {1}", this.NameList[0].GivenName, this.NameList[0].FamilyName));
				return str;
			}
		}

		public string GenderCode
		{
			get;
			set;
		}

		public string Identifier
		{
			get;
			set;
		}

		public string IdentifierType
		{
			get;
			set;
		}

		public string IdentifyTheft
		{
			get;
			set;
		}

		public string IsDeceased
		{
			get;
			set;
		}

		public Name[] NameList
		{
			get;
			set;
		}

		public string ParticipantId
		{
			get;
			set;
		}

		public string PhoneNumber
		{
			get;
			set;
		}

		public string RecordSource
		{
			get;
			set;
		}

		public string SocialSecurityNumber
		{
			get;
			set;
		}

		public string StatusCode
		{
			get;
			set;
		}

		public string Url
		{
			get;
			set;
		}

		public string VeteranSensitivityLevel
		{
			get;
			set;
		}

		public PatientPerson()
		{
		}
	}
}