using System;
using System.Runtime.CompilerServices;

namespace VRM.VEFT.Workflow.Messages
{
	public class PersonSearchRequest
	{
		public string Address
		{
			get;
			set;
		}

		public string AssigningAuthority
		{
			get;
			set;
		}

		public string AssigningFacility
		{
			get;
			set;
		}

		public string AuthorityOid
		{
			get;
			set;
		}

		public string BirthDate
		{
			get;
			set;
		}

		public string BranchOfService
		{
			get;
			set;
		}

		public bool Debug
		{
			get;
			set;
		}

		public string Edipi
		{
			get;
			set;
		}

		public string FamilyName
		{
			get;
			set;
		}

		public string FetchMessageProcessType
		{
			get;
			set;
		}

		public string FirstName
		{
			get;
			set;
		}

		public string Gender
		{
			get;
			set;
		}

		public string IdentifierClassCode
		{
			get;
			set;
		}

		public string IdentifierType
		{
			get;
			set;
		}

		public bool IsAttended
		{
			get;
			set;
		}

		public HeaderInfo LegacyServiceHeaderInfo
		{
			get;
			set;
		}

		public bool LogSoap
		{
			get;
			set;
		}

		public bool LogTiming
		{
			get;
			set;
		}

		public string MessageId
		{
			get;
			set;
		}

		public string MiddleName
		{
			get;
			set;
		}

		public string MMN
		{
			get;
			set;
		}

		public string OrganizationName
		{
			get;
			set;
		}

		public string PatientIdentifier
		{
			get;
			set;
		}

		public string PatientSearchIdentifier
		{
			get;
			set;
		}

		public string PhoneNumber
		{
			get;
			set;
		}

		public string POBC
		{
			get;
			set;
		}

		public string POBS
		{
			get;
			set;
		}

		public string RawValueFromMvi
		{
			get;
			set;
		}

		public string RelatedParentEntityName
		{
			get;
			set;
		}

		public string RelatedParentFieldName
		{
			get;
			set;
		}

		public Guid RelatedParentId
		{
			get;
			set;
		}

		public string SearchUse
		{
			get;
			set;
		}

		public string SocialSecurityNumber
		{
			get;
			set;
		}

		public string UserFirstName
		{
			get;
			set;
		}

		public Guid UserId
		{
			get;
			set;
		}

		public string UserLastName
		{
			get;
			set;
		}

		public PersonSearchRequest()
		{
		}

		public override string ToString()
		{
			object[] patientSearchIdentifier = new object[] { this.PatientSearchIdentifier, null, null, null };
			patientSearchIdentifier[1] = (!string.IsNullOrEmpty(this.Edipi) || this.IdentifierClassCode.Equals("MIL") ? "NI" : this.IdentifierType);
			patientSearchIdentifier[2] = (!string.IsNullOrEmpty(this.Edipi) || this.IdentifierClassCode.Equals("MIL") ? "200DOD" : this.AssigningFacility);
			patientSearchIdentifier[3] = (!string.IsNullOrEmpty(this.Edipi) || this.IdentifierClassCode.Equals("MIL") ? "USDOD" : this.AssigningAuthority);
			return string.Format("{0}^{1}^{2}^{3}", patientSearchIdentifier);
		}
	}
}