using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Query;
using Microsoft.Xrm.Sdk.Workflow;
using System;
using System.Activities;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Runtime.CompilerServices;
using System.Web.Script.Serialization;
using VRM.VEFT.Workflow.Messages;
using VRM.VEFT.Workflow.Models;

namespace VRM.VEFT.Workflow
{
	public class RefreshFacilityListFromVAST : CodeActivity
	{
        /*
        [Input("DAC URL")]
        public InArgument<string> dacURLInput { get; set; }

        [Input("Facility Data Date")]
        [RequiredArgument]
        public InArgument<DateTime> FacilityDataDateInput { get; set; }

        [AttributeTarget("mcs_setting", "patsr_vastfacilityrefreshselectedendpoint")]
        [Input("API to use for facility data")]
        [RequiredArgument]
        public InArgument<OptionSetValue> FacilityEndpointToUse { get; set; }

        [Input("VAST List GIS API Base URL")]
        public InArgument<string> GISAPIBaseURLInput { get; set; }

        [Input("VAST List GIS API URL Parameters")]
        public InArgument<string> GISAPIURLParametersInput { get; set; }

        [Output("Refresh Completed Successfully")]
        public OutArgument<bool> RefreshCompletedSuccessfully { get; set; }

        [Output("Message")]
        public OutArgument<string> ResultMessage { get; set; }

        [Input("VAST List API URL")]
        public InArgument<string> VASTAPIURLInput { get; set; }

        [AttributeTarget("mcs_setting", "patsr_vastfacilitytosubfacilitymappingmethod")]
        [Input("VAST Facility to Sub Facility Mapping Method")]
        [RequiredArgument]
        public InArgument<OptionSetValue> VASTMappingMethodInput { get; set; }
        */
        public RefreshFacilityListFromVAST() {}

        protected override void Execute(CodeActivityContext executionContext)
        {
            /*
            WebClient webClient;
            string str;
            Exception exception;
            int i;
            object[] correlationId;
            ITracingService extension = executionContext.GetExtension<ITracingService>();
            IWorkflowContext workflowContext = executionContext.GetExtension<IWorkflowContext>();
            IOrganizationService organizationService = executionContext.GetExtension<IOrganizationServiceFactory>().CreateOrganizationService(new Guid?(workflowContext.UserId));
            try
            {
                OptionSetValue optionSetValue = this.FacilityEndpointToUse.Get(executionContext);
                FacilityEndpoint facilityEndpoint = (optionSetValue != null ? (FacilityEndpoint)Enum.ToObject(typeof(FacilityEndpoint), optionSetValue.Value) : FacilityEndpoint.VASTProxy);
                OptionSetValue optionSetValue1 = this.VASTMappingMethodInput.Get(executionContext);
                ParentFacilityMappingMethod parentFacilityMappingMethod = (optionSetValue1 != null ? (ParentFacilityMappingMethod)Enum.ToObject(typeof(ParentFacilityMappingMethod), optionSetValue1.Value) : ParentFacilityMappingMethod.UseParentStationIDFieldFromVAST);
                DateTime dateTime = this.FacilityDataDateInput.Get(executionContext);
                int month = dateTime.Month;
                string str1 = month.ToString();
                month = dateTime.Day;
                string str2 = month.ToString();
                month = dateTime.Year;
                string str3 = string.Format("{0}-{1}-{2}", str1, str2, month.ToString());
                VASTRefreshResponse vASTRefreshResponse = new VASTRefreshResponse();
                if (facilityEndpoint != FacilityEndpoint.VASTProxy)
                {
                    string str4 = this.GISAPIBaseURLInput.Get(executionContext);
                    string str5 = this.GISAPIURLParametersInput.Get(executionContext);
                    if ((string.IsNullOrEmpty(str4) ? true : string.IsNullOrEmpty(str5)))
                    {
                        throw new InvalidPluginExecutionException("You must provide a value for 'VAST List GIS API Base URL' and 'VAST List GIS API URL Parameters' in order to query facility data directly from the GIS endpoint.");
                    }
                    string str6 = string.Concat(str4, str3, str5);
                    GISResponse gISResponse = new GISResponse();
                    webClient = new WebClient();
                    try
                    {
                        try
                        {
                            extension.Trace("querying VAST GIS API", new object[0]);
                            str = webClient.DownloadString(str6);
                            gISResponse = (new JavaScriptSerializer()).Deserialize<GISResponse>(str);
                        }
                        catch (Exception exception1)
                        {
                            exception = exception1;
                            extension.Trace("error querying VAST GIS API", new object[0]);
                            throw new InvalidPluginExecutionException(string.Concat("error querying VAST GIS API: ", exception.Message));
                        }
                    }
                    finally
                    {
                        if (webClient != null)
                        {
                            ((IDisposable)webClient).Dispose();
                        }
                    }
                    List<VASTStation> vASTStations = new List<VASTStation>();
                    GISStation[] gISStationArray = gISResponse.features;
                    for (i = 0; i < (int)gISStationArray.Length; i++)
                    {
                        vASTStations.Add(new VASTStation(gISStationArray[i]));
                    }
                    DataMember[] dataMemberArray = new DataMember[1];
                    DataMember dataMember = new DataMember()
                    {
                        vistaList = vASTStations.ToArray()
                    };
                    dataMemberArray[0] = dataMember;
                    vASTRefreshResponse.Data = dataMemberArray;
                }
                else
                {
                    string str7 = this.dacURLInput.Get(executionContext);
                    string str8 = this.VASTAPIURLInput.Get(executionContext);
                    if ((string.IsNullOrEmpty(str7) ? true : string.IsNullOrEmpty(str8)))
                    {
                        throw new Exception("You must provide a value for 'DAC URL' and 'VAST List API URL' in order to query facility data from the VAST Proxy.");
                    }
                    string str9 = string.Concat(str7, str8, str3);
                    webClient = new WebClient();
                    try
                    {
                        try
                        {
                            extension.Trace("querying VAST Refresh API", new object[0]);
                            str = webClient.DownloadString(str9);
                            vASTRefreshResponse = (new JavaScriptSerializer()).Deserialize<VASTRefreshResponse>(str);
                        }
                        catch (Exception exception2)
                        {
                            exception = exception2;
                            extension.Trace("error querying VAST Refresh API", new object[0]);
                            throw new InvalidPluginExecutionException(string.Concat("Error querying VAST Refresh API: ", exception.Message));
                        }
                    }
                    finally
                    {
                        if (webClient != null)
                        {
                            ((IDisposable)webClient).Dispose();
                        }
                    }
                    if (vASTRefreshResponse.ErrorOccurred)
                    {
                        throw new InvalidPluginExecutionException((string.IsNullOrEmpty((string)vASTRefreshResponse.ErrorMessage) ? "Unspecified error." : (string)vASTRefreshResponse.ErrorMessage));
                    }
                }
                if ((int)vASTRefreshResponse.Data.Length != 1)
                {
                    throw new InvalidPluginExecutionException("Unhandled response content: multiple Data[] members.");
                }
                DataMember data = vASTRefreshResponse.Data[0];
                if ((int)data.vistaList.Length > 0)
                {
                    VASTStation[] vASTStationArray = data.vistaList;
                    for (i = 0; i < (int)vASTStationArray.Length; i++)
                    {
                        vASTStationArray[i].MassageVASTStation(data.vistaList, parentFacilityMappingMethod);
                    }
                    extension.Trace("staring VISNs...", new object[0]);
                    QueryExpression queryExpression = new QueryExpression();
                    queryExpression.EntityName = "veo_visn";
                    queryExpression.ColumnSet = new ColumnSet(new string[] { "name" });
                    queryExpression.Criteria.Conditions.Add(new ConditionExpression("statecode", 0, "Active"));
                    queryExpression.Orders.Add(new OrderExpression("modifiedon", OrderType.Ascending));
                    EntityCollection entityCollection = organizationService.RetrieveMultiple(queryExpression);
                    extension.Trace("got active ftp_visn records", new object[0]);
                    Dictionary<string, Entity> strs = new Dictionary<string, Entity>();
                    vASTStationArray = data.vistaList;
                    for (i = 0; i < (int)vASTStationArray.Length; i++)
                    {
                        VASTStation vASTStation = vASTStationArray[i];
                        if (strs.FirstOrDefault<KeyValuePair<string, Entity>>((KeyValuePair<string, Entity> entry) => entry.Key == vASTStation.VisnID).Key == null)
                        {
                            extension.Trace(string.Concat("VISN from VAST: ", vASTStation.VisnID), new object[0]);
                            Entity entity = entityCollection.Entities.FirstOrDefault<Entity>((Entity v) => (!v.Contains("name") ? false : (string)v.GetAttributeValue<string>("name") == vASTStation.VisnID));
                            if (entity != null)
                            {
                                strs.Add(vASTStation.VisnID, entity);
                            }
                            else
                            {
                                extension.Trace(string.Concat("creating new ftp_visn record: ", vASTStation.VisnID), new object[0]);
                                Entity entity1 = new Entity("veo_visn");
                                entity1.Attributes.Add("name", vASTStation.VisnID);
                                try
                                {
                                    entity1.Id = organizationService.Create(entity1);
                                }
                                catch (Exception exception3)
                                {
                                    exception = exception3;
                                    extension.Trace(string.Concat("error creating new ftp_visn record: ", vASTStation.VisnID), new object[0]);
                                    throw new InvalidPluginExecutionException(string.Concat("error creating new ftp_visn record: ", exception.Message));
                                }
                                strs.Add(vASTStation.VisnID, entity1);
                            }
                        }
                    }
                    extension.Trace("filled VISNDictionary.", new object[0]);
                    extension.Trace("starting top-level facilities (ftp_facility entity)", new object[0]);
                    QueryExpression queryExpression1 = new QueryExpression();
                    queryExpression1.EntityName = Facility.CrmEntityName;
                    queryExpression1.ColumnSet = Facility.CrmColumns;
                    queryExpression1.Criteria.Conditions.Add(new ConditionExpression("statecode", 0, "Active"));
                    queryExpression1.Orders.Add(new OrderExpression(Facility.StationNumberFieldName, 0));
                    queryExpression1.Orders.Add(new OrderExpression("modifiedon", OrderType.Ascending));
                    EntityCollection entityCollection1 = organizationService.RetrieveMultiple(queryExpression1);
                    extension.Trace("got active ftp_facility records.", new object[0]);
                    Dictionary<VASTStation, Entity> vASTStations1 = new Dictionary<VASTStation, Entity>();
                    vASTStationArray = data.vistaList;
                    for (i = 0; i < (int)vASTStationArray.Length; i++)
                    {
                        VASTStation vASTStation1 = vASTStationArray[i];
                        if (vASTStation1.IsATopLevelStation)
                        {
                            Facility facility = new Facility(vASTStation1);
                            extension.Trace(string.Concat("top-level facility from VAST: ", facility.CRMDisplayname), new object[0]);
                            Entity entity2 = entityCollection1.Entities.FirstOrDefault<Entity>((Entity f) => (!f.Contains(Facility.StationIDFieldName) ? false : (string)f.GetAttributeValue<string>(Facility.StationIDFieldName) == vASTStation1.StationID));
                            if (entity2 == null)
                            {
                                entity2 = entityCollection1.Entities.FirstOrDefault<Entity>((Entity f) => (!f.Contains(Facility.StationNumberFieldName) ? false : (string)f.GetAttributeValue<string>(Facility.StationNumberFieldName) == vASTStation1.StationNumber));
                            }
                            if (entity2 == null)
                            {
                                extension.Trace(string.Concat("creating new ftp_facility record: ", facility.CRMDisplayname), new object[0]);
                                Entity cRMRecord = facility.MapToCRMRecord(Guid.Empty, strs);
                                try
                                {
                                    cRMRecord.Id = organizationService.Create(cRMRecord);
                                    vASTStations1.Add(vASTStation1, cRMRecord);
                                }
                                catch (Exception exception4)
                                {
                                    exception = exception4;
                                    extension.Trace("error creating new ftp_facility record.", new object[0]);
                                    throw new InvalidPluginExecutionException(string.Concat("error creating new ftp_facility record: ", exception.Message));
                                }
                            }
                            else if (facility.MatchesCRMRecord(entity2))
                            {
                                vASTStations1.Add(vASTStation1, entity2);
                            }
                            else
                            {
                                extension.Trace(string.Concat("updating ftp_facility record: ", facility.CRMDisplayname), new object[0]);
                                Entity cRMRecord1 = facility.MapToCRMRecord(entity2.Id, strs);
                                try
                                {
                                    organizationService.Update(cRMRecord1);
                                    vASTStations1.Add(vASTStation1, cRMRecord1);
                                }
                                catch (Exception exception5)
                                {
                                    exception = exception5;
                                    extension.Trace("error updating ftp_facility record.", new object[0]);
                                    throw new InvalidPluginExecutionException(string.Concat("error updating ftp_facility record: ", exception.Message));
                                }
                            }
                        }
                    }
                    extension.Trace("finished creating/updating ftp_facility records from vastResponse.Data[0].vistaList.", new object[0]);
                    extension.Trace("filled ParentFacilityDictionary.", new object[0]);
                    extension.Trace("starting full facilities list (ftp_subfacility entity)...", new object[0]);
                    QueryExpression queryExpression2 = new QueryExpression();
                    queryExpression2.EntityName = SubFacility.CrmEntityName;
                    queryExpression2.ColumnSet = SubFacility.CrmColumns;
                    queryExpression2.Criteria.Conditions.Add(new ConditionExpression("statecode", 0, "Active"));
                    queryExpression2.Orders.Add(new OrderExpression(SubFacility.StationNumberFieldName, 0));
                    queryExpression2.Orders.Add(new OrderExpression("modifiedon", OrderType.Ascending));
                    EntityCollection entityCollection2 = organizationService.RetrieveMultiple(queryExpression2);
                    extension.Trace("got active ftp_subfacility records.", new object[0]);
                    vASTStationArray = data.vistaList;
                    for (i = 0; i < (int)vASTStationArray.Length; i++)
                    {
                        VASTStation vASTStation2 = vASTStationArray[i];
                        SubFacility subFacility = new SubFacility(vASTStation2, vASTStations1);
                        extension.Trace(string.Concat("facility from VAST: ", subFacility.CRMDisplayname), new object[0]);
                        Entity entity3 = entityCollection2.Entities.FirstOrDefault<Entity>((Entity sf) => (!sf.Contains(SubFacility.StationIDFieldName) ? false : (string)sf.GetAttributeValue<string>(SubFacility.StationIDFieldName) == vASTStation2.StationID));
                        if (entity3 == null)
                        {
                            entity3 = entityCollection2.Entities.FirstOrDefault<Entity>((Entity sf) => (!sf.Contains(SubFacility.StationNumberFieldName) ? false : (string)sf.GetAttributeValue<string>(SubFacility.StationNumberFieldName) == vASTStation2.StationNumber));
                        }
                        if (entity3 == null)
                        {
                            extension.Trace(string.Concat("creating new ftp_subfacility record: ", subFacility.CRMDisplayname), new object[0]);
                            Entity cRMRecord2 = subFacility.MapToCRMRecord(Guid.Empty, vASTStations1);
                            try
                            {
                                cRMRecord2.Id = organizationService.Create(cRMRecord2);
                            }
                            catch (Exception exception6)
                            {
                                exception = exception6;
                                extension.Trace("error creating new ftp_subfacility record.", new object[0]);
                                throw new InvalidPluginExecutionException(string.Concat("error creating new ftp_subfacility record: ", exception.Message));
                            }
                        }
                        else if (!subFacility.MatchesCRMRecord(entity3))
                        {
                            extension.Trace(string.Concat("updating ftp_subfacility record: ", subFacility.CRMDisplayname), new object[0]);
                            try
                            {
                                organizationService.Update(subFacility.MapToCRMRecord(entity3.Id, vASTStations1));
                            }
                            catch (Exception exception7)
                            {
                                exception = exception7;
                                extension.Trace("error updating ftp_subfacility record.", new object[0]);
                                throw new InvalidPluginExecutionException(string.Concat("error updating ftp_subfacility record: ", exception.Message));
                            }
                        }
                    }
                    this.RefreshCompletedSuccessfully.Set(executionContext, true);
                    this.ResultMessage.Set(executionContext, "finished creating/updating ftp_subfacility records.");
                    extension.Trace("finished creating/updating ftp_subfacility records.", new object[0]);
                }
            }
            catch (Exception exception8)
            {
                exception = exception8;
                this.RefreshCompletedSuccessfully.Set(executionContext, false);
                correlationId = new object[] { exception.ToString() };
                extension.Trace("Exception: {0}", correlationId);
                this.ResultMessage.Set(executionContext, exception.ToString());
                throw;
            }
            correlationId = new object[] { workflowContext.CorrelationId };
            extension.Trace("Exiting RefreshFacilityListFromVAST.Execute(), Correlation Id: {0}", correlationId);
            */
        }
 
    } 
}